//---------------------------------------------------------------------------
//
//  FILE NAME:          SCSLog.cc
//
//  DEVELOPMENT:        CXCDS, User Infrastructure
//
//  DESCRIPTION:
//
//
//---------------------------------------------------------------------------
// Copyright (c) 2006, Smithsonian Astrophysical Observatory
//---------------------------------------------------------------------------

#include <fstream>
#include <sstream>
#include <sys/types.h>
#include <unistd.h>
#include <iostream>
#include <string.h>
#include <stdlib.h>

#include "SCSLog.hh"

using namespace std;

string SCSLog::logFileName;



void SCSLog::Write(const string& inString,int inLogLevel)
{

  
  int loggingLevel;
  char* tmpDebugStr=getenv("SCSDEBUG");
  if ( tmpDebugStr)
    {
      loggingLevel=atoi(tmpDebugStr);
    }
  else
    loggingLevel=0;

  if ( inLogLevel <= loggingLevel)
    {
      ofstream logStream;
      if ( !logFileName.empty())
	{
	  logStream.open(logFileName.c_str(),fstream::out | fstream::app);
	  if (!logStream)
	    {
	      cerr<<"ERROR : can not open log file '"<<logFileName<<"' for writing"<<endl;
	      return;
	    }
	  
	}
      else
	{
	  ostringstream tmpStr;
	  tmpStr<<"/tmp/SCSLog."<<getpid();
	  logStream.open(tmpStr.str().c_str(),fstream::out | fstream::app);
	  
	  if (!logStream)
	    {
	      cerr<<"ERROR : can not open log file '"<<tmpStr.str()<<"' for writing"<<endl;
	      return;
	    };
	  
	};

      logStream<<inString<<endl;
      logStream.flush();
      logStream.close();

    };
};

void SCSLog::Write(const string & inString,int inSysErrNo,int inLogLevel)
{
  char* tmpStr=strerror(inSysErrNo);
  Write(inString+": "+tmpStr,inLogLevel);
};
