#! /bin/sh

TESTID=chips-smoke003
export TESTID

#
# Replace with variable via configure
#
ASCDS_QUIET=1; export ASCDS_QUIET
ASCDS_OVERRIDE=1; export ASCDS_OVERRIDE
locale -a | grep -i "en_US" > /dev/null
if test $? = 0; then
   LANG="en_US.UTF-8"; export LANG
fi
. setup.sh

#
# Setup test env
#
TESTDIR=$ASCDS_INSTALL/test/smoke/data; export TESTDIR
if [ "$ASCDS_SMOKE_DIR" = "" ]; then
   OUTDIR=$ASCDS_WORK_PATH/smoke.${LOGNAME}/$TESTID; export OUTDIR
else
   OUTDIR=$ASCDS_SMOKE_DIR/smoke.${LOGNAME}/$TESTID; export OUTDIR
fi
SAVEDIR=$TESTDIR/; export SAVEDIR

INDIR=$TESTDIR
MYSCRIPT=${OUTDIR}/${TESTID}.py
OUTFILE=${OUTDIR}/${TESTID}.txt

if test -d $OUTDIR
then
   \rm -rf $OUTDIR
fi
mkdir -p $OUTDIR


#
# Run command
#
echo " CHIPS3 SMOKE TEST LOG " > $OUTFILE
echo "" >> $OUTFILE
printf "Running test $TESTID "

# set up test script to run
echo "from pychips import *"                         >  $MYSCRIPT 
echo "load_state('${INDIR}/chips-state.solaris')"    >> $MYSCRIPT
echo "print(info())"                                 >> $MYSCRIPT
echo "clear()"                                       >> $MYSCRIPT
echo "load_state('${INDIR}/chips-state.osx')"        >> $MYSCRIPT
echo "print(info())"                                 >> $MYSCRIPT
echo "clear()"                                       >> $MYSCRIPT
echo "load_state('${INDIR}/chips-state.linux')"      >> $MYSCRIPT
echo "print(info())"                                 >> $MYSCRIPT

printf "."

python ${MYSCRIPT} | grep -v "missing on display" >> ${OUTFILE}  2>&1

printf "."

#
# Run checks on the output files.
#
state=0
diff "$OUTFILE" "$SAVEDIR/${TESTID}.txt" 2>&1 >> $OUTDIR/diff.log
if test $? != 0
then
   state=1
fi

#
# Exit condition
#
printf ". "
if test $state = 0
then
  echo "PASS"

  if echo "$OUTDIR" | grep "$TESTID" >/dev/null
  then
     rm $OUTDIR/${TESTID}.*
     rm $OUTDIR/diff.log
     rmdir $OUTDIR
  fi
else
  echo "FAIL"
fi

exit $state
