#! /bin/sh

TESTID=chips-smoke004
export TESTID

#
# Replace with variable via configure
#
ASCDS_QUIET=1; export ASCDS_QUIET
ASCDS_OVERRIDE=1; export ASCDS_OVERRIDE
locale -a | grep -i "en_US" > /dev/null
if test $? = 0; then
   LANG="en_US.UTF-8"; export LANG
fi
. setup.sh

#
# Setup test env
#
TESTDIR=$ASCDS_INSTALL/test/smoke/data; export TESTDIR
if [ "$ASCDS_SMOKE_DIR" = "" ]; then
   OUTDIR=$ASCDS_WORK_PATH/smoke.${LOGNAME}/$TESTID; export OUTDIR
else
   OUTDIR=$ASCDS_SMOKE_DIR/smoke.${LOGNAME}/$TESTID; export OUTDIR
fi
SAVEDIR=$TESTDIR/; export SAVEDIR

INDIR=$TESTDIR
MYSCRIPT=${OUTDIR}/${TESTID}.py
OUTFILE=${OUTDIR}/${TESTID}.txt

if test -d $OUTDIR
then
   \rm -rf $OUTDIR
fi
mkdir -p $OUTDIR

#
# Run command
#
###echo "Running test $TESTID -  undo/redo"
echo " CHIPS4 SMOKE TEST LOG " > $OUTFILE
echo "" >> $OUTFILE
printf "Running test $TESTID "
printf "."
#
# set up test script to run
echo "from pychips.all import *" > $MYSCRIPT
echo "from pychips import pychips_base"                         >>  $MYSCRIPT 
echo "add_curve([1,3,4,6,8,10,18,23,24,39,41,46,47,53,62,67,69,71,77,88,89,93,95,97,99],[41,43,45,44,46,36,41,44,45,48,51,50,49,48,42,38,41,43,47,50,51,52,53,55,58])">> $MYSCRIPT

echo "limits(XY_AXIS,0,100)" >> $MYSCRIPT
echo "print(pychips_base.v_symbol_to_string(get_curve_symbolstyle()))" >> $MYSCRIPT
echo "set_curve_symbolstyle(chips_arrow)" >> $MYSCRIPT
echo "print(pychips_base.v_symbol_to_string(get_curve_symbolstyle()))" >> $MYSCRIPT
echo "set_curve_symbolstyle(chips_downtriangle)" >> $MYSCRIPT
echo "print(pychips_base.v_symbol_to_string(get_curve_symbolstyle()))" >> $MYSCRIPT
echo "set_curve_symbolstyle(chips_plus)" >> $MYSCRIPT
echo "print(pychips_base.v_symbol_to_string(get_curve_symbolstyle()))" >> $MYSCRIPT
echo "set_curve_symbolstyle(chips_square)" >> $MYSCRIPT
echo "print(pychips_base.v_symbol_to_string(get_curve_symbolstyle()))" >> $MYSCRIPT
echo "set_curve_symbolstyle(chips_none)" >> $MYSCRIPT
echo "print(pychips_base.v_symbol_to_string(get_curve_symbolstyle()))" >> $MYSCRIPT
echo "set_curve_symbolstyle(chips_uptriangle)" >> $MYSCRIPT
echo "print(pychips_base.v_symbol_to_string(get_curve_symbolstyle()))" >> $MYSCRIPT
echo "undo()" >> $MYSCRIPT
echo "print(pychips_base.v_symbol_to_string(get_curve_symbolstyle()))" >> $MYSCRIPT
echo "undo()" >> $MYSCRIPT
echo "print(pychips_base.v_symbol_to_string(get_curve_symbolstyle()))" >> $MYSCRIPT
echo "undo()" >> $MYSCRIPT
echo "print(pychips_base.v_symbol_to_string(get_curve_symbolstyle()))" >> $MYSCRIPT
echo "undo(3)" >> $MYSCRIPT
echo "print(pychips_base.v_symbol_to_string(get_curve_symbolstyle()))" >> $MYSCRIPT
echo "set_curve_linecolor('plum')" >> $MYSCRIPT
echo "print(get_curve_linecolor())" >> $MYSCRIPT
echo "set_curve_linecolor('skyblue')" >> $MYSCRIPT
echo "print(get_curve_linecolor())" >> $MYSCRIPT
echo "set_curve_linecolor('lime')" >> $MYSCRIPT
echo "print(get_curve_linecolor())" >> $MYSCRIPT
echo "set_curve_linecolor('coral')" >> $MYSCRIPT
echo "print(get_curve_linecolor())" >> $MYSCRIPT
echo "undo(3)" >> $MYSCRIPT
echo "print(get_curve_linecolor())" >> $MYSCRIPT
echo "redo(1)" >> $MYSCRIPT
echo "print(get_curve_linecolor())" >> $MYSCRIPT
echo "print(info())" >> $MYSCRIPT
echo "add_label(20,30,'A')" >> $MYSCRIPT
echo "add_label(40,34,'B')" >> $MYSCRIPT
echo "add_label(60,28,'C')" >> $MYSCRIPT
echo "add_label(80,35,'D')" >> $MYSCRIPT
echo "print(info())" >> $MYSCRIPT
echo "undo(4)" >> $MYSCRIPT
echo "print(info())" >> $MYSCRIPT
echo "redo(2)" >> $MYSCRIPT
echo "print(info())" >> $MYSCRIPT
echo "redo()" >> $MYSCRIPT
echo "redo()" >> $MYSCRIPT
echo "print(info())" >> $MYSCRIPT
echo "print(get_axis_scale('ax1'))" >> $MYSCRIPT
echo "log_scale(X_AXIS)" >> $MYSCRIPT
echo "print(get_axis_scale('ax1'))" >> $MYSCRIPT
echo "undo()" >> $MYSCRIPT
echo "print(get_axis_scale('ax1'))" >> $MYSCRIPT
echo "delete_frame()" >> $MYSCRIPT
echo "print(info())" >> $MYSCRIPT
echo "undo()" >> $MYSCRIPT
echo "print(info())" >> $MYSCRIPT

python ${MYSCRIPT} | grep -v "missing on display" >> ${OUTFILE}  2>&1

printf "."
#
# Run checks on the output files.
#
state=0
diff "$OUTFILE" "$SAVEDIR/${TESTID}.txt" 2>&1 >> $OUTDIR/diff.log
if test $? != 0
then
   state=1
fi

#
# Exit condition
#
printf ". "
if test $state = 0
then
  echo "PASS"

  if echo "$OUTDIR" | grep "$TESTID" >/dev/null
  then
     rm $OUTDIR/${TESTID}.*
     rm $OUTDIR/diff.log
     rmdir $OUTDIR
  fi
else
  echo "FAIL"
fi

exit $state
