// 
//  Copyright (C) 2009  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSADJUSTRELSIZECOMMAND_HH
#define CHIPSADJUSTRELSIZECOMMAND_HH

#include "ChipsCommand.hh"
#include <string>

class ChipsStateStream;

class ChipsAdjustRelsizeCommand : public ChipsCommand
{
   public:
      ChipsAdjustRelsizeCommand(ChipsObject *new_co, int cnt, int dimension,
         float* ovals, float osum);
      ChipsAdjustRelsizeCommand(ChipsObject* cob, ChipsStateStream& in);
      void store_new_values(int cnt, float* arr, float sum);
      virtual ~ChipsAdjustRelsizeCommand();
      virtual int execute();
      virtual int unexecute();
      virtual int clear() {return ERR_STATUS_GOOD;};
      virtual void print();
      virtual void serialize(ChipsStateStream& out);
      virtual void deserialize(ChipsStateStream& in);
   protected:
      int     ocount;
      int     ncount;
      int     dimn; 
      float   orelsum; 
      float   nrelsum; 
      float*  oldv;
      float*  newv;
};

#endif

