// 
//  Copyright (C) 2004,2005,2007  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSANNOTATION_HH
#define CHIPSANNOTATION_HH

#include <string>
#include <iostream>
#include <stdio.h>
#include "ChipsObject.hh"
#include "ChipsDefaults.hh"
#include "ChipsColor.hh"

using namespace std;


class ChipsAnnotation: public ChipsObject
{
  public:

   ChipsAnnotation(ChipsObject* par, string val);
   ChipsAnnotation(const ChipsAnnotation &ca);
   virtual ~ChipsAnnotation();

   float      get_angle()    { return angle; }
   int        set_angle(float val);
   string     get_color()    { return color.get_name(); }
   void       get_rgb_color(double& r, double& g, double& b)
                 { r=color.red(); g=color.green(); b=color.blue(); };

   virtual int set_color(string in_color); 

   virtual int change_color();
   virtual int change_rotation(); 

  protected:

   float      angle;         // angle or rotation
   ChipsColor color;         // color of annotation
   bool       initialized;   // have we initialized everything
};


#endif 
