// 
//  Copyright (C) 2009  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSAXISALGORITHMFACTORY_HH
#define CHIPSAXISALGORITHMFACTORY_HH

#include "ChipsAxisAlgorithm.hh"

class ChipsAxis;
class Transform;

// Create a class for handling the algorithms
class ChipsAxisAlgorithmFactory
{
   public:

      enum TransformType {UNKNOWN, CARTESIAN, WCSTAN};

      ChipsAxisAlgorithmFactory () {};
      ~ChipsAxisAlgorithmFactory () {};

      static ChipsAxisAlgorithm *create (int type, int orientation, ChipsAxis *axis, ChipsAxisAlgorithm *copy = NULL);

      static TransformType get_type (ChipsAxisAlgorithm *alg);
      static TransformType get_algorithm_type (Transform *transform);
      static bool check_transform_compatibility (Transform *transform, ChipsAxisAlgorithm *axis_alg);

};

#endif
