// 
//  Copyright (C) 2007  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSAXISTICKCOMMAND_HH
#define CHIPSAXISTICKCOMMAND_HH

#include "ChipsCommand.hh"

class ChipsStateStream;
class ChipsAxis;

class ChipsAxisTickCommand : public ChipsCommand
{
   public:
      ChipsAxisTickCommand(ChipsAxis* obj, int ocnt, double *ovals,
         string* olabs, int ncnt, double *nvals, string* nlabs);
      ChipsAxisTickCommand(ChipsObject* cob, ChipsStateStream& in);
      virtual ~ChipsAxisTickCommand();
      virtual int execute();
      virtual int unexecute();
      virtual int clear() {return ERR_STATUS_GOOD;};
      virtual void print();
      virtual void serialize(ChipsStateStream& out);
      virtual void deserialize(ChipsStateStream& in);
   protected:
      int           o_cnt;
      int           n_cnt;
      double*       o_vals;
      double*       n_vals;
      string*       o_labs;
      string*       n_labs;
};

#endif

