// 
//  Copyright (C) 2005,2007  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSCOLOR_HH
#define CHIPSCOLOR_HH

#include <string>
#include <iostream>
#include <stdio.h>
#include "ChipsDefines.hh"

using namespace std;


class ChipsColor 
{
  public:

   ChipsColor();
   ChipsColor(string val);
   virtual ~ChipsColor(); 

   string     get_name()     { return  name;     }
   float      red()          { return *red_p;    } 
   float      green()        { return *green_p;  } 
   float      blue()         { return *blue_p;   } 
   string     get_color()    { return name;      } 
   string     get_foreground_color()    { return fg_name;  } 
   string     get_background_color()    { return bg_name;  } 

   int        valid_color(string val); 

   int        set_background_color(string val); 
   int        set_foreground_color(string val); 
   int        set_color(string val); 

   int        set_default_background(string val); 
   int        set_default_foreground(string val); 

  private:
   int        strcmp_cis(const char *aa, const char *bb);
   int        hexchar2int(char inchar);
   int        get_color_components(string val, float& comp_r, 
                                   float& comp_g, float& comp_b);

   string     name;
   float*     red_p;
   float*     green_p;
   float*     blue_p; 

   // specific color components 
   float      my_red;
   float      my_green;
   float      my_blue;

   // default background components 
   static string  bg_name; 
   static float   bg_red; 
   static float   bg_green; 
   static float   bg_blue; 

   // default foreground color components 
   static string  fg_name; 
   static float   fg_red; 
   static float   fg_green; 
   static float   fg_blue; 
};


#endif 
