// 
//  Copyright (C) 2009,2013  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#include "ChipsColorMapTable.hh"
#include "ChipsErrs.hh"
#include "ChipsCmdManager.hh"

#include <fstream>
#include <sstream>

#include <iostream>

extern ChipsCmdManager* cmd_manager;

ChipsColorMapTable::ChipsColorMapTable ()
{
   this->ref_count = 0;

   // initialize the user defined table 1
   userdefined1.table_size = 27;
   userdefined1.table = new double *[27];
   for (int ii=0; ii<27; ii++)
   {
      userdefined1.table[ii] = new double[4];
      userdefined1.table[ii][3] = 1;
   }
 
   userdefined1.table[0][0] = 0; userdefined1.table[0][1] = 0; userdefined1.table[0][2] = 0;
   userdefined1.table[1][0] = 0.225803; userdefined1.table[1][1] = 0; userdefined1.table[1][2] = 0.2580606;
   userdefined1.table[2][0] = 0.3225757; userdefined1.table[2][1] = 0; userdefined1.table[2][2] = 0.3870909;
   userdefined1.table[3][0] = 0.451606; userdefined1.table[3][1] = 0; userdefined1.table[3][2] = 0.5161211;
   userdefined1.table[4][0] = 0.5483787; userdefined1.table[4][1] = 0; userdefined1.table[4][2] = 0.6128939;
   userdefined1.table[5][0] = 0.677409; userdefined1.table[5][1] = 0; userdefined1.table[5][2] = 0.7419242;
   userdefined1.table[6][0] = 0.8064393; userdefined1.table[6][1] = 0; userdefined1.table[6][2] = 0.8709545;
   userdefined1.table[7][0] = 0.903212; userdefined1.table[7][1] = 0; userdefined1.table[7][2] = 1;
   userdefined1.table[8][0] = 0.8064393; userdefined1.table[8][1] = 0.1290303; userdefined1.table[8][2] = 1;
   userdefined1.table[9][0] = 0.677409; userdefined1.table[9][1] = 0.2580606; userdefined1.table[9][2] = 1;
   userdefined1.table[10][0] = 0.5483787; userdefined1.table[10][1] = 0.3870909; userdefined1.table[10][2] = 1;
   userdefined1.table[11][0] = 0.451606; userdefined1.table[11][1] = 0.5161211; userdefined1.table[11][2] = 1;
   userdefined1.table[12][0] = 0.3225757; userdefined1.table[12][1] = 0.6128939; userdefined1.table[12][2] = 1;
   userdefined1.table[13][0] = 0.225803; userdefined1.table[13][1] = 0.7419242; userdefined1.table[13][2] = 1;
   userdefined1.table[14][0] = 9.6772715E-2; userdefined1.table[14][1] = 0.8709545; userdefined1.table[14][2] = 1;
   userdefined1.table[15][0] = 0; userdefined1.table[15][1] = 1; userdefined1.table[15][2] = 1;
   userdefined1.table[16][0] = 0.1290303; userdefined1.table[16][1] = 1; userdefined1.table[16][2] = 0.8709545;
   userdefined1.table[17][0] = 0.2580606; userdefined1.table[17][1] = 1; userdefined1.table[17][2] = 0.7419242;
   userdefined1.table[18][0] = 0.3870909; userdefined1.table[18][1] = 1; userdefined1.table[18][2] = 0.6128939;
   userdefined1.table[19][0] = 0.5161211; userdefined1.table[19][1] = 1; userdefined1.table[19][2] = 0.5161211;
   userdefined1.table[20][0] = 0.6128939; userdefined1.table[20][1] = 1; userdefined1.table[20][2] = 0.3870909;
   userdefined1.table[21][0] = 0.7419242; userdefined1.table[21][1] = 1; userdefined1.table[21][2] = 0.2580606;
   userdefined1.table[22][0] = 0.8709545; userdefined1.table[22][1] = 1; userdefined1.table[22][2] = 0.1290303;
   userdefined1.table[23][0] = 1; userdefined1.table[23][1] = 1; userdefined1.table[23][2] = 0;
   userdefined1.table[24][0] = 1; userdefined1.table[24][1] = 1; userdefined1.table[24][2] = 0.3;
   userdefined1.table[25][0] = 1; userdefined1.table[25][1] = 1; userdefined1.table[25][2] = 0.7;
   userdefined1.table[26][0] = 1; userdefined1.table[26][1] = 1; userdefined1.table[26][2] = 1;

   // initialize the user defined table 2
   userdefined2.table_size = 8;
   userdefined2.table = new double *[8];
   for (int ii=0; ii<8; ii++)
   {
      userdefined2.table[ii] = new double[4];
      userdefined2.table[ii][3] = 1;
   }

   userdefined2.table[0][0] = 0.0; userdefined2.table[0][1] = 0.0; userdefined2.table[0][2] = 0.0;
   userdefined2.table[1][0] = 0.0; userdefined2.table[1][1] = 0.4; userdefined2.table[1][2] = 0.4;
   userdefined2.table[2][0] = 0.0; userdefined2.table[2][1] = 0.5; userdefined2.table[2][2] = 0.5;
   userdefined2.table[3][0] = 0.0; userdefined2.table[3][1] = 0.6; userdefined2.table[3][2] = 0.6;
   userdefined2.table[4][0] = 0.0; userdefined2.table[4][1] = 0.8; userdefined2.table[4][2] = 0.8;
   userdefined2.table[5][0] = 0.0; userdefined2.table[5][1] = 0.9; userdefined2.table[5][2] = 0.9;
   userdefined2.table[6][0] = 0.0; userdefined2.table[6][1] = 1.0; userdefined2.table[6][2] = 1.0;
   userdefined2.table[7][0] = 1.0; userdefined2.table[7][1] = 1.0; userdefined2.table[7][2] = 1.0;


   // initialize the user defined table 3
   userdefined3.table_size = 64;
   userdefined3.table = new double *[64];
   for (int ii=0; ii<64; ii++)
   {
      userdefined3.table[ii] = new double[4];
      userdefined3.table[ii][3] = 1;
   }

   userdefined3.table[0][0] = 0.0; userdefined3.table[0][1] = 0.0; userdefined3.table[0][2] = 0.0;
   userdefined3.table[1][0] = 0.33; userdefined3.table[1][1] = 0.0; userdefined3.table[1][2] = 0.0;
   userdefined3.table[2][0] = 0.67; userdefined3.table[2][1] = 0.0; userdefined3.table[2][2] = 0.0;
   userdefined3.table[3][0] = 1.0; userdefined3.table[3][1] = 0.0; userdefined3.table[3][2] = 0.0;
   userdefined3.table[4][0] = 0.0; userdefined3.table[4][1] = 0.33; userdefined3.table[4][2] = 0.0;
   userdefined3.table[5][0] = 0.33; userdefined3.table[5][1] = 0.33; userdefined3.table[5][2] = 0.0;
   userdefined3.table[6][0] = 0.67; userdefined3.table[6][1] = 0.33; userdefined3.table[6][2] = 0.0;
   userdefined3.table[7][0] = 1.0; userdefined3.table[7][1] = 0.33; userdefined3.table[7][2] = 0.0;
   userdefined3.table[8][0] = 0.0; userdefined3.table[8][1] = 0.67; userdefined3.table[8][2] = 0.0;
   userdefined3.table[9][0] = 0.33; userdefined3.table[9][1] = 0.67; userdefined3.table[9][2] = 0.0;
   userdefined3.table[10][0] = 0.67; userdefined3.table[10][1] = 0.67; userdefined3.table[10][2] = 0.0;
   userdefined3.table[11][0] = 1.0; userdefined3.table[11][1] = 0.67; userdefined3.table[11][2] = 0.0;
   userdefined3.table[12][0] = 0.0; userdefined3.table[12][1] = 1.0; userdefined3.table[12][2] = 0.0;
   userdefined3.table[13][0] = 0.33; userdefined3.table[13][1] = 1.0; userdefined3.table[13][2] = 0.0;
   userdefined3.table[14][0] = 0.67; userdefined3.table[14][1] = 1.0; userdefined3.table[14][2] = 0.0;
   userdefined3.table[15][0] = 1.0; userdefined3.table[15][1] = 1.0; userdefined3.table[15][2] = 0.0;
   userdefined3.table[16][0] = 0.0; userdefined3.table[16][1] = 0.0; userdefined3.table[16][2] = 0.33;
   userdefined3.table[17][0] = 0.33; userdefined3.table[17][1] = 0.0; userdefined3.table[17][2] = 0.33;
   userdefined3.table[18][0] = 0.67; userdefined3.table[18][1] = 0.0; userdefined3.table[18][2] = 0.33;
   userdefined3.table[19][0] = 1.0; userdefined3.table[19][1] = 0.0; userdefined3.table[19][2] = 0.33;
   userdefined3.table[20][0] = 0.0; userdefined3.table[20][1] = 0.33; userdefined3.table[20][2] = 0.33;
   userdefined3.table[21][0] = 0.33; userdefined3.table[21][1] = 0.33; userdefined3.table[21][2] = 0.33;
   userdefined3.table[22][0] = 0.67; userdefined3.table[22][1] = 0.33; userdefined3.table[22][2] = 0.33;
   userdefined3.table[23][0] = 1.0; userdefined3.table[23][1] = 0.33; userdefined3.table[23][2] = 0.33;
   userdefined3.table[24][0] = 0.0; userdefined3.table[24][1] = 0.67; userdefined3.table[24][2] = 0.33;
   userdefined3.table[25][0] = 0.33; userdefined3.table[25][1] = 0.67; userdefined3.table[25][2] = 0.33;
   userdefined3.table[26][0] = 0.67; userdefined3.table[26][1] = 0.67; userdefined3.table[26][2] = 0.33;
   userdefined3.table[27][0] = 1.0; userdefined3.table[27][1] = 0.67; userdefined3.table[27][2] = 0.33;
   userdefined3.table[28][0] = 0.0; userdefined3.table[28][1] = 1.0; userdefined3.table[28][2] = 0.33;
   userdefined3.table[29][0] = 0.33; userdefined3.table[29][1] = 1.0; userdefined3.table[29][2] = 0.33;
   userdefined3.table[30][0] = 0.67; userdefined3.table[30][1] = 1.0; userdefined3.table[30][2] = 0.33;
   userdefined3.table[31][0] = 1.0; userdefined3.table[31][1] = 1.0; userdefined3.table[31][2] = 0.33;
   userdefined3.table[32][0] = 0.0; userdefined3.table[32][1] = 0.0; userdefined3.table[32][2] = 0.67;
   userdefined3.table[33][0] = 0.33; userdefined3.table[33][1] = 0.0; userdefined3.table[33][2] = 0.67;
   userdefined3.table[34][0] = 0.67; userdefined3.table[34][1] = 0.0; userdefined3.table[34][2] = 0.67;
   userdefined3.table[35][0] = 1.0; userdefined3.table[35][1] = 0.0; userdefined3.table[35][2] = 0.67;
   userdefined3.table[36][0] = 0.0; userdefined3.table[36][1] = 0.33; userdefined3.table[36][2] = 0.67;
   userdefined3.table[37][0] = 0.33; userdefined3.table[37][1] = 0.33; userdefined3.table[37][2] = 0.67;
   userdefined3.table[38][0] = 0.67; userdefined3.table[38][1] = 0.33; userdefined3.table[38][2] = 0.67;
   userdefined3.table[39][0] = 1.0; userdefined3.table[39][1] = 0.33; userdefined3.table[39][2] = 0.67;
   userdefined3.table[40][0] = 0.0; userdefined3.table[40][1] = 0.67; userdefined3.table[40][2] = 0.67;
   userdefined3.table[41][0] = 0.33; userdefined3.table[41][1] = 0.67; userdefined3.table[41][2] = 0.67;
   userdefined3.table[42][0] = 0.67; userdefined3.table[42][1] = 0.67; userdefined3.table[42][2] = 0.67;
   userdefined3.table[43][0] = 1.0; userdefined3.table[43][1] = 0.67; userdefined3.table[43][2] = 0.67;
   userdefined3.table[44][0] = 0.0; userdefined3.table[44][1] = 1.0; userdefined3.table[44][2] = 0.67;
   userdefined3.table[45][0] = 0.33; userdefined3.table[45][1] = 1.0; userdefined3.table[45][2] = 0.67;
   userdefined3.table[46][0] = 0.67; userdefined3.table[46][1] = 1.0; userdefined3.table[46][2] = 0.67;
   userdefined3.table[47][0] = 1.0; userdefined3.table[47][1] = 1.0; userdefined3.table[47][2] = 0.67;
   userdefined3.table[48][0] = 0.0; userdefined3.table[48][1] = 0.0; userdefined3.table[48][2] = 1.0;
   userdefined3.table[49][0] = 0.33; userdefined3.table[49][1] = 0.0; userdefined3.table[49][2] = 1.0;
   userdefined3.table[50][0] = 0.67; userdefined3.table[50][1] = 0.0; userdefined3.table[50][2] = 1.0;
   userdefined3.table[51][0] = 1.0; userdefined3.table[51][1] = 0.0; userdefined3.table[51][2] = 1.0;
   userdefined3.table[52][0] = 0.0; userdefined3.table[52][1] = 0.33; userdefined3.table[52][2] = 1.0;
   userdefined3.table[53][0] = 0.33; userdefined3.table[53][1] = 0.33; userdefined3.table[53][2] = 1.0;
   userdefined3.table[54][0] = 0.67; userdefined3.table[54][1] = 0.33; userdefined3.table[54][2] = 1.0;
   userdefined3.table[55][0] = 1.0; userdefined3.table[55][1] = 0.33; userdefined3.table[55][2] = 1.0;
   userdefined3.table[56][0] = 0.0; userdefined3.table[56][1] = 0.67; userdefined3.table[56][2] = 1.0;
   userdefined3.table[57][0] = 0.33; userdefined3.table[57][1] = 0.67; userdefined3.table[57][2] = 1.0;
   userdefined3.table[58][0] = 0.67; userdefined3.table[58][1] = 0.67; userdefined3.table[58][2] = 1.0;
   userdefined3.table[59][0] = 1.0; userdefined3.table[59][1] = 0.67; userdefined3.table[59][2] = 1.0;
   userdefined3.table[60][0] = 0.0; userdefined3.table[60][1] = 1.0; userdefined3.table[60][2] = 1.0;
   userdefined3.table[61][0] = 0.33; userdefined3.table[61][1] = 1.0; userdefined3.table[61][2] = 1.0;
   userdefined3.table[62][0] = 0.67; userdefined3.table[62][1] = 1.0; userdefined3.table[62][2] = 1.0;
   userdefined3.table[63][0] = 1.0; userdefined3.table[63][1] = 1.0; userdefined3.table[63][2] = 1.0;

}

ChipsColorMapTable::~ChipsColorMapTable ()
{
   colormap_map::iterator iter = this->colormap_table.begin ();
   for (; iter != this->colormap_table.end (); iter++)
      delete iter->second;
   this->colormap_table.clear ();

   if (userdefined1.table > 0)
   {
      for (int ii=0; ii<userdefined1.table_size; ii++)
         delete []userdefined1.table[ii];
      delete []userdefined1.table;
   }

   if (userdefined2.table > 0)
   {
      for (int ii=0; ii<userdefined2.table_size; ii++)
         delete []userdefined2.table[ii];
      delete []userdefined2.table;
   }

   if (userdefined3.table > 0)
   {
      for (int ii=0; ii<userdefined3.table_size; ii++)
         delete []userdefined3.table[ii];
      delete []userdefined3.table;
   }

}

void ChipsColorMapTable::set_colormap_type (unsigned short id, V_COLORMAP_TYPE colormap_enum)
{
   colormap_map::iterator iter;
   iter = this->colormap_table.find (id);

   if (iter != this->colormap_table.end ())
   {
      ChipsColorMap *colormap = iter->second;
      switch ((int)colormap_enum)
      {
         case chips_grayscale:
            // grey scale: black -> white

            colormap->set_value_range(0, 1);
            colormap->set_saturation_range(0, 0);
            colormap->set_hue_range(0, 0);

            colormap->set_colormap_type (colormap_enum);
         break;
         case chips_rainbow:
            // rainbow: blue -> red

            colormap->set_hue_range(.833, 0);
            colormap->set_saturation_range(1, 1);
            colormap->set_value_range(1, 1);
            colormap->set_colormap_type (colormap_enum);
         break;
         case chips_red:
            // red: black -> red

            colormap->set_value_range(0, 1);
            colormap->set_saturation_range(1, 1);
            colormap->set_hue_range(0, 0);
            colormap->set_colormap_type (colormap_enum);
         break;
         case chips_green:
            // green: black -> green

            colormap->set_value_range(0, 1);
            colormap->set_saturation_range(1, 1);
            colormap->set_hue_range(.333, .333);
            colormap->set_colormap_type (colormap_enum);
         break;
         case chips_blue:
            // blue: black -> blue

            colormap->set_value_range(0, 1);
            colormap->set_saturation_range(1, 1);
            colormap->set_hue_range(.667, .667);
            colormap->set_colormap_type (colormap_enum);
         break;
         case chips_hsv:
         {
            // hsv

            // clear all position except alpha
            colormap->clear_positions (7);

            colormap->set_hue_position(0,.833);
            colormap->set_hue_position(.9,0);

            colormap->set_saturation_position(0,1);
            colormap->set_saturation_position(0.1,.75);
            colormap->set_saturation_position(0.85,.6);
            colormap->set_saturation_position(1,0);

            colormap->set_value_position(0,0);
            colormap->set_value_position(0.1,0.5);
            colormap->set_value_position(1,1);



            colormap->set_colormap_type (colormap_enum);
         }
         break;
         case chips_heat:
            // heat: black -> red -> yellow -> white

            // clear all positions except alpha
            colormap->clear_positions (7);

            colormap->set_red_position(0,0);
            colormap->set_red_position(.34,1);
            colormap->set_red_position(1,1);

            colormap->set_green_position(0,0);
            colormap->set_green_position(1,1);

            colormap->set_blue_position(0,0);
            colormap->set_blue_position(0.65,0);
            colormap->set_blue_position(0.98,1);
            colormap->set_blue_position(1,1);


            colormap->set_colormap_type (colormap_enum);
         break;
         case chips_cool:
            // cool: black -> blue -> white

            // clear all positions except alpha
            colormap->clear_positions (7);

            colormap->set_red_position(0,0);
            colormap->set_red_position(.29,0);
            colormap->set_red_position(.76,.1);
            colormap->set_red_position(1,1);

            colormap->set_green_position(0,0);
            colormap->set_green_position(.22,0);
            colormap->set_green_position(.96,1);
            colormap->set_green_position(1,1);

            colormap->set_blue_position(0,0);
            colormap->set_blue_position(0.53,1);
            colormap->set_blue_position(1,1);

            colormap->set_colormap_type (colormap_enum);
         break;
         case chips_usercmap1:

            // clear all positions
            colormap->clear_positions ();

            if (userdefined1.map_type == UserDefinedMap::TABLE)
               colormap->set_table (userdefined1.table, userdefined1.table_size);
            else if (userdefined1.map_type == UserDefinedMap::DS9)
            {
               list <pair <double, double> >::iterator color_iter;

               color_iter=userdefined1.red_map.begin ();
               for (; color_iter!=userdefined1.red_map.end (); color_iter++)
                  colormap->set_red_position (color_iter->first, color_iter->second);

               color_iter=userdefined1.green_map.begin ();
               for (; color_iter!=userdefined1.green_map.end (); color_iter++)
                  colormap->set_green_position (color_iter->first, color_iter->second);

               color_iter=userdefined1.blue_map.begin ();
               for (; color_iter!=userdefined1.blue_map.end (); color_iter++)
                  colormap->set_blue_position (color_iter->first, color_iter->second);

               color_iter=userdefined1.alpha_map.begin ();
               for (; color_iter!=userdefined1.alpha_map.end (); color_iter++)
                  colormap->set_alpha_position (color_iter->first, color_iter->second);
            }
            colormap->set_colormap_type (colormap_enum);
         break;
         case chips_usercmap2:

            // clear all positions
            colormap->clear_positions ();

            if (userdefined2.map_type == UserDefinedMap::TABLE)
               colormap->set_table (userdefined2.table, userdefined2.table_size);
            else if (userdefined2.map_type == UserDefinedMap::DS9)
            {
               list <pair <double, double> >::iterator color_iter;

               color_iter=userdefined2.red_map.begin ();
               for (; color_iter!=userdefined2.red_map.end (); color_iter++)
                  colormap->set_red_position (color_iter->first, color_iter->second);

               color_iter=userdefined2.green_map.begin ();
               for (; color_iter!=userdefined2.green_map.end (); color_iter++)
                  colormap->set_green_position (color_iter->first, color_iter->second);

               color_iter=userdefined2.blue_map.begin ();
               for (; color_iter!=userdefined2.blue_map.end (); color_iter++)
                  colormap->set_blue_position (color_iter->first, color_iter->second);

               color_iter=userdefined2.alpha_map.begin ();
               for (; color_iter!=userdefined2.alpha_map.end (); color_iter++)
                  colormap->set_alpha_position (color_iter->first, color_iter->second);
            }
            colormap->set_colormap_type (colormap_enum);
         break;
         case chips_usercmap3:
            // clear all positions
            colormap->clear_positions ();

            if (userdefined3.map_type == UserDefinedMap::TABLE)
               colormap->set_table (userdefined3.table, userdefined3.table_size);
            else if (userdefined3.map_type == UserDefinedMap::DS9)
            {
               list <pair <double, double> >::iterator color_iter;

               color_iter=userdefined3.red_map.begin ();
               for (; color_iter!=userdefined3.red_map.end (); color_iter++)
                  colormap->set_red_position (color_iter->first, color_iter->second);

               color_iter=userdefined3.green_map.begin ();
               for (; color_iter!=userdefined3.green_map.end (); color_iter++)
                  colormap->set_green_position (color_iter->first, color_iter->second);

               color_iter=userdefined3.blue_map.begin ();
               for (; color_iter!=userdefined3.blue_map.end (); color_iter++)
                  colormap->set_blue_position (color_iter->first, color_iter->second);

               color_iter=userdefined3.alpha_map.begin ();
               for (; color_iter!=userdefined3.alpha_map.end (); color_iter++)
                  colormap->set_alpha_position (color_iter->first, color_iter->second);
            }
            colormap->set_colormap_type (colormap_enum);
         break;
         default:
         break;
      }

      colormap->update ();
   }
}


V_COLORMAP_TYPE ChipsColorMapTable::get_colormap_type (unsigned short id)
{
   colormap_map::iterator iter;
   iter = this->colormap_table.find (id);

   if (iter != this->colormap_table.end ())
      return static_cast<V_COLORMAP_TYPE>(iter->second->get_colormap_type ());

   return static_cast<V_COLORMAP_TYPE>(0);
}


void ChipsColorMapTable::set_invert_colormap (unsigned short id, bool invert)
{
   colormap_map::iterator iter;
   iter = this->colormap_table.find (id);

   if (iter != this->colormap_table.end ())
   {
      ChipsColorMap *colormap = iter->second;
      if (colormap->get_inverted () != invert)
         colormap->invert_table ();
   }
}

bool ChipsColorMapTable::get_invert_colormap (unsigned short id)
{
   colormap_map::iterator iter;
   iter = this->colormap_table.find (id);

   if (iter != this->colormap_table.end ())
      return iter->second->get_inverted ();

   return false;
}

void ChipsColorMapTable::set_colormap_size (unsigned short id, int size)
{
   colormap_map::iterator iter;
   iter = this->colormap_table.find (id);

   if (iter != this->colormap_table.end ())
   {
      ChipsColorMap *colormap = iter->second;
      colormap->set_table_size (size);
      colormap->update ();
   }

}

int ChipsColorMapTable::get_colormap_size (unsigned short id)
{
   colormap_map::iterator iter;
   iter = this->colormap_table.find (id);

   if (iter != this->colormap_table.end ())
   {
      ChipsColorMap *colormap = iter->second;
      return colormap->get_table_size ();
   }

   return 0;
}



void ChipsColorMapTable::set_colormap_alpha_range (unsigned short id, double alpha_range[])
{
   colormap_map::iterator iter;
   iter = this->colormap_table.find (id);

   if (iter != this->colormap_table.end ())
   {
      ChipsColorMap *colormap = iter->second;
      colormap->set_alpha_range (alpha_range);
      colormap->update ();
   }
}

void ChipsColorMapTable::get_colormap_alpha_range (unsigned short id, double alpha_range[])
{
   colormap_map::iterator iter;
   iter = this->colormap_table.find (id);

   if (iter != this->colormap_table.end ())
   {
      ChipsColorMap *colormap = iter->second;
      colormap->get_alpha_range (alpha_range);
   }
}

void ChipsColorMapTable::set_colormap_scale (unsigned short id, int scale)
{
   colormap_map::iterator iter;
   iter = this->colormap_table.find (id);

   if (iter != this->colormap_table.end ())
   {
      ChipsColorMap *colormap = iter->second;
      colormap->set_color_scale (scale);
   }
}

int ChipsColorMapTable::get_colormap_scale (unsigned short id)
{
   colormap_map::iterator iter;
   iter = this->colormap_table.find (id);

   if (iter != this->colormap_table.end ())
   {
      ChipsColorMap *colormap = iter->second;
      return colormap->get_color_scale ();
   }

   return 0;
}

void ChipsColorMapTable::set_colormap_ramp (unsigned short id, int ramp)
{
   colormap_map::iterator iter;
   iter = this->colormap_table.find (id);

   if (iter != this->colormap_table.end ())
   {
      ChipsColorMap *colormap = iter->second;
      colormap->set_color_ramp (ramp);
   }

}

int ChipsColorMapTable::get_colormap_ramp (unsigned short id)
{
   colormap_map::iterator iter;
   iter = this->colormap_table.find (id);

   if (iter != this->colormap_table.end ())
   {
      ChipsColorMap *colormap = iter->second;
      return colormap->get_color_ramp ();
   }

   return 0;

}

void ChipsColorMapTable::set_colormap_interpolate (unsigned short id, bool interpolate )
{
   colormap_map::iterator iter;
   iter = this->colormap_table.find (id);

   if (iter != this->colormap_table.end ())
   {
      ChipsColorMap *colormap = iter->second;
      colormap->set_interpolate (interpolate);
      colormap->update ();
   }

}

bool ChipsColorMapTable::get_colormap_interpolate (unsigned short id)
{
   colormap_map::iterator iter;
   iter = this->colormap_table.find (id);

   if (iter != this->colormap_table.end ())
   {
      ChipsColorMap *colormap = iter->second;
      return colormap->get_interpolate ();
   }

   return false;

}


void ChipsColorMapTable::set_colormap_scalar_threshold (unsigned short id, double threshold[])
{
   colormap_map::iterator iter;
   iter = this->colormap_table.find (id);

   if (iter != this->colormap_table.end ())
   {
      ChipsColorMap *colormap = iter->second;
      colormap->set_scalar_threshold (threshold);
      colormap->update  ();
   }

}

void ChipsColorMapTable::get_colormap_scalar_threshold (unsigned short id, double threshold[])
{
   colormap_map::iterator iter;
   iter = this->colormap_table.find (id);

   if (iter != this->colormap_table.end ())
   {
      ChipsColorMap *colormap = iter->second;
      colormap->get_scalar_threshold (threshold);
   }
}


void ChipsColorMapTable::set_colormap_scalar_range (unsigned short id, double range[])
{
   colormap_map::iterator iter;
   iter = this->colormap_table.find (id);

   if (iter != this->colormap_table.end ())
   {
      ChipsColorMap *colormap = iter->second;
      colormap->set_scalar_range (range);
      colormap->update  ();
   }
}

void ChipsColorMapTable::get_colormap_scalar_range (unsigned short id, double range[])
{
   colormap_map::iterator iter;
   iter = this->colormap_table.find (id);

   if (iter != this->colormap_table.end ())
   {
      ChipsColorMap *colormap = iter->second;
      colormap->get_scalar_range (range);
   }
}



int ChipsColorMapTable::load_file (string filename, V_COLORMAP_TYPE slot)
{
   ifstream colormap_file (filename.c_str ());
   string colormap_line = "";
   unsigned int file_pos = 0;

   int rval = ERR_STATUS_GOOD;

   if (colormap_file.fail () || !colormap_file.is_open ())
   {
      cmd_manager->add_err(rval=ERR_CMAP_LOAD, "", -1, filename.c_str ());
      return rval;
   }

   // ignore lines which begin with #
   do
   {
      file_pos = colormap_file.tellg ();
      getline (colormap_file, colormap_line);
   } while (!colormap_file.eof () && (colormap_line[0] == '#'));

   colormap_file.seekg (file_pos, ios::beg);
   if (colormap_line.compare (0, 11, "PSEUDOCOLOR") == 0)
   {
      if (slot == chips_usercmap1)
         rval = this->read_ds9_file (colormap_file, userdefined1, filename);
      else if (slot == chips_usercmap2)
         rval = this->read_ds9_file (colormap_file, userdefined2, filename);
      else if (slot == chips_usercmap3)
         rval = this->read_ds9_file (colormap_file, userdefined3, filename);
      else
         cmd_manager->add_err(rval=ERR_CMAP_SLOT_INV);
   } 
   else
   {
      if (slot == chips_usercmap1)
         rval = this->read_table_file (colormap_file, userdefined1, filename);
      else if (slot == chips_usercmap2)
         rval = this->read_table_file (colormap_file, userdefined2, filename);
      else if (slot == chips_usercmap3)
         rval = this->read_table_file (colormap_file, userdefined3, filename);
      else
         cmd_manager->add_err(rval=ERR_CMAP_SLOT_INV);

   }

   return rval;
}

unsigned short ChipsColorMapTable::add_colormap ()
{
   ChipsColorMap *colormap = this->new_colormap ();
   colormap_table[++this->ref_count] = colormap;

   return this->ref_count;
}


ChipsColorMap *ChipsColorMapTable::get_colormap (unsigned short id)
{
   colormap_map::iterator iter;
   iter = this->colormap_table.find (id);

   if (iter != this->colormap_table.end ())
      return (iter->second);

   return static_cast <ChipsColorMap *> (0);
}


void ChipsColorMapTable::serialize(ChipsStateStream& out)
{
   short sval;
   int ival;
   double dval;

   // write out user defines
   sval = static_cast <short> (this->userdefined1.map_type);
   out.write_short (&sval);
   if (this->userdefined1.map_type == UserDefinedMap::TABLE)
   {
      out.write_int (&(this->userdefined1.table_size));
      for (int ii=0; ii<this->userdefined1.table_size; ii++)
         out.write_double (this->userdefined1.table[ii], 4);
   }
   else if (this->userdefined1.map_type == UserDefinedMap::DS9)
   {
      list <pair <double, double> >::iterator iter = this->userdefined1.red_map.begin ();


      ival = static_cast <int> (this->userdefined1.red_map.size ());
      out.write_int (&ival);
      for (; iter != this->userdefined1.red_map.end (); iter++)
      {
         dval = iter->first;
         out.write_double (&dval);
         dval = iter->second;
         out.write_double (&dval);
      }

      iter = this->userdefined1.green_map.begin ();
      ival = static_cast <int> (this->userdefined1.green_map.size ());
      out.write_int (&ival);
      for (; iter != this->userdefined1.green_map.end (); iter++)
      {
         dval = iter->first;
         out.write_double (&dval);
         dval = iter->second;
         out.write_double (&dval);
      }

      iter = this->userdefined1.blue_map.begin ();
      ival = static_cast <int> (this->userdefined1.blue_map.size ());
      out.write_int (&ival);
      for (; iter != this->userdefined1.blue_map.end (); iter++)
      {
         dval = iter->first;
         out.write_double (&dval);
         dval = iter->second;
         out.write_double (&dval);
      }

      iter = this->userdefined1.alpha_map.begin ();
      ival = static_cast <int> (this->userdefined1.alpha_map.size ());
      out.write_int (&ival);
      for (; iter != this->userdefined1.alpha_map.end (); iter++)
      {
         dval = iter->first;
         out.write_double (&dval);
         dval = iter->second;
         out.write_double (&dval);
      }

   }

   sval = static_cast <short> (this->userdefined2.map_type);
   out.write_short (&sval);
   if (this->userdefined2.map_type == UserDefinedMap::TABLE)
   {
      out.write_int (&(this->userdefined2.table_size));
      for (int ii=0; ii<this->userdefined2.table_size; ii++)
         out.write_double (this->userdefined2.table[ii], 4);
   }
   else if (this->userdefined2.map_type == UserDefinedMap::DS9)
   {
      list <pair <double, double> >::iterator iter = this->userdefined2.red_map.begin ();

      ival = static_cast <int> (this->userdefined2.red_map.size ());
      out.write_int (&ival);
      for (; iter != this->userdefined2.red_map.end (); iter++)
      {
         dval = iter->first;
         out.write_double (&dval);
         dval = iter->second;
         out.write_double (&dval);
      }

      iter = this->userdefined2.green_map.begin ();
      ival = static_cast <int> (this->userdefined2.green_map.size ());
      out.write_int (&ival);
      for (; iter != this->userdefined2.green_map.end (); iter++)
      {
         dval = iter->first;
         out.write_double (&dval);
         dval = iter->second;
         out.write_double (&dval);
      }

      iter = this->userdefined2.blue_map.begin ();
      ival = static_cast <int> (this->userdefined2.blue_map.size ());
      out.write_int (&ival);
      for (; iter != this->userdefined2.blue_map.end (); iter++)
      {
         dval = iter->first;
         out.write_double (&dval);
         dval = iter->second;
         out.write_double (&dval);
      }

      iter = this->userdefined2.alpha_map.begin ();
      ival = static_cast <int> (this->userdefined2.alpha_map.size ());
      out.write_int (&ival);
      for (; iter != this->userdefined2.alpha_map.end (); iter++)
      {
         dval = iter->first;
         out.write_double (&dval);
         dval = iter->second;
         out.write_double (&dval);
      }

   }

   sval = static_cast <short> (this->userdefined3.map_type);
   out.write_short (&sval);
   if (this->userdefined3.map_type == UserDefinedMap::TABLE)
   {
      out.write_int (&(this->userdefined3.table_size));
      for (int ii=0; ii<this->userdefined3.table_size; ii++)
         out.write_double (this->userdefined3.table[ii], 4);
   }
   else if (this->userdefined3.map_type == UserDefinedMap::DS9)
   {
      list <pair <double, double> >::iterator iter = this->userdefined3.red_map.begin ();
      ival = static_cast <int> (this->userdefined3.red_map.size ());
      out.write_int (&ival);
      for (; iter != this->userdefined3.red_map.end (); iter++)
      {
         dval = iter->first;
         out.write_double (&dval);
         dval = iter->second;
         out.write_double (&dval);
      }

      iter = this->userdefined3.green_map.begin ();
      ival = static_cast <int> (this->userdefined3.green_map.size ());

      out.write_int (&ival);
      for (; iter != this->userdefined3.green_map.end (); iter++)
      {
         dval = iter->first;
         out.write_double (&dval);
         dval = iter->second;
         out.write_double (&dval);
      }

      iter = this->userdefined3.blue_map.begin ();
      ival = static_cast <int> (this->userdefined3.blue_map.size ());
      out.write_int (&ival);
      for (; iter != this->userdefined3.blue_map.end (); iter++)
      {
         dval = iter->first;
         out.write_double (&dval);
         dval = iter->second;
         out.write_double (&dval);
      }

      iter = this->userdefined3.alpha_map.begin ();
      ival = static_cast <int> (this->userdefined3.alpha_map.size ());
      out.write_int (&ival);
      for (; iter != this->userdefined3.alpha_map.end (); iter++)
      {
         dval = iter->first;
         out.write_double (&dval);
         dval = iter->second;
         out.write_double (&dval);
      }

   }

   // write out stored color maps
   ival = colormap_table.size ();
   out.write_int (&ival);
   colormap_map::iterator iter = colormap_table.begin ();
   for (; iter != colormap_table.end (); iter++)
   {
      sval = iter->first;
      out.write_short (&sval);
      iter->second->serialize (out);
   }
}

void ChipsColorMapTable::serialize_ascii(ChipsStateStream& out)
{
   if (userdefined1.fname != "")
      out << "load_colormap(\"" << userdefined1.fname <<"\")"<<endl;
   if (userdefined2.fname != "")
      out << "load_colormap(\"" << userdefined2.fname <<"\",chips_usercmap2)"<<endl;
   if (userdefined3.fname != "")
      out << "load_colormap(\"" << userdefined3.fname <<"\",chips_usercmap3)"<<endl;
}

void ChipsColorMapTable::deserialize(ChipsStateStream& in)
{
   short sval;
   int ival;
   double dval1;
   double dval2;
   ChipsColorMap *colormap;

   // read in user defines
   in.read_short (&sval);
   this->userdefined1.map_type = static_cast<UserDefinedMap::MAP_TYPE> (sval);
   if (this->userdefined1.map_type == UserDefinedMap::TABLE)
   {
      if (userdefined1.table)
      {
         for (int ii=0; ii<userdefined1.table_size; ii++)
            delete []userdefined1.table[ii];
         delete []userdefined1.table;
      }

      in.read_int (&(this->userdefined1.table_size));
      this->userdefined1.table = new double* [this->userdefined1.table_size];
      for (int ii=0; ii<this->userdefined1.table_size; ii++)
      {
         this->userdefined1.table[ii] = new double[4];
         in.read_double (this->userdefined1.table[ii], 4);
      }
   }
   else if (this->userdefined1.map_type == UserDefinedMap::DS9)
   {
      pair <double, double> map_values;
      in.read_int (&ival);
      for (int ii=0; ii<ival; ii++)
      {
         in.read_double (&dval1);
         in.read_double (&dval2);
         map_values.first = dval1;
         map_values.second = dval2;

         this->userdefined1.red_map.push_back (map_values);
      }

      in.read_int (&ival);
      for (int ii=0; ii<ival; ii++)
      {
         in.read_double (&dval1);
         in.read_double (&dval2);
         map_values.first = dval1;
         map_values.second = dval2;

         this->userdefined1.green_map.push_back (map_values);
      }

      in.read_int (&ival);
      for (int ii=0; ii<ival; ii++)
      {
         in.read_double (&dval1);
         in.read_double (&dval2);
         map_values.first = dval1;
         map_values.second = dval2;

         this->userdefined1.blue_map.push_back (map_values);

      }

      in.read_int (&ival);
      for (int ii=0; ii<ival; ii++)
      {
         in.read_double (&dval1);
         in.read_double (&dval2);
         map_values.first = dval1;
         map_values.second = dval2;

         this->userdefined1.alpha_map.push_back (map_values);
      }
   }


   in.read_short (&sval);
   this->userdefined2.map_type = static_cast<UserDefinedMap::MAP_TYPE> (sval);
   if (this->userdefined2.map_type == UserDefinedMap::TABLE)
   {
      if (userdefined2.table)
      {
         for (int ii=0; ii<userdefined2.table_size; ii++)
            delete []userdefined2.table[ii];
         delete []userdefined2.table;
      }

      in.read_int (&(this->userdefined2.table_size));
      this->userdefined2.table = new double* [this->userdefined2.table_size];
      for (int ii=0; ii<this->userdefined2.table_size; ii++)
      {
         this->userdefined2.table[ii] = new double[4];
         in.read_double (this->userdefined2.table[ii], 4);
      }
   }
   else if (this->userdefined2.map_type == UserDefinedMap::DS9)
   {
      pair <double, double> map_values;
      in.read_int (&ival);
      for (int ii=0; ii<ival; ii++)
      {
         in.read_double (&dval1);
         in.read_double (&dval2);
         map_values.first = dval1;
         map_values.second = dval2;

         this->userdefined2.red_map.push_back (map_values);

      }

      in.read_int (&ival);
      for (int ii=0; ii<ival; ii++)
      {
         in.read_double (&dval1);
         in.read_double (&dval2);
         map_values.first = dval1;
         map_values.second = dval2;

         this->userdefined2.green_map.push_back (map_values);
      }

      in.read_int (&ival);
      for (int ii=0; ii<ival; ii++)
      {
         in.read_double (&dval1);
         in.read_double (&dval2);
         map_values.first = dval1;
         map_values.second = dval2;

         this->userdefined2.blue_map.push_back (map_values);
      }

      in.read_int (&ival);
      for (int ii=0; ii<ival; ii++)
      {
         in.read_double (&dval1);
         in.read_double (&dval2);
         map_values.first = dval1;
         map_values.second = dval2;

         this->userdefined2.alpha_map.push_back (map_values);
      }
   }

   in.read_short (&sval);
   this->userdefined3.map_type = static_cast<UserDefinedMap::MAP_TYPE> (sval);
   if (this->userdefined3.map_type == UserDefinedMap::TABLE)
   {
      if (userdefined3.table)
      {
         for (int ii=0; ii<userdefined3.table_size; ii++)
            delete []userdefined3.table[ii];
         delete []userdefined3.table;
      }

      in.read_int (&(this->userdefined3.table_size));
      this->userdefined3.table = new double* [this->userdefined3.table_size];
      for (int ii=0; ii<this->userdefined3.table_size; ii++)
      {
         this->userdefined3.table[ii] = new double[4];
         in.read_double (this->userdefined3.table[ii], 4);
      }
   }
   else if (this->userdefined3.map_type == UserDefinedMap::DS9)
   {
      pair <double, double> map_values;
      in.read_int (&ival);
      for (int ii=0; ii<ival; ii++)
      {
         in.read_double (&dval1);
         in.read_double (&dval2);
         map_values.first = dval1;
         map_values.second = dval2;

         this->userdefined3.red_map.push_back (map_values);
      }

      in.read_int (&ival);
      for (int ii=0; ii<ival; ii++)
      {
         in.read_double (&dval1);
         in.read_double (&dval2);
         map_values.first = dval1;
         map_values.second = dval2;

         this->userdefined3.green_map.push_back (map_values);
      }

      in.read_int (&ival);
      for (int ii=0; ii<ival; ii++)
      {
         in.read_double (&dval1);
         in.read_double (&dval2);
         map_values.first = dval1;
         map_values.second = dval2;

         this->userdefined3.blue_map.push_back (map_values);
      }

      in.read_int (&ival);
      for (int ii=0; ii<ival; ii++)
      {
         in.read_double (&dval1);
         in.read_double (&dval2);
         map_values.first = dval1;
         map_values.second = dval2;

         this->userdefined3.alpha_map.push_back (map_values);
      }
   }

   // clean up the current table before rebuilding it
   colormap_map::iterator iter = this->colormap_table.begin ();
   for (; iter != this->colormap_table.end (); iter++)
      delete iter->second;
   this->colormap_table.clear ();

   in.read_int (&ival);
   for (int ii=0; ii<ival; ii++)
   {
      in.read_short (&sval);
      if (this->ref_count <= (unsigned short)sval)
         this->ref_count = static_cast <unsigned short> (sval);

      colormap = this->new_colormap ();
      colormap->deserialize (in);
      this->colormap_table[static_cast<unsigned short>(sval)] = colormap;
   }

}


ChipsColorMap *ChipsColorMapTable::new_colormap ()
{
   return static_cast <ChipsColorMap *> (0);
}


int ChipsColorMapTable::read_ds9_file (ifstream &file, UserDefinedMap &user_map, string filename)
{
   istringstream tmpString;

   string line = "";

   int mode = 0;
   unsigned int string_pos = 0;
   unsigned int prev_string_pos = 0;

   int rval = ERR_STATUS_GOOD;

   double position;
   double value;

   list <pair <double, double> > red_map;
   list <pair <double, double> > green_map;
   list <pair <double, double> > blue_map;
   list <pair <double, double> > alpha_map;

   pair <double, double> map_value;


   if (!file.is_open () || file.eof ())
   {
      cmd_manager->add_err(rval=ERR_CMAP_LOAD, "", -1, filename.c_str ());
      return ERR_CMAP_LOAD;
   }

   getline (file, line);

   if (line.compare (0, 11, "PSEUDOCOLOR") != 0)
   {
      cmd_manager->add_err(rval=ERR_CMAP_DS9, "", -1, filename.c_str ());
      return ERR_CMAP_DS9;
   }
   
   getline (file, line);
   do
   {
      if (mode == 0)
      {
         if (line.compare (0,3,"RED") == 0)
            mode = 1;
         else if (line.compare (0,5,"GREEN") == 0)
            mode = 2;
         else if (line.compare (0,4,"BLUE") == 0)
            mode = 3;
         else if (line.compare (0,5,"ALPHA") == 0)
            mode = 4;
         else
         {
            string err_msg = "The specified colormap file, " + filename + ", has in invalid line, '"+ line +"'. Expected the keyword, RED, GREEN, BLUE, or ALPHA.";
            cmd_manager->add_err(err_msg, rval=ERR_CMAP_DS9);
            break;
         }
      }
      else
      {
         string_pos = 0;
         prev_string_pos = 1;

         while (string_pos != line.length ())
         {
            if (line[string_pos] != '(')
            {
               string err_msg = "The specified colormap file, " + filename + ", has in invalid line, '"+ line +"'. Expected '(' to start the line.";

               cmd_manager->add_err(err_msg, rval=ERR_CMAP_DS9);
               break;
            }

            string_pos = line.find_first_of (",", string_pos);

            if (string_pos >= line.length () || 
                prev_string_pos == string_pos ||
                string_pos > line.find_first_of (")", prev_string_pos) ||
                string_pos > line.find_first_of ("(", prev_string_pos))
            {
               string err_msg = "The specified colormap file, " + filename + ", has in invalid line, '"+ line +"'. Missing ',' between values";
               cmd_manager->add_err(err_msg, rval=ERR_CMAP_DS9);
               break;
            }

            tmpString.clear ();
            tmpString.str (line.substr (prev_string_pos, string_pos-prev_string_pos));
            tmpString >> position;

            if (tmpString.fail () || tmpString.bad ())
            {
               string err_msg = "The specified colormap file, " + filename + ", has in invalid line, '"+ line +"'. The line has an invalid value, "+line.substr (prev_string_pos, string_pos-prev_string_pos); 
               cmd_manager->add_err(err_msg, rval=ERR_CMAP_DS9);
               break;
            }

            prev_string_pos = string_pos+1;
            string_pos = line.find_first_of (")", string_pos);

            if (string_pos >= line.length () ||
                prev_string_pos == string_pos ||
                string_pos > line.find_first_of ("(", prev_string_pos) ||
                string_pos > line.find_first_of (",", prev_string_pos))
            {
               string err_msg = "The specified colormap file, " + filename + ", has in invalid line, '"+ line +"'. Missing ')' at the end fo the entry.";
               cmd_manager->add_err(err_msg, rval=ERR_CMAP_DS9);
               break;
            }

            tmpString.clear ();
            tmpString.str (line.substr (prev_string_pos, string_pos-prev_string_pos));
            tmpString >> value;

            if (tmpString.fail () || tmpString.bad ())
            {
               string err_msg = "The specified colormap file, " + filename + ", has in invalid line, '"+ line +"'. The line has an invalid value, "+line.substr (prev_string_pos, string_pos-prev_string_pos);
               cmd_manager->add_err(err_msg, rval=ERR_CMAP_DS9);
               break;
            }

            map_value.first = position;
            map_value.second = value;
            if (mode == 1)
               red_map.push_back (map_value);
            else if (mode == 2)
               green_map.push_back (map_value);
            else if (mode == 3)
               blue_map.push_back (map_value);
            else if (mode == 4)
               alpha_map.push_back (map_value);

            string_pos++;
            prev_string_pos = string_pos+1;

         }
         mode = 0;
      }
      getline (file, line);

   } while (!file.eof () && !rval);

   if (rval == ERR_STATUS_GOOD)
   {
      user_map.map_type = UserDefinedMap::DS9;
      
      // only update the user info if the file was good
      user_map.red_map = red_map;
      user_map.green_map = green_map;
      user_map.blue_map = blue_map;
      user_map.alpha_map = alpha_map;

   }

   return rval;
}

int ChipsColorMapTable::read_array_list (long len, V_COLORMAP_TYPE slot,
					 double* r, double* g, 
                                         double* b, double* alpha)
{
  
   UserDefinedMap* user_map;
   int rval = ERR_STATUS_GOOD;

   if (slot == chips_usercmap1)
     user_map = &userdefined1;
   else if (slot == chips_usercmap2)
     user_map = &userdefined2;
   else if (slot == chips_usercmap3)
     user_map = &userdefined3;
   else
     cmd_manager->add_err(rval=ERR_CMAP_SLOT_INV);
  
   if (rval == ERR_STATUS_GOOD)
   {
      int row = 0;
      double **table;
      table = new double *[len];

      for (int i=0; i<len; i++)
      {
	table[i] = new double [4];
        table[i][0] = r[i];
	table[i][1] = g[i];
	table[i][2] = b[i];
	table[i][3] = alpha[i];
	row++;
      }
      
      user_map->map_type = UserDefinedMap::TABLE;
 
      // if a table already exists remove it
      if (user_map->table_size > 0)
      {
         for (int ii=0; ii<user_map->table_size; ii++)
            delete []user_map->table[ii];
         delete []user_map->table;
      }
      user_map->table_size = row;
      user_map->table = table;
   }
   return rval;
}

int ChipsColorMapTable::read_table_file (ifstream &file, UserDefinedMap &user_map, string filename)
{
   istringstream tmpString;
   string line = "";

   int row = 0;
   int file_pos;

   int rval = ERR_STATUS_GOOD;

   double **table;

   if (!file.is_open () || file.eof ())
   {
      cmd_manager->add_err(rval=ERR_CMAP_LOAD, "", -1,  filename.c_str ());
      return ERR_CMAP_LOAD;
   }

   file_pos = file.tellg ();

   // count the number of columns
   while (!file.eof ())
   {
      getline (file, line);
      row++;
   }

   file.clear ();

   file.seekg (0, ios::beg);

   table = new double *[row];

   row = 0;

   getline (file, line);
   do
   {

      // trim white space from the end of the line
      line = line.erase( line.find_last_not_of(" \n\t") + 1);

      table[row] = new double [4];
      tmpString.str (line);

      for (int ii=0; ii<4; ii++)
      {
         if (!tmpString.eof ())
            tmpString >> table[row][ii];
         else if (ii == 3)
            // if the row does not contain an alpha value assume 
            // alpha of one
            table[row][ii] = 1;
         else
            // if the row does not have all rgb components assume
            // value of zero
            table[row][ii] = 0;

         if (tmpString.fail ())
         {
            cmd_manager->add_err(rval=ERR_CMAP_TABLE,"",-1, filename.c_str (), line.c_str ());
            break;
         }
      }

      tmpString.clear ();

      getline (file, line);
      row++;
   }while (!file.eof () && !rval);

   // only update the table if the file was good
   if (rval == ERR_STATUS_GOOD)
   {
      user_map.map_type = UserDefinedMap::TABLE;
 
      // if a table already exists remove it
      if (user_map.table_size > 0)
      {
         for (int ii=0; ii<user_map.table_size; ii++)
            delete []user_map.table[ii];
         delete []user_map.table;
      }
      user_map.table_size = row;
      user_map.table = table;
   }
   else 
   {
      // if there was an error clean up the memory
      for (int ii=0; ii<row; ii++)
         delete []table[ii];
      delete []table;
   }


   return rval;

}
