// 
//  Copyright (C) 2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSDATAASPECTCOMMAND_HH
#define CHIPSDATAASPECTCOMMAND_HH

#include "ChipsCommand.hh"
#include <string>

class ChipsStateStream;

class ChipsDataAspectCommand : public ChipsCommand
{
   public:
      ChipsDataAspectCommand(ChipsObject *new_co, string xax, 
         string yax, string new_val, string old_val, string oldcur);
      ChipsDataAspectCommand(ChipsObject* cob, ChipsStateStream& in);
      virtual ~ChipsDataAspectCommand();
      virtual int execute();
      virtual int unexecute();
      virtual int clear() {return ERR_STATUS_GOOD;};
      virtual void print();
      virtual void serialize(ChipsStateStream& out);
      virtual void deserialize(ChipsStateStream& in);
   protected:
      string current;
      string xaxis;
      string yaxis;
      string new_ratio;
      string old_ratio;
};

#endif

