// 
//  Copyright (C) 2007  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSDELETECOMMAND_HH
#define CHIPSDELETECOMMAND_HH

#include "ChipsObject.hh"
#include "ChipsCommand.hh"
#include "ChipsEngine.hh"

class ChipsDeleteCommand : public ChipsCommand
{
   public:
      ChipsDeleteCommand (ChipsObject *new_co, const string &curr="");
      ChipsDeleteCommand (ChipsObject *new_co, ChipsStateStream& in);
      ChipsDeleteCommand (ChipsEngine *eng, ChipsStateStream& in);
      ChipsDeleteCommand(ChipsStateStream& in);
      virtual ~ChipsDeleteCommand ();
      virtual int execute ();
      virtual int unexecute ();
      virtual int clear ();
      virtual void print ();
      virtual void serialize(ChipsStateStream& out);
      virtual void deserialize(ChipsStateStream& in);
      void clear_objects();
      void set_current (const string &curr) { current = curr; };
   protected:
      string current;
};

#endif
