// 
//  Copyright (C) 2007  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSDEPTHARRANGECOMMAND_HH
#define CHIPSDEPTHARRANGECOMMAND_HH

#include "ChipsCommand.hh"
#include "ChipsDepthControl.hh"
#include "ChipsId.hh"
#include "ChipsDefines.hh"

class ChipsStateStream;

class ChipsDepthArrangeCommand : public ChipsCommand
{
   public:
      ChipsDepthArrangeCommand(ChipsObject *cob, int inPos, int inTotalPos, 
                                int inDirection, V_OBJECT_TYPE inObj,
                                ChipsId *inCid);
      ChipsDepthArrangeCommand(ChipsObject *cob, ChipsStateStream& in);
      virtual ~ChipsDepthArrangeCommand();
      virtual int execute();
      virtual int unexecute();
      virtual int clear() {return ERR_STATUS_GOOD;};
      virtual void print();
      virtual void serialize(ChipsStateStream& out);
      virtual void deserialize(ChipsStateStream& in);
      void    make_no_op() { direction = -1;};
   protected:
      int pos;             // position in the depth
      int total_pos;       // total number of objects in that depth
      int direction;
      V_OBJECT_TYPE obj;
      ChipsId *cid;
};

#endif

