// 
//  Copyright (C) 2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSFILLCOMMAND_HH
#define CHIPSFILLCOMMAND_HH

#include "ChipsCommand.hh"
#include <string>

class ChipsStateStream;

class ChipsFillCommand : public ChipsCommand
{
   public:
      ChipsFillCommand(int slotval, unsigned char* oldval, unsigned char* newval);
      ChipsFillCommand(ChipsStateStream& in);
      virtual ~ChipsFillCommand();
      virtual int execute();
      virtual int unexecute();
      virtual int clear() {return ERR_STATUS_GOOD;};
      virtual void print();
      virtual void serialize(ChipsStateStream& out);
      virtual void deserialize(ChipsStateStream& in);
   protected:
      unsigned char oval[128]; 
      unsigned char nval[128]; 
      int slot; 
};

#endif

