// 
//  Copyright (C) 2008  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSFILLPATTERN_HH
#define CHIPSFILLPATTERN_HH

class ChipsFillPattern;
class ChipsStateStream;

#include <string>
#include <iostream>
#include <stdio.h>
#include "ChipsDefines.hh"
#include <list>

using namespace std;


typedef struct fill_elem_t
{
   string   name;     // name of fill
   string   file; 
   string   desc;     // description 
   unsigned char* pattern; 
} FILL_ELEM_T, *FILL_ELEM_P_T;


class ChipsFillPattern
{
  public:

   ChipsFillPattern();
  ~ChipsFillPattern();

   int      load_file(string filename, string slot);
   int      load_file(string filename, int slot);
   int      load_xbm(string filename, int slot);
   int      set_fill(unsigned char* pat, int slot); 
   string   get_filename(int slot);
   string   get_description(int slot);
   unsigned char*  get_pattern(int slot); 

   virtual void serialize(ChipsStateStream& out);
   virtual void deserialize(ChipsStateStream& in);

  protected:

   FILL_ELEM_T  fills[chips_fill_size];
};

#endif 
