// 
//  Copyright (C) 2005,2007  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSFONTLIST_HH
#define CHIPSFONTLIST_HH

class ChipsFontList;

#include <string>
#include <iostream>
#include <stdio.h>
#include "ChipsDefines.hh"
#include <list>

using namespace std;


typedef struct fontlist_elem_t
{
   string   fontname;     // name of font
   string   path_n;       // path to normal style font
   string   path_b;       // path to normal style font
   string   path_i;       // path to normal style font
   string   path_bi;      // path to normal style font
} FONTLIST_ELEM_T, *FONTLIST_ELEM_P_T;


class ChipsFontList
{
  public:

   ChipsFontList();
  ~ChipsFontList();

   int      load_font(string fname, string fpath, V_FONTSTYLE_TYPE styl);

   string   get_path(string& fname, V_FONTSTYLE_TYPE styl);
   string   get_normal_path(string& fname);
   string   get_bold_path(string& fname);
   string   get_italic_path(string& fname);
   string   get_bolditalic_path(string& fname);
   bool     font_exists(string& fname);
   void     get_font_names (list<string> &out_fnames);

  protected:

   FONTLIST_ELEM_P_T get_font(string& fname);

   list <FONTLIST_ELEM_P_T> fonts;

};

#endif 
