// 
//  Copyright (C) 2007  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSIMAGECHANNELCOMMAND_HH
#define CHIPSIMAGECHANNELCOMMAND_HH

#include "ChipsCommand.hh"

class ChipsStateStream;
class ChipsImage;

class ChipsImageChannelCommand : public ChipsCommand
{
   public:
      ChipsImageChannelCommand(ChipsImage* obj, double *ovals, 
                              double *nvals, int channel, int *dim, 
                              bool add_channel);
      ChipsImageChannelCommand(ChipsImage* obj, int ocnt, double *ovals,
                              int ncnt, double *nvals);
      ChipsImageChannelCommand(ChipsObject* cob, ChipsStateStream& in);
      virtual ~ChipsImageChannelCommand();
      virtual int execute();
      virtual int unexecute();
      virtual int clear() {return ERR_STATUS_GOOD;};
      virtual void print();
      virtual void serialize(ChipsStateStream& out);
      virtual void deserialize(ChipsStateStream& in);
   protected:
      int           dim[2];
      bool          add_channel;
      int           channel;
      double*       diff_vals;

      bool          diff_exists;
};

#endif

