// 
//  Copyright (C) 2004,2005,2007  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSLEGEND_HH
#define CHIPSLEGEND_HH

#include <string>
#include <list>
#include <iostream>
#include <stdio.h>

#include "ChipsObject.hh"
#include "ChipsDefaults.hh"
#include "ChipsDefines.hh"
#include "ChipsAnnotation.hh"

using namespace std;


class ChipsLegend: public ChipsAnnotation
{
  public:

   ChipsLegend(ChipsObject* par, const char** cvids, const char** in_labels, 
              string lgid);
   void       initialize(); 
   int        set_property(void* in_val, int in_property);

   float      get_thickness()    { return thickness; }
   int        set_thickness(float val);

   int        set_transparency(bool val);
   bool       get_transparency()   { return !opaque; }

   int        set_borders(bool val);
   bool       get_borders()   { return borders; }


   virtual ~ChipsLegend(); 
   virtual int redraw(); 
   virtual int change_position(); 
   virtual int change_thickness(); 
   virtual int change_transparency(); 
   virtual int change_borders(); 

  protected:

   int        cnt;           // number of items in legend

   list <string>curves;      // list of curve ids 
   list <string>labels;      // list of labels for the curves

   float      thickness;     // thickness of legend borders  
   bool       opaque;        // opaque or transparent background
   bool       borders;       // display border around legend 
   
};


#endif 
