// 
//  Copyright (C) 2004-2009  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSMESSAGES_HH
#define CHIPSMESSAGES_HH

// Messages
//
// The following macros define message identifiers used
// by the ChipsServer class for client server communication 

// Window Related Messages  
#define MSG_ADD_WINDOW_A      1000 
#define MSG_ADD_WINDOW_B      1002
#define MSG_ADD_WINDOW_C      1004
#define MSG_DEL_WINDOW        1010 
#define MSG_DEL_ALL_WINS      1012 
#define MSG_SHOW_LAYOUT       1014 
#define MSG_HIDE_LAYOUT       1015 
#define MSG_SHOW_GRID         1016 
#define MSG_HIDE_GRID         1017 
#define MSG_TILED_FRAME       1020
#define MSG_ROW_TILED_FRAME   1021
#define MSG_COL_TILED_FRAME   1022
#define MSG_SET_FRAMEMODE     1023
#define MSG_SINGLE_FRAME      1024
#define MSG_PREV_FRAME        1025
#define MSG_NEXT_FRAME        1026
#define MSG_PLACED_FRAME      1028
#define MSG_SET_WIN_TITLE     1030
#define MSG_GET_WIN_TITLE     1031
#define MSG_ICONIFY_WIN       1040
#define MSG_DEICONIFY_WIN     1042
#define MSG_SET_CURRENT_WIN   1050 
#define MSG_SET_GRID_STYLE    1060
#define MSG_SET_GRID_COLOR    1062
#define MSG_SET_GRID_THICK    1064
#define MSG_SET_GRID_SCALE    1066
#define MSG_SET_LAYOUT_STYLE  1070
#define MSG_SET_LAYOUT_COLOR  1072
#define MSG_SET_LAYOUT_THICK  1074
#define MSG_SET_WINDOW_COLOR  1080
#define MSG_GET_WINDOW_COLOR  1081
#define MSG_SET_WIN_DRAW_ON   1082
#define MSG_SET_WIN_DRAW_OFF  1083
#define MSG_GET_WIN_REDRAW    1084
#define MSG_SET_REDRAW        1085
#define MSG_PICK              1090
#define MSG_PICK_LIMITS       1092
#define MSG_GET_PICK          1095

// Frame Related Messages 
#define MSG_ADD_FRAME_A       1200
#define MSG_ADD_FRAME_B       1202
#define MSG_ADD_FRAME_C       1204
#define MSG_DEL_FRAME         1210 
#define MSG_DEL_ALL_FRAMES    1212 
#define MSG_REPOSITION_FRAME  1214
#define MSG_SET_FRAME_COLOR   1216
#define MSG_GET_FRAME_COLOR   1217
#define MSG_SET_FRAME_TRANS   1220
#define MSG_GET_FRAME_TRANS   1221
#define MSG_ARRANGE_FRAMES    1224
#define MSG_BLINK_FRAMES      1226
#define MSG_STOP_BLINK        1228
#define MSG_SET_CURRENT_FRM   1230
#define MSG_SET_FRAME_SCALE   1232
#define MSG_GET_FRAME_SCALE   1234
#define MSG_SET_FRAME_BCOLOR  1236
#define MSG_GET_FRAME_BCOLOR  1237
#define MSG_SET_FRAME_BVIS    1240
#define MSG_GET_FRAME_BVIS    1241
#define MSG_SET_FRAME_VIS     1245
#define MSG_GET_FRAME_VIS     1247

// Layer Related Messages 
#define MSG_GRID_OBJS         1450
#define MSG_GRID_OBJS_B       1452
#define MSG_GRID_GAP          1454
#define MSG_GRID_XGAP         1456
#define MSG_GRID_YGAP         1458
#define MSG_SWAP_OBJ_POS      1460
#define MSG_GRID_XRELSIZE     1462
#define MSG_GRID_YRELSIZE     1464
#define MSG_GRID_XRELSIZES    1466
#define MSG_GRID_YRELSIZES    1468

// Image Related Messages 
#define MSG_ADD_IMAGE         1600
#define MSG_ADD_IMAGE_B       1602
#define MSG_ADD_IMAGE_C       1604
#define MSG_ADD_IMAGE_D       1606
#define MSG_DEL_IMAGE         1610 
#define MSG_DEL_ALL_IMAGES    1612 
#define MSG_SET_CURRENT_IMG   1620
#define MSG_SET_IMG_CMAP      1622
#define MSG_GET_IMG_CMAP      1624
#define MSG_SET_IMG_INVCMAP   1626 
#define MSG_GET_IMG_INVCMAP   1628 
#define MSG_SET_IMG_CMAPSIZE  1630
#define MSG_GET_IMG_CMAPSIZE  1632
#define MSG_SET_IMG_CMAPINTRP 1634
#define MSG_GET_IMG_CMAPINTRP 1636
#define MSG_SET_IMG_INTERP    1638 
#define MSG_GET_IMG_INTERP    1640 
#define MSG_SET_IMG_ALPHA     1642
#define MSG_GET_IMG_ALPHA     1644
#define MSG_SET_IMG_THRESH    1646
#define MSG_GET_IMG_THRESH    1648
#define MSG_SET_IMG_DEPTH     1650
#define MSG_GET_IMG_DEPTH     1652
#define MSG_SET_IMG_VISIBLE   1654 
#define MSG_GET_IMG_VISIBLE   1656 
#define MSG_GET_IMG_RANGE     1658
#define MSG_GET_IMG_XRANGE    1660
#define MSG_GET_IMG_YRANGE    1662
#define MSG_SET_IMG_SCL_CHNNL 1664
#define MSG_GET_IMG_SCL_CHNNL 1666
#define MSG_ADD_IMAGE_CHANNEL 1670
#define MSG_DEL_IMAGE_CHANNEL 1672
#define MSG_PRINT_IMAGE       1678

#define MSG_ADD_CBAR          1700
#define MSG_DEL_CBAR          1702
#define MSG_SET_CBAR_LENGTH   1704
#define MSG_GET_CBAR_LENGTH   1706
#define MSG_SET_CBAR_WIDTH    1708
#define MSG_GET_CBAR_WIDTH    1710 
#define MSG_SET_CBAR_TITLE    1712 
#define MSG_GET_CBAR_TITLE    1714
#define MSG_SET_CBAR_HALIGN   1716
#define MSG_GET_CBAR_HALIGN   1718
#define MSG_SET_CBAR_VALIGN   1720
#define MSG_GET_CBAR_VALIGN   1721
#define MSG_SET_CBAR_DEPTH    1722 
#define MSG_GET_CBAR_DEPTH    1724 
#define MSG_SET_CBAR_VISIBLE  1726
#define MSG_GET_CBAR_VISIBLE  1728
#define MSG_SET_CURRENT_CBAR  1730
#define MSG_SET_CBAR_ORIENT   1732 
#define MSG_GET_CBAR_ORIENT   1734 
#define MSG_SET_CBAR_BVIS     1736 
#define MSG_GET_CBAR_BVIS     1737 
#define MSG_SET_CBAR_LAB_TXT  1738
#define MSG_GET_CBAR_LAB_TXT  1739
#define MSG_SET_CBAR_LAB_CLR  1740 
#define MSG_GET_CBAR_LAB_CLR  1741 
#define MSG_SET_CBAR_LAB_VIS  1742
#define MSG_GET_CBAR_LAB_VIS  1743
#define MSG_SET_CBAR_LAB_FONT 1744
#define MSG_GET_CBAR_LAB_FONT 1745
#define MSG_SET_CBAR_LAB_FSTY 1746 
#define MSG_GET_CBAR_LAB_FSTY 1747 
#define MSG_SET_CBAR_LAB_SZ   1748
#define MSG_GET_CBAR_LAB_SZ   1749
#define MSG_SET_CBAR_LAB_ANG  1750
#define MSG_GET_CBAR_LAB_ANG  1751
#define MSG_SET_CBAR_LAB_HAL  1752
#define MSG_GET_CBAR_LAB_HAL  1753
#define MSG_SET_CBAR_LAB_VAL  1754
#define MSG_GET_CBAR_LAB_VAL  1755
#define MSG_SET_CBAR_LAB_LOC   1756 
#define MSG_GET_CBAR_LAB_LOC   1757 
#define MSG_SET_CBAR_TL_CLR   1762 
#define MSG_GET_CBAR_TL_CLR   1763 
#define MSG_SET_CBAR_TL_SZ    1764 
#define MSG_GET_CBAR_TL_SZ    1765 
#define MSG_SET_CBAR_TL_OFF   1766 
#define MSG_GET_CBAR_TL_OFF   1767 
#define MSG_SET_CBAR_TL_ANG   1768
#define MSG_GET_CBAR_TL_ANG   1769
#define MSG_SET_CBAR_TL_HAL   1770
#define MSG_GET_CBAR_TL_HAL   1771
#define MSG_SET_CBAR_TL_VAL   1772
#define MSG_GET_CBAR_TL_VAL   1773
#define MSG_SET_CBAR_TL_FONT  1774
#define MSG_GET_CBAR_TL_FONT  1775
#define MSG_SET_CBAR_TL_FSTY  1776
#define MSG_GET_CBAR_TL_FSTY  1777
#define MSG_SET_CBAR_TL_VIS   1778
#define MSG_GET_CBAR_TL_VIS   1779
#define MSG_SET_CBAR_TK_THK   1780 
#define MSG_GET_CBAR_TK_THK   1781 
#define MSG_SET_CBAR_TK_STY   1782
#define MSG_GET_CBAR_TK_STY   1783
#define MSG_SET_CBAR_TK_MODE  1784
#define MSG_GET_CBAR_TK_MODE  1785
#define MSG_SET_CBAR_TK_CLR   1786
#define MSG_GET_CBAR_TK_CLR   1787
#define MSG_SET_CBAR_TK_LEN   1788
#define MSG_GET_CBAR_TK_LEN   1789
#define MSG_SET_CBAR_TK_VIS   1790
#define MSG_GET_CBAR_TK_VIS   1791
#define MSG_SET_CBAR_TK_LOC   1792
#define MSG_GET_CBAR_TK_LOC   1793
#define MSG_SET_CBAR_PERP_OFF 1794
#define MSG_GET_CBAR_PERP_OFF 1795
#define MSG_SET_CBAR_PAR_OFF  1796
#define MSG_GET_CBAR_PAR_OFF  1797




// Plot Related Messages 
#define MSG_ADD_PLOT          1800
#define MSG_ADD_PLOT_B        1802
#define MSG_SET_PLOT_DEPTH    1805
#define MSG_GET_PLOT_DEPTH    1806
#define MSG_DEL_PLOT          1810
#define MSG_DEL_ALL_PLOTS     1812
#define MSG_REPOSITION_PLOT   1814
#define MSG_SET_LIMITS_CID    1816
#define MSG_SET_LIMITS_OID    1818
#define MSG_SET_LIMITS_X      1820
#define MSG_SET_LIMITS_Y      1822
#define MSG_SET_LIMITS_XY     1824

#define MSG_SET_LIMITS_X_AA   1826
#define MSG_SET_LIMITS_Y_AA   1828
#define MSG_SET_LIMITS_XY_AA  1830
#define MSG_SET_LIMITS_X_AM   1832
#define MSG_SET_LIMITS_Y_AM   1834
#define MSG_SET_LIMITS_XY_AM  1836
#define MSG_SET_LIMITS_X_MA   1838
#define MSG_SET_LIMITS_Y_MA   1840
#define MSG_SET_LIMITS_XY_MA  1842
#define MSG_SET_LIMITS_XX_YY  1844

#define MSG_SET_LOGSCALE      1846
#define MSG_SET_LINEARSCALE   1848
#define MSG_GET_SCALE         1849
#define MSG_SET_PLOT_TITLE    1850
#define MSG_GET_PLOT_TITLE    1851
#define MSG_SET_PLOT_VISIBLE  1852
#define MSG_GET_PLOT_VISIBLE  1853
#define MSG_SET_CURRENT_PLT   1855
#define MSG_SET_PLOT_LMARGIN  1860
#define MSG_GET_PLOT_LMARGIN  1861
#define MSG_SET_PLOT_RMARGIN  1862
#define MSG_GET_PLOT_RMARGIN  1863
#define MSG_SET_PLOT_TMARGIN  1864
#define MSG_GET_PLOT_TMARGIN  1865
#define MSG_SET_PLOT_BMARGIN  1866
#define MSG_GET_PLOT_BMARGIN  1867
#define MSG_SET_PLOT_XLABEL   1870
#define MSG_SET_PLOT_YLABEL   1872
#define MSG_SET_PLOT_ZLABEL   1874
#define MSG_SET_PLOT_AX_STYLE 1876
#define MSG_GET_PLOT_AX_STYLE 1877
#define MSG_SET_TITLE_SIZE    1888
#define MSG_GET_TITLE_SIZE    1889
#define MSG_SET_TITLE_X_POS   1890
#define MSG_GET_TITLE_X_POS   1891
#define MSG_SET_TITLE_Y_POS   1892
#define MSG_GET_TITLE_Y_POS   1893
#define MSG_SET_TITLE_COLOR   1894
#define MSG_GET_TITLE_COLOR   1895
#define MSG_SET_TITLE_FONT    1896
#define MSG_GET_TITLE_FONT    1897
#define MSG_SET_TITLE_FNTSTYL 1898
#define MSG_GET_TITLE_FNTSTYL 1899
#define MSG_SET_TITLE_ANGLE   1900
#define MSG_GET_TITLE_ANGLE   1902 
#define MSG_SET_TITLE_HALIGN  1903
#define MSG_GET_TITLE_HALIGN  1904 
#define MSG_SET_TITLE_VALIGN  1905
#define MSG_GET_TITLE_VALIGN  1906 
#define MSG_GET_PLOT_XRANGE   1907 
#define MSG_GET_PLOT_YRANGE   1908 
#define MSG_GET_PLOT_RANGE    1909 
#define MSG_SET_PLOT_CORNER   1910
#define MSG_GET_PLOT_CORNER   1912
#define MSG_CLEAR_PLOT        1918

#define MSG_SET_PLOT_ASPRATIO 1920
#define MSG_GET_PLOT_ASPRATIO 1922
#define MSG_GET_PLOT_ASPW     1928
#define MSG_GET_PLOT_ASPH     1930
#define MSG_SET_DATA_ASPRATIO 1950
#define MSG_GET_DATA_ASPRATIO 1952

#define MSG_ZOOM_PLOT         1960
#define MSG_ZOOM_PLOT_GUI     1962
#define MSG_PAN_PLOT          1965
#define MSG_PANTO_PLOT        1967

// Curve Related Messages 
#define MSG_ADD_CURVE_A       2000
#define MSG_ADD_CURVE_B       2002
#define MSG_DEL_CURVE         2010
#define MSG_SET_CV_VISIBLE    2015
#define MSG_GET_CV_VISIBLE    2017 
#define MSG_SET_CV_SYMBOL     2020
#define MSG_GET_CV_SYMBOL     2021
#define MSG_SET_CV_SYM_SIZE   2022
#define MSG_GET_CV_SYM_SIZE   2023
#define MSG_SET_CV_SYM_COLOR  2024
#define MSG_GET_CV_SYM_COLOR  2025
#define MSG_SET_CV_SYM_FILL   2026
#define MSG_SET_CV_SYM_UNFILL 2027
#define MSG_GET_CV_SYM_FILL   2028
#define MSG_SET_CV_LINE_STYLE 2030
#define MSG_GET_CV_LINE_STYLE 2031
#define MSG_SET_CV_LINE_COLOR 2035
#define MSG_GET_CV_LINE_COLOR 2036
#define MSG_SET_CV_LINE_SIZE  2040
#define MSG_GET_CV_LINE_SIZE  2041
#define MSG_SET_CV_DEPTH      2045
#define MSG_GET_CV_DEPTH      2047
#define MSG_SET_CV_ERR_SIZE   2050
#define MSG_GET_CV_ERR_SIZE   2051
#define MSG_SET_CV_ERR_COLOR  2055
#define MSG_GET_CV_ERR_COLOR  2056
#define MSG_SET_CV_ERR_CAPLEN 2057
#define MSG_GET_CV_ERR_CAPLEN 2058
#define MSG_SET_CV_ERR_STYLE  2059
#define MSG_GET_CV_ERR_STYLE  2060
#define MSG_SET_CV_ERR_UP     2061
#define MSG_GET_CV_ERR_UP     2062
#define MSG_SET_CV_ERR_DOWN   2063
#define MSG_GET_CV_ERR_DOWN   2064
#define MSG_SET_CV_ERR_LEFT   2065
#define MSG_GET_CV_ERR_LEFT   2066
#define MSG_SET_CV_ERR_RIGHT  2067
#define MSG_GET_CV_ERR_RIGHT  2068
#define MSG_SET_CURRENT_CRV   2069
#define MSG_GET_CV_XRANGE     2070
#define MSG_GET_CV_YRANGE     2071
#define MSG_SET_CV_BADDATA    2072
#define MSG_GET_CV_BADDATA    2073
#define MSG_GET_CV_RANGE      2074
#define MSG_SET_CV_SYM_ANGLE  2075
#define MSG_GET_CV_SYM_ANGLE  2076

#define MSG_SET_CV_LIMLENGTH  2077
#define MSG_GET_CV_LIMLENGTH  2079
#define MSG_SET_CV_LIMOVRIDE  2080
#define MSG_GET_CV_LIMOVRIDE  2081

// Contour Related Messages
#define MSG_ADD_CONTOUR       2100
#define MSG_ADD_CONTOUR_B     2101
#define MSG_DEL_CONTOUR       2102
#define MSG_SET_CNTR_MODE     2104
#define MSG_GET_CNTR_MODE     2105
#define MSG_SET_CNTR_STYLE    2106
#define MSG_GET_CNTR_STYLE    2107
#define MSG_SET_CNTR_COLOR    2108
#define MSG_GET_CNTR_COLOR    2109
#define MSG_SET_CNTR_LEVELS   2110
#define MSG_GET_CNTR_LEVELS   2111
#define MSG_SET_CNTR_THICK    2112
#define MSG_GET_CNTR_THICK    2113
#define MSG_SET_CURRENT_CNTR  2115
#define MSG_GET_CNTR_XRANGE   2116
#define MSG_GET_CNTR_YRANGE   2117
#define MSG_GET_CNTR_ZRANGE   2118
#define MSG_GET_CNTR_RANGE    2119
#define MSG_SET_CNTR_ALG      2120
#define MSG_GET_CNTR_ALG      2121
#define MSG_SET_CNTR_INT      2122
#define MSG_GET_CNTR_INT      2123
#define MSG_SET_CNTR_NUMLEV   2124
#define MSG_GET_CNTR_NUMLEV   2125
#define MSG_SET_CNTR_DEPTH    2127
#define MSG_GET_CNTR_DEPTH    2129
#define MSG_SET_CNTR_XFORM    2131
#define MSG_GET_CNTR_XFORM    2132
#define MSG_APP_CNTR_XFORM    2133
#define MSG_INV_CNTR_XFORM    2134
#define MSG_SET_CNTR_VISIBLE  2135
#define MSG_GET_CNTR_VISIBLE  2137 

// Histogram Related Messages
#define MSG_ADD_HISTOGRAM     2150
#define MSG_DEL_HISTOGRAM     2152
#define MSG_SET_HST_DEPTH     2154
#define MSG_GET_HST_DEPTH     2155
#define MSG_SET_HST_VISIBLE   2156
#define MSG_GET_HST_VISIBLE   2157
#define MSG_SET_HST_SYMBOL    2158
#define MSG_GET_HST_SYMBOL    2159
#define MSG_SET_HST_SYM_SIZE  2160
#define MSG_GET_HST_SYM_SIZE  2161
#define MSG_SET_HST_SYM_COLOR 2162
#define MSG_GET_HST_SYM_COLOR 2163
#define MSG_SET_HST_SYM_FILL  2164
#define MSG_SET_HST_SYM_UNFIL 2165
#define MSG_GET_HST_SYM_FILL  2166
#define MSG_SET_HST_LINE_STYL 2167
#define MSG_GET_HST_LINE_STYL 2168
#define MSG_SET_HST_LINE_COLR 2169
#define MSG_GET_HST_LINE_COLR 2170
#define MSG_SET_HST_LINE_SIZE 2171
#define MSG_GET_HST_LINE_SIZE 2172
#define MSG_SET_HST_DROPLINE  2173
#define MSG_GET_HST_DROPLINE  2174
#define MSG_SET_HST_ERR_SIZE  2175
#define MSG_GET_HST_ERR_SIZE  2176
#define MSG_SET_HST_ERR_COLOR 2177
#define MSG_GET_HST_ERR_COLOR 2178
#define MSG_SET_HST_ERR_STYLE 2179
#define MSG_GET_HST_ERR_STYLE 2180
#define MSG_SET_HST_ERR_UP    2181
#define MSG_GET_HST_ERR_UP    2182
#define MSG_SET_HST_ERR_DOWN  2183
#define MSG_GET_HST_ERR_DOWN  2184
#define MSG_SET_HST_FILL_COLR 2185
#define MSG_GET_HST_FILL_COLR 2186
#define MSG_SET_HST_ERR_CPLEN 2187
#define MSG_GET_HST_ERR_CPLEN 2188
#define MSG_SET_HST_FILL_OPAC 2189
#define MSG_GET_HST_FILL_OPAC 2190
#define MSG_SET_HST_FILL_STYL 2191
#define MSG_GET_HST_FILL_STYL 2192
#define MSG_SET_CURRENT_HST   2194
#define MSG_GET_HST_XRANGE    2195
#define MSG_GET_HST_YRANGE    2196
#define MSG_GET_HST_RANGE     2197
#define MSG_SET_HST_SYM_ANGLE 2198
#define MSG_GET_HST_SYM_ANGLE 2199

// Label Related Messages
#define MSG_ADD_LABEL         2200
#define MSG_DEL_LABEL         2210 
#define MSG_SET_LAB_ANGLE     2220 
#define MSG_GET_LAB_ANGLE     2223
#define MSG_SET_LAB_HALIGN    2224 
#define MSG_GET_LAB_HALIGN    2225
#define MSG_SET_LAB_VALIGN    2226 
#define MSG_GET_LAB_VALIGN    2227
#define MSG_SET_LAB_SIZE      2230 
#define MSG_GET_LAB_SIZE      2233
#define MSG_SET_LAB_DEPTH     2237 
#define MSG_GET_LAB_DEPTH     2238
#define MSG_SET_LAB_COLOR     2240 
#define MSG_GET_LAB_COLOR     2243
#define MSG_SET_LAB_FONT      2250 
#define MSG_GET_LAB_FONT      2253
#define MSG_SET_LAB_STYLE     2260 
#define MSG_GET_LAB_STYLE     2263
#define MSG_SET_LAB_TEXT      2270 
#define MSG_GET_LAB_TEXT      2273
#define MSG_SET_LAB_VISIBLE   2280 
#define MSG_GET_LAB_VISIBLE   2281 
#define MSG_SET_CURRENT_LAB   2285

// Axis Related Messages
#define MSG_ADD_AXIS          2400
#define MSG_ADD_XAXIS         2402
#define MSG_ADD_YAXIS         2404
#define MSG_DEL_AXIS          2410
#define MSG_SET_AXIS_PAR_OFF  2416
#define MSG_GET_AXIS_PAR_OFF  2417
#define MSG_SET_AXIS_PERP_OFF 2418
#define MSG_GET_AXIS_PERP_OFF 2419
#define MSG_SET_AXIS_COLOR    2420
#define MSG_GET_AXIS_COLOR    2421
#define MSG_SET_AXIS_MAJ_CLR  2422
#define MSG_GET_AXIS_MAJ_CLR  2423
#define MSG_SET_AXIS_MIN_CLR  2424
#define MSG_GET_AXIS_MIN_CLR  2425
#define MSG_SET_AXIS_XLAB_TXT 2426
#define MSG_GET_AXIS_XLAB_TXT 2427
#define MSG_SET_AXIS_YLAB_TXT 2428
#define MSG_GET_AXIS_YLAB_TXT 2429
#define MSG_SET_AXIS_TEXT     2430
#define MSG_GET_AXIS_TEXT     2431
#define MSG_REVERSE_AXIS      2432
#define MSG_SET_AXIS_TICKSTYL 2435
#define MSG_GET_AXIS_TICKSTYL 2436
#define MSG_SET_AXIS_TICKFMT  2440
#define MSG_GET_AXIS_TICKFMT  2441
#define MSG_SET_AXIS_MAJ_MODE 2442
#define MSG_GET_AXIS_MAJ_MODE 2443
#define MSG_SET_AXIS_MIN_MODE 2444
#define MSG_GET_AXIS_MIN_MODE 2445
#define MSG_SET_AXIS_MAJ_STYL 2446
#define MSG_GET_AXIS_MAJ_STYL 2447
#define MSG_SET_AXIS_MIN_STYL 2448
#define MSG_GET_AXIS_MIN_STYL 2449
#define MSG_SET_AXIS_THICK    2450
#define MSG_GET_AXIS_THICK    2451
#define MSG_SET_AXIS_MAJ_THK  2452
#define MSG_GET_AXIS_MAJ_THK  2453
#define MSG_SET_AXIS_MIN_THK  2454
#define MSG_GET_AXIS_MIN_THK  2455
#define MSG_SET_AXIS_MAJ_NUM  2460
#define MSG_GET_AXIS_MAJ_NUM  2461
#define MSG_SET_AXIS_MIN_NUM  2465
#define MSG_GET_AXIS_MIN_NUM  2466
#define MSG_SET_AXIS_MAJ_LEN  2470
#define MSG_GET_AXIS_MAJ_LEN  2471
#define MSG_SET_AXIS_MIN_LEN  2475
#define MSG_GET_AXIS_MIN_LEN  2476
#define MSG_SET_AXIS_MAJ_INT  2477 
#define MSG_GET_AXIS_MAJ_INT  2478 
#define MSG_SET_AXIS_MIN_INT  2479 
#define MSG_GET_AXIS_MIN_INT  2480 
#define MSG_SET_AXIS_VISIBLE  2483 
#define MSG_GET_AXIS_VISIBLE  2484 
#define MSG_SET_AXIS_SCALABLE 2485 
#define MSG_SET_AXIS_MAJ_VIS  2486 
#define MSG_GET_AXIS_MAJ_VIS  2487 
#define MSG_SET_AXIS_MIN_VIS  2488 
#define MSG_GET_AXIS_MIN_VIS  2489 
#define MSG_SET_CURRENT_AXS   2490 
#define MSG_SET_AXSLB_HALIGN  2491
#define MSG_GET_AXSLB_HALIGN  2492
#define MSG_SET_AXSLB_VALIGN  2493 
#define MSG_GET_AXSLB_VALIGN  2494
#define MSG_SET_AXSLB_ANGLE   2498
#define MSG_GET_AXSLB_ANGLE   2499
#define MSG_SET_AXSLB_FONT    2500 
#define MSG_GET_AXSLB_FONT    2501 
#define MSG_SET_AXSLB_FNTSTYL 2502 
#define MSG_GET_AXSLB_FNTSTYL 2503 
#define MSG_SET_AXSLB_SIZE    2504 
#define MSG_GET_AXSLB_SIZE    2505 
#define MSG_SET_AXSLB_COLOR   2506 
#define MSG_GET_AXSLB_COLOR   2507 
#define MSG_SET_AXIS_TICKPOS  2508
#define MSG_SET_AXSTCKLB_STYL 2510
#define MSG_GET_AXSTCKLB_STYL 2511
#define MSG_SET_AXIS_PAD      2512
#define MSG_GET_AXIS_PAD      2513
#define MSG_SET_AXIS_AUTOMIN  2514  
#define MSG_GET_AXIS_AUTOMIN  2515  
#define MSG_SET_AXIS_AUTOMAX  2516  
#define MSG_GET_AXIS_AUTOMAX  2517  
#define MSG_SET_AXSG_MJ_CLR   2520 
#define MSG_GET_AXSG_MJ_CLR   2521 
#define MSG_SET_AXSG_MJ_STL   2522 
#define MSG_GET_AXSG_MJ_STL   2523 
#define MSG_SET_AXSG_MJ_VIS   2524 
#define MSG_GET_AXSG_MJ_VIS   2525 
#define MSG_SET_AXSG_MJ_SZ    2526 
#define MSG_GET_AXSG_MJ_SZ    2527 
#define MSG_SET_AXSG_MN_CLR   2530 
#define MSG_GET_AXSG_MN_CLR   2531 
#define MSG_SET_AXSG_MN_STL   2532 
#define MSG_GET_AXSG_MN_STL   2533 
#define MSG_SET_AXSG_MN_VIS   2534 
#define MSG_GET_AXSG_MN_VIS   2535 
#define MSG_SET_AXSG_MN_SZ    2536 
#define MSG_GET_AXSG_MN_SZ    2537 
#define MSG_SET_TCKLB_HALIGN  2538
#define MSG_GET_TCKLB_HALIGN  2539
#define MSG_SET_TCKLB_ANGLE   2540
#define MSG_GET_TCKLB_ANGLE   2541
#define MSG_SET_TCKLB_FONT    2542
#define MSG_GET_TCKLB_FONT    2543
#define MSG_SET_TCKLB_FNTSTYL 2544
#define MSG_GET_TCKLB_FNTSTYL 2545
#define MSG_SET_TCKLB_SIZE    2546
#define MSG_GET_TCKLB_SIZE    2547
#define MSG_SET_TCKLB_COLOR   2548
#define MSG_GET_TCKLB_OFFSET  2549
#define MSG_SET_TCKLB_OFFSET  2550
#define MSG_GET_TCKLB_COLOR   2551
#define MSG_SET_TCKLB_VIS     2552
#define MSG_GET_TCKLB_VIS     2554
#define MSG_SET_TCKLB_VALIGN  2555 
#define MSG_GET_TCKLB_VALIGN  2556
#define MSG_AXIS_BIND         2560
#define MSG_AXIS_UNBIND       2562
#define MSG_GET_AXIS_RANGE    2563
#define MSG_SET_AXSLB_VIS     2570
#define MSG_GET_AXSLB_VIS     2572
#define MSG_SET_AXIS_DEPTH    2581
#define MSG_GET_AXIS_DEPTH    2583
#define MSG_SET_AXIS_XLAB_ANG 2595
#define MSG_GET_AXIS_XLAB_ANG 2596
#define MSG_SET_AXIS_YLAB_ANG 2597
#define MSG_GET_AXIS_YLAB_ANG 2598

// Line Related Messages
#define MSG_ADD_LINE          2600
#define MSG_ADD_LINE_B        2602
#define MSG_DEL_LINE          2610
#define MSG_SET_LINE_STYLE    2615
#define MSG_GET_LINE_STYLE    2618
#define MSG_SET_LINE_COLOR    2620
#define MSG_GET_LINE_COLOR    2623
#define MSG_SET_LINE_THICK    2630
#define MSG_GET_LINE_THICK    2631
#define MSG_SET_LINE_VISIBLE  2632
#define MSG_GET_LINE_VISIBLE  2633
#define MSG_SET_CURRENT_LINE  2635
#define MSG_SET_LINE_DEPTH    2637 
#define MSG_GET_LINE_DEPTH    2638
#define MSG_SET_LINE_EXTEND   2639
#define MSG_GET_LINE_EXTEND   2640

// Point Related Messages
#define MSG_ADD_POINT         2800
#define MSG_ADD_POINT_B       2802
#define MSG_DEL_POINT         2810
#define MSG_SET_POINT_ANGLE   2820 
#define MSG_GET_POINT_ANGLE   2823
#define MSG_SET_POINT_COLOR   2830 
#define MSG_SET_POINT_VISIBLE 2832
#define MSG_GET_POINT_COLOR   2833
#define MSG_GET_POINT_VISIBLE 2835
#define MSG_SET_POINT_DEPTH   2837 
#define MSG_GET_POINT_DEPTH   2838
#define MSG_SET_POINT_FILL    2840 
#define MSG_GET_POINT_FILL    2843
#define MSG_SET_POINT_SYMBOL  2850 
#define MSG_GET_POINT_SYMBOL  2853
#define MSG_SET_POINT_SIZE    2860 
#define MSG_GET_POINT_SIZE    2863
#define MSG_SET_CURRENT_PNT   2865

// Legend Related Messages
#define MSG_ADD_LEGEND        3000
#define MSG_DEL_LEGEND        3002 
#define MSG_SET_LEGEND_VIS    3004
#define MSG_SET_LEGEND_TRANS  3006
#define MSG_SET_LEGEND_COLOR  3008
#define MSG_SET_LEGEND_THICK  3010
#define MSG_SET_LEGEND_BORDER 3012
#define MSG_SET_CURRENT_LGD   3020

// Region Messages
#define MSG_ADD_REGION        3400
#define MSG_ADD_REGION_B      3402
#define MSG_DEL_REGION        3406
#define MSG_SET_REGN_ANGLE    3420
#define MSG_GET_REGN_ANGLE    3423
#define MSG_SET_REGN_THICK    3430
#define MSG_GET_REGN_THICK    3433
#define MSG_SET_REGN_STYLE    3440
#define MSG_GET_REGN_STYLE    3443
#define MSG_SET_REGN_EDGCOL   3450
#define MSG_GET_REGN_EDGCOL   3453
#define MSG_SET_REGN_FILCOL   3460
#define MSG_GET_REGN_FILCOL   3463
#define MSG_SET_REGN_FILSTYL  3466
#define MSG_GET_REGN_FILSTYL  3468
#define MSG_SET_REGN_OPACITY  3470
#define MSG_GET_REGN_OPACITY  3473
#define MSG_SET_REGN_DEPTH    3476 
#define MSG_GET_REGN_DEPTH    3478
#define MSG_SET_REGN_VISIBLE  3480
#define MSG_GET_REGN_VISIBLE  3483
#define MSG_SET_CURRENT_REGN  3490


#define MSG_LOAD_PREFS_A      5000
#define MSG_LOAD_PREFS_B      5002
#define MSG_SAVE_PREFS        5010
#define MSG_SET_PREFERENCE    5014
#define MSG_GET_PREFERENCE    5016
#define MSG_SET_CASCADE       5050
#define MSG_MOVE              5100

// Coordinate Related Messages
#define MSG_ADD_TRANSFORM     7000
#define MSG_REMOVE_TRANSFORM  7005
#define MSG_APPLY_TRANS_A     7010
#define MSG_APPLY_TRANS_B     7012
#define MSG_INVERT_TRANS      7020
#define MSG_CONVERT_COORD_A   7030
#define MSG_CONVERT_COORD_B   7031

// Print Messages             
#define MSG_PRINT_WINDOW      8900
#define MSG_PRINT_FRAME       8902
#define MSG_SET_EXPORT_FONTS  8904
#define MSG_GET_EXPORT_FONTS  8905
#define MSG_SET_EXPORT_ORIENT 8906
#define MSG_GET_EXPORT_ORIENT 8907

// Misc Messages 
#define MSG_INFO_REQUEST      9000
#define MSG_INFO_BOUND_REQUEST 9002
#define MSG_INFO_COORD_REQUEST 9003
#define MSG_INFO_DEPTH_REQUEST 9004
#define MSG_CURRENT_REQUEST   9005
#define MSG_INFO_RESPONSE     9009
#define MSG_HILITE_OBJ        9015
#define MSG_GET_OBJ_COUNT     9020
#define MSG_GET_OBJ_COORD     9030
#define MSG_ADD_CLIENT_ERR    9035
#define MSG_GET_ERRS          9040
#define MSG_SET_ERR_VERB      9050
#define MSG_GET_ERR_VERB      9060
#define MSG_GET_ERR_CNT       9070
#define MSG_GET_ERR_TYPES     9080
#define MSG_CLEAR_ERRS        9090
#define MSG_LOAD_FONT         9100
#define MSG_LOAD_FILL         9125
#define MSG_LOAD_CMAP         9135
#define MSG_LOAD_CMAP_ARRAY   9136
#define MSG_SET_LINE_STIPPLE  9150
#define MSG_GET_LINE_STIPPLE  9152
#define MSG_UNDO              9200
#define MSG_UNDO_TAG          9205
#define MSG_OPEN_UNDO_BLK     9210
#define MSG_CLOSE_UNDO_BLK    9220
#define MSG_SET_UNDO_TAG      9230
#define MSG_CLEAR_UNDO_TAG    9240
#define MSG_REDO              9250
#define MSG_REDO_TAG          9255
#define MSG_OPEN_UNDO_BUFF    9260
#define MSG_CLOSE_UNDO_BUFF   9270
#define MSG_CLEAR_UNDO_BUFF   9280
#define MSG_LOAD_STATE        9300
#define MSG_SAVE_STATE        9350
#define MSG_SAVE_STATE_B      9355
#define MSG_SET_DEF_DEPTH     9371
#define MSG_GET_DEF_DEPTH     9372
#define MSG_COLLAPSE_DEPTH    9373 
#define MSG_REARRANGE_DEPTH   9374
#define MSG_DISPLAY_DEPTH     9375
#define MSG_HIDE_DEPTH        9378
#define MSG_SHOW_GUI          9500
#define MSG_HIDE_GUI          9510
#define MSG_CMDLNE_CONN       9520
#define MSG_SET_CWD           9600
#define MSG_GET_CWD           9610
#define MSG_GET_SERVER_ID     9995
#define MSG_LOCK              9997 
#define MSG_UNLOCK            9998 
#define MSG_QUIT              9999 


// Type identifiers used by server to pass data back
// to client in response to MSG_INFO_REQUEST 
#define MSG_DATATYPE_DOUBLE      2
#define MSG_DATATYPE_FLOAT       4
#define MSG_DATATYPE_LONG        8
#define MSG_DATATYPE_ULONG       9
#define MSG_DATATYPE_INT        16
#define MSG_DATATYPE_UINT       17
#define MSG_DATATYPE_SHORT      32
#define MSG_DATATYPE_USHORT     33
#define MSG_DATATYPE_CHAR       64
#define MSG_DATATYPE_UCHAR      65


#endif 
