// 
//  Copyright (C) 2007  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSPOLYGON_HH
#define CHIPSPOLYGON_HH

#include <string>
#include <iostream>
#include <stdio.h>
#include "ChipsObject.hh"
#include "ChipsDefaults.hh"
#include "ChipsLabel.hh"
#include "ChipsColor.hh"
#include "ChipsStateStream.hh"
#include "ChipsRegion.hh"

using namespace std;


class ChipsPolygon: public ChipsRegion
{
  public:

   ChipsPolygon(ChipsObject* par, ChipsCoordinate *inCoord, COORD_SYS coord_sys,
               double* xcoords, double* ycoords, unsigned int cnt, string val);
   ChipsPolygon(ChipsObject* par, ChipsCoordinate *inCoord, COORD_SYS coord_sys,
               int sides, double xcoord, double ycoord, double radius, 
               string val);
   ChipsPolygon(ChipsObject* par, ChipsCoordinate *inCoord, COORD_SYS coord_sys,
                ChipsStateStream& in);

   virtual ~ChipsPolygon();
   virtual void serialize(ChipsStateStream& out);
   virtual void serialize_ascii(ChipsStateStream& out);
   virtual void deserialize(ChipsStateStream& in);

  protected:
   double radinp; // input radius for ngon

};

#endif 
