// 
//  Copyright (C) 2007  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#include "ChipsPrefCommand.hh"
#include "ChipsDefaults.hh"
#include "ChipsStateStream.hh"

extern ChipsDefaults* theDefaults; 

ChipsPrefCommand::ChipsPrefCommand(string pname, string oldv, string newv)
{
   weight=1;
   co = NULL;
   oval = pname;
   oval.append(":");
   oval.append(oldv);
   nval = pname;
   nval.append(":");
   nval.append(newv);
}

ChipsPrefCommand::~ChipsPrefCommand()
{
}


ChipsPrefCommand::ChipsPrefCommand(ChipsStateStream& in)
{
   deserialize(in);
   weight=1;
}

int ChipsPrefCommand::execute ()
{
   return theDefaults->parseLine(nval.c_str(), ':', false);
}

int ChipsPrefCommand::unexecute ()
{
   return theDefaults->parseLine(oval.c_str(), ':', false);
}

void ChipsPrefCommand::serialize(ChipsStateStream& out)
{
   int val = 14;
   int type = (int)chips_not_object;
   out.write_int(&val);
   out.write_int(&type);
   out.write_int(&ref);
   out.write_int(&block_ref);
   out.write_string (&oval);
   out.write_string (&nval);
}

void ChipsPrefCommand::deserialize(ChipsStateStream& in)
{
   in.read_int(&ref);
   in.read_int(&block_ref);

   in.read_string (&oval);
   in.read_string (&nval);
}

void ChipsPrefCommand::print ()
{
   cerr << "   [ "<<ref<<", "<< block_ref <<"] " <<"Set Preference " << endl;
};



