// 
//  Copyright (C) 2007  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSREPOCOMMAND_HH
#define CHIPSREPOCOMMAND_HH

#include "ChipsCommand.hh"
#include <string>

class ChipsStateStream;

class ChipsRepoCommand : public ChipsCommand
{
   public:
      ChipsRepoCommand(ChipsObject *new_co, float ollx, float olly, float ourx,
                      float oury, float nllx, float nlly, float nurx, 
                      float nury, string oldcurr);
      ChipsRepoCommand(ChipsObject* cob, ChipsStateStream& in);
      virtual ~ChipsRepoCommand();
      virtual int execute();
      virtual int unexecute();
      virtual int clear() {return ERR_STATUS_GOOD;};
      virtual void print();
      virtual void serialize(ChipsStateStream& out);
      virtual void deserialize(ChipsStateStream& in);
   protected:
      string current;
      float   o_llx;
      float   o_lly;
      float   o_urx;
      float   o_ury;
      float   n_llx;
      float   n_lly;
      float   n_urx;
      float   n_ury;
};

#endif

