// 
//  Copyright (C) 2006,2007  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPS_TEXT_SUPPORT_HH
#define CHIPS_TEXT_SUPPORT_HH

using namespace std;

#include <string>
#include <stdio.h>

#include "ChipsColor.hh"
#include "ChipsDefines.hh"

typedef struct elem_t
{
   string         text;      // text of characters to print
   string         fontfile;  // path/font to use
   int            size;      // point size of font
   ChipsColor     color;     // color info for this element
   struct elem_t  *super;    // superscript for this element
   struct elem_t  *next;     // next normal text item
   struct elem_t  *sub;      // subscript for this element
   struct elem_t  *parent;   // descended from what elem?
} ELEM_T, *ELEM_P_T, **ELEM_PP_T;


extern int format_text(const string &text, 
                       const string &def_font, 
                       V_FONTSTYLE_TYPE def_style, 
                       const string &def_color, 
	               int def_size,
                       ELEM_PP_T result); 

extern int delete_tree(ELEM_P_T iter); 

#endif
