// 
//  Copyright (C) 2007  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSZOOMCOMMAND_HH
#define CHIPSZOOMCOMMAND_HH

#include "ChipsCommand.hh"

class ChipsStateStream;
class ChipsId;
class ChipsFrame;

class ChipsZoomCommand : public ChipsCommand
{
   public:
      ChipsZoomCommand(ChipsFrame* obj, float scale_, ChipsId *cid_);
      ChipsZoomCommand(ChipsObject* cob, ChipsStateStream& in);
      virtual ~ChipsZoomCommand();
      virtual int execute();
      virtual int unexecute();
      virtual int clear() {return ERR_STATUS_GOOD;};
      virtual void print();
      virtual void serialize(ChipsStateStream& out);
      virtual void deserialize(ChipsStateStream& in);
   protected:
      float scale;
      ChipsId *cid;
};

#endif

