// 
//  Copyright (C) 2007  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSEVENTOBSERVER_HH
#define CHIPSEVENTOBSERVER_HH

#include "ChipsEventManager.hh"

#include <list>



// Interface to the Event Manager
class ChipsEventObserver
{
   public:
      ChipsEventObserver ();
      virtual ~ChipsEventObserver ();

      virtual void execute_event (int event, void *data)=0;

   protected:

      void register_event (int event);
      void unregister_event (int event);
      
      list<int> registered_events;
   
};

#endif

