// 
//  Copyright (C) 2008-2009  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPS_GTKWINDOW_HH
#define CHIPS_GTKWINDOW_HH

#include <gtk/gtk.h>
#include <gdk/gdkx.h>
#include <gtk/gtkgl.h>

#include <string>
#include <map>

using namespace std;

class ChipsWindow;

class ChipsGtkWindow
{

   public:
      ChipsGtkWindow (ChipsWindow *parent, string geom="", bool focus=FALSE);
      virtual ~ChipsGtkWindow  ();

      void show_window ();
      void hide_window ();

      void *get_xwindow ();

      void set_title (const string &title);
      void get_title (string &title);
      void set_default_size (int width, int height);
      void get_default_size (int &width, int &height);

      void iconify ();
      void deiconify ();

      void draw_rectangle (bool filled, int x, int y, int width, int height);
      void set_fg_color (float red, float green, float blue);

      void setEventSafe (bool flag) {this->eventSafeFlag = flag;};
      bool getEventSafe () {return this->eventSafeFlag;};



      static void on_realize (GtkWidget *widget, gpointer data);
      static gboolean on_delete (GtkWidget *widget, GdkEvent *event, gpointer data);
      static void on_expose (GtkWidget *widget, GdkEvent *event, gpointer data);
      static void on_configure (GtkWidget *widget, GdkEvent *event, gpointer data);
      static void on_enter (GtkWidget *widget, GdkEvent *event, gpointer data);
      static void on_leave (GtkWidget *widget, GdkEvent *event, gpointer data);
      static void on_focus (GtkWidget *widget, GdkEvent *event, gpointer data);


   protected:
      GtkWidget * window;
      GtkWidget * drawing_area;

      ChipsWindow *parent;

      bool eventSafeFlag;

      static GdkGLConfig *glconfig;

      bool has_focus;
};

#endif
      


