// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSGUIADDLABELDIALOG_HH
#define CHIPSGUIADDLABELDIALOG_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <string>

#include "ChipsEventObserver.hh"
#include "ChipsGuiTooltipObject.hh"

class ChipsObject; 

using namespace std;

/*******************************************************
*  ChipsGuiAddLabelDialog
*
*  Dialog used when adding a label interactively 
********************************************************/

class ChipsGuiAddLabelDialog : public ChipsEventObserver, public ChipsGuiTooltipObject
{
  public:
    ChipsGuiAddLabelDialog();
    virtual ~ChipsGuiAddLabelDialog();

    void         build_form(); 

    virtual void execute_event (int event, void *data);

  protected:

    static void  text_change_callback(GtkWidget *object, gpointer user_data);
    static void  text_activate_callback (GtkWidget *object, gpointer user_data);
    static bool  cleanup_callback(GtkWidget *wid, GdkEvent *event, gpointer data);

    void         set_text (const string &text);
    void         close_dialog ();

    GtkWidget *_dialog;
    GtkWidget *_text;
    bool       label_added; 

  // signals for callbacks
  unsigned long _text_id;
  unsigned long _text_activate_id;


};

#endif 
