// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSGUIANNOTATEMENU_HH
#define CHIPSGUIANNOTATEMENU_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <string>

#include "ChipsGuiTooltipObject.hh"
#include "ChipsEventObserver.hh"

using namespace std;

class ChipsGuiAnnotateMenu : public ChipsEventObserver, public ChipsGuiTooltipObject
{
  public:
    ChipsGuiAnnotateMenu();
    virtual ~ChipsGuiAnnotateMenu();

    static int  add_cb(GtkMenuItem *mitem, gpointer user_data);

    virtual int show();
    virtual int hide();


    GtkWidget*  base_widget()   { return base_w; }

    virtual void execute_event (int event, void *data);

    void set_sensitivity (bool enable);

  protected:

    int add_object(int substate);

    GtkWidget *base_w; 
    GtkWidget *menu;
    GtkWidget *menuItemAddPoint;
    GtkWidget *menuItemAddLine;
    GtkWidget *menuItemAddVLine;
    GtkWidget *menuItemAddHLine;
    GtkWidget *menuItemAddPolygon;
    GtkWidget *menuItemAddEllipse;
    GtkWidget *menuItemAddBox;
    GtkWidget *menuItemAddLabel;
    GtkWidget *menuItemAddColorBar;



    bool _enabled;
};

#endif 
