// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//

#ifndef CHIPSGUICOLORBARFRAME_HH
#define CHIPSGUICOLORBARFRAME_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>

#include "ChipsGuiPropFrame.hh"
#include "ChipsGuiTooltipObject.hh"

using namespace std;

class ChipsGuiColorBarPropWidget;

//---------------------------------------------------------------------------

class ChipsGuiColorBarFrame : public ChipsGuiPropFrame, public ChipsGuiTooltipObject
{
public:

  ChipsGuiColorBarFrame();
  virtual ~ChipsGuiColorBarFrame();

  static void thick_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void tickmode_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void width_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void length_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void orientation_callback(ChipsGuiColorBarPropWidget *widget, void *data);

  static void label_color_change_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void label_angle_change_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void label_text_change_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void label_font_change_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void label_fontstyle_change_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void label_valign_change_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void label_halign_change_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void label_size_change_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void label_perpendicular_offset_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void label_parallel_offset_callback(ChipsGuiColorBarPropWidget *widget, void *data);

  static void label_visible_change_callback(ChipsGuiColorBarPropWidget *widget, void *data);

  static void tick_color_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void tick_style_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void tick_length_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void tick_visible_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void tick_location_callback(ChipsGuiColorBarPropWidget *widget, void *data);

  static void ticklabel_color_callback (ChipsGuiColorBarPropWidget *widget, void *data);
  static void ticklabel_font_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void ticklabel_fontstyle_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void ticklabel_size_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void ticklabel_angle_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void ticklabel_offset_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void ticklabel_halign_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void ticklabel_valign_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void ticklabel_visible_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void halign_change_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void valign_change_callback(ChipsGuiColorBarPropWidget *widget, void *data);

  static void depth_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void visible_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void border_visible_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void position_callback(ChipsGuiColorBarPropWidget *widget, void *data);
  static void coordinate_callback(ChipsGuiColorBarPropWidget *widget, void *data);

  virtual void initialize(ChipsId* id);
  virtual void build_form(); 

  virtual void display_subobject (V_SUBOBJECT_TYPE subtype);

private:

   ChipsGuiColorBarPropWidget*   _cbarprop;

};

#endif
