// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSGUIEDITMENU_HH
#define CHIPSGUIEDITMENU_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <string>

#include "ChipsGuiTooltipObject.hh"

using namespace std;

class ChipsGuiEditMenu: public ChipsGuiTooltipObject
{
  public:
    ChipsGuiEditMenu();
    virtual ~ChipsGuiEditMenu();

    static int  undo_cb();
    static int  clear_cb(gpointer user_data);
    static int  redo_cb();
    static int  prefs_cb();
    static int  config_cb();

    virtual int show();

    void   set_undo_redo_sensitivity(bool undo, bool redo);

    GtkWidget*  base_widget()   { return base_w; }

  protected:
    GtkWidget *base_w; 
    GtkWidget *menu;
    GtkWidget *menuItemUndo;
    GtkWidget *menuItemRedo;
    GtkWidget *menuItemClear;
    GtkWidget *menuItemClearP;
    GtkWidget *menuItemPrefs;       // chips defaults 
    GtkWidget *menuItemConfig;      // gui configuration settings
    GtkWidget *sep;                 // separator 
    GtkWidget *sep2;                // separator 
};

#endif 
