// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSGUIFILEMENU_HH
#define CHIPSGUIFILEMENU_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <string>

#include "ChipsGuiTooltipObject.hh"

#define CHIPSGUI_FLIST_SZ        10

using namespace std;

class ChipsGuiFileMenu: public ChipsGuiTooltipObject
{
  public:
    ChipsGuiFileMenu();
    virtual ~ChipsGuiFileMenu();

    static int  print_cb();
    static int  saveas_cb(GObject *object, gpointer user_data);
    static int  quit_cb();

    static int  filelist_cb(gchar* buf);

  virtual int show();

    void        set_prev_dir(string fname)  { _prev_dir = fname; }
    const char* get_prev_dir()     { return _prev_dir.c_str(); }
    void        load_recent_submenu(); 
    void        update_filelist(string file); 

    GtkWidget*  base_widget()   { return base_w; }

  protected:
    GtkWidget *base_w; 
    GtkWidget *menu;
    GtkWidget *menuItemSaveAs;
    GtkWidget *menuItemPrint;
    GtkWidget *sep;                 // separator 
    GtkWidget *menuItemQuit;
    string    _prev_dir;            // previous directory
    string    _filelist;            // name of file containing opened file list
    GtkWidget *_filelistItem[CHIPSGUI_FLIST_SZ];
};

#endif 
