// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//

#ifndef CHIPSGUIFONTINFO_HH
#define CHIPSGUIFONTINFO_HH

#include <gtk/gtk.h>
#include <list>
#include <string>

using namespace std;

class ChipsGuiFontInfo
{
   public:
      ChipsGuiFontInfo ();
      ~ChipsGuiFontInfo ();

      void initialize ();
      void update_font_list ();

      GtkListStore * get_font_list () {return _font_list;};
      GtkListStore * get_size_list () {return _size_list;};

      int  get_table_size ()          {return _table_size;};


   protected:

      void build_font_list (GtkListStore* font_list);
      void build_size_list (GtkListStore* size_list);

      GtkListStore*   _font_list;
      GtkListStore*   _size_list;

      list<string>    _font_names;

      bool            _initialized;
      int             _table_size; 

};


#endif


