// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//

#ifndef CHIPSGUIFRAMEFRAME_HH
#define CHIPSGUIFRAMEFRAME_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>

#include "ChipsGuiPropFrame.hh"
#include "ChipsGuiTooltipObject.hh"

using namespace std;

class ChipsGuiColorWidget;
//---------------------------------------------------------------------------

class ChipsGuiFrameFrame: public ChipsGuiPropFrame, ChipsGuiTooltipObject
{
public:

  ChipsGuiFrameFrame();
  virtual ~ChipsGuiFrameFrame();

  static void color_callback(ChipsGuiColorWidget *widget, void *data);
  static void bordercolor_callback(ChipsGuiColorWidget *widget, void *data);
  static void bordervis_callback(GtkWidget *widget, gpointer data);
  static void scale_callback(GtkWidget *widget, gpointer data);
  static void trans_callback(GtkWidget *widget, gpointer data);

  virtual void initialize(ChipsId* id);

  virtual void display_subobject (V_SUBOBJECT_TYPE subtype) {};
  virtual void build_form(); 

  void set_scale(bool val); 
  void set_bordervis(bool val); 
  void set_color(string color); 
  void set_bordercolor(string color); 
  void set_trans(bool fill); 

private:
  
  GtkWidget*   _frame_bg; 
  GtkWidget*   _frame_bdr; 
  GtkWidget*   _table;
  GtkWidget*   _table_bg;
  GtkWidget*   _table_bdr;
  ChipsGuiColorWidget*   _color;
  ChipsGuiColorWidget*   _bordercolor;
  GtkWidget*   _scale;
  GtkWidget*   _trans;
  GtkWidget*   _bordervis;

  // signals for callbacks 
  unsigned long _scale_id; 
  unsigned long _trans_id; 
  unsigned long _bordervis_id; 

  bool         _bordervisval;
  bool         _scaleval;
  bool         _transval;

};

#endif
