// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSGUIGRIDPROPDIALOG_HH
#define CHIPSGUIGRIDPROPDIALOG_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <string>


using namespace std;

class ChipsGuiColorWidget;

class ChipsGuiGridPropDialog
{
  public:
    ChipsGuiGridPropDialog();
    ~ChipsGuiGridPropDialog();
    int show();

    int doit(); 
    void initialize(int load=1); 
    void change_color_value(const char *val); 
    void set_scale_value(int val); 
    void set_style_value(int val); 
    void set_thickness_value(float val); 

    static void color_cb(ChipsGuiColorWidget *widget, void *data);
    static void style_changed_cb(GtkWidget *widget, gpointer data);
    static void scale_changed_cb(GtkWidget *widget, gpointer data);
    static void thickness_changed_cb(GtkWidget *widget, gpointer data);

  protected:
    void generate_form(); 

    GtkWidget* base_w; 
    GtkWidget* _table; 
    ChipsGuiColorWidget* _color;
    GtkWidget* _style;
    GtkWidget* _thickness;
    GtkWidget* _scale;
    GtkWidget* _label[4]; 
    gulong     _style_sigid;  
    gulong     _scale_sigid;  
    gulong     _thick_sigid;  
    bool       _updatecolor; 
    string     _colorv;      // color chooser set value
    string     _colorval;    // initial color value 
    int        _scaleval;    // initial scale value
    int        _styleval;    // initial style value
    float      _thickval;    // initial thickness value 
    int        _scalecv;     // current scale value
    int        _stylecv;     // current style value
    float      _thickcv;     // current thickness value 

};

#endif 
