// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSGUIHELPMENU_HH
#define CHIPSGUIHELPMENU_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>

using namespace std;

#include "ChipsGuiTooltipObject.hh"

class ChipsGuiRefMan; 

class ChipsGuiHelpMenu: public ChipsGuiTooltipObject
{
  public:
    ChipsGuiHelpMenu();
    virtual ~ChipsGuiHelpMenu();

    static int reference_manual_cb(gpointer data);
    static int faq_cb();
    static int about_cb();
    static int acknowledgement_cb();

    virtual int show();

    GtkWidget*  base_widget()   { return base_w; }

    void launch_ref_manual(); 
    void cleanup(); 

  protected:
    GtkWidget *menu;
    GtkWidget *menuRef;
    GtkWidget *menuFaq;
    GtkWidget *menuAbout;
    GtkWidget *menuAck;
    GtkWidget *sep; 
    GtkWidget *base_w; 
    ChipsGuiRefMan* refMan; 
};

#endif 
