// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//

#ifndef CHIPSGUILABELFRAME_HH
#define CHIPSGUILABELFRAME_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>

#include "ChipsGuiPropFrame.hh"
#include "ChipsGuiTooltipObject.hh"

using namespace std;

class ChipsGuiLabelPropWidget;

//---------------------------------------------------------------------------

class ChipsGuiLabelFrame : public ChipsGuiPropFrame, public ChipsGuiTooltipObject
{
public:

  ChipsGuiLabelFrame();
  virtual ~ChipsGuiLabelFrame();

  static void text_change_callback(ChipsGuiLabelPropWidget *widget, void *data);
  static void font_change_callback(ChipsGuiLabelPropWidget *widget, void *data);
  static void fontstyle_change_callback(ChipsGuiLabelPropWidget *widget, void *data);
  static void size_change_callback(ChipsGuiLabelPropWidget *widget, void *data);
  static void angle_change_callback(ChipsGuiLabelPropWidget *widget, void *data);
  static void position_change_callback(ChipsGuiLabelPropWidget *widget, void *data);
  static void coordinate_callback(ChipsGuiLabelPropWidget *widget, void *data);
  static void halign_change_callback(ChipsGuiLabelPropWidget *widget, void *data);
  static void valign_change_callback(ChipsGuiLabelPropWidget *widget, void *data);
  static void depth_callback(ChipsGuiLabelPropWidget *widget, void *data);
  static void vis_callback(ChipsGuiLabelPropWidget *widget, void *data);
  static void color_change_callback(ChipsGuiLabelPropWidget *widget, void *data);

  virtual void initialize(ChipsId* id);
  virtual void build_form(); 

  virtual void display_subobject (V_SUBOBJECT_TYPE subtype) {};

  void set_angle(float val); 
  void set_depth(int val); 
  void set_color(const string &color); 
  void set_font(const string &val);
  void set_fontstyle(int val);
  void set_halign(float val);
  void set_valign(float val);
  void set_size(int val);
  void set_text(const string &val);
  void set_position (double xpos, double ypos);
  void set_visibility(bool val);
  void set_coordinate (int coordinate);

private:

  ChipsGuiLabelPropWidget*   _labelprop;
};

#endif
