// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//

#ifndef CHIPSGUILINEFRAME_HH
#define CHIPSGUILINEFRAME_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>

#include "ChipsGuiPropFrame.hh"
#include "ChipsGuiTooltipObject.hh"

using namespace std;

class ChipsGuiLinePropWidget;

//---------------------------------------------------------------------------

class ChipsGuiLineFrame: public ChipsGuiPropFrame, public ChipsGuiTooltipObject
{
public:

  ChipsGuiLineFrame();
  virtual ~ChipsGuiLineFrame();

  static void color_callback(ChipsGuiLinePropWidget *widget, gpointer data);
  static void style_callback(ChipsGuiLinePropWidget *widget, gpointer data);
  static void thick_callback(ChipsGuiLinePropWidget *widget, gpointer data);
  static void depth_callback(ChipsGuiLinePropWidget *widget, gpointer data);
  static void extent_callback(ChipsGuiLinePropWidget *widget, gpointer data);
  static void vis_callback(ChipsGuiLinePropWidget *widget, gpointer data);
  static void position_callback(ChipsGuiLinePropWidget *widget, void *data);
  static void coordinate_callback(ChipsGuiLinePropWidget *widget, void *data);

  virtual void initialize(ChipsId* id);
  virtual void build_form(); 

  virtual void display_subobject (V_SUBOBJECT_TYPE subtype) {};

  void set_style(int val); 
  void set_depth(int val); 
  void set_color(string color); 
  void set_thick(float val);
  void set_extent(int extent); 
  void set_visibility(bool val);
  void set_position (double xpos, double ypos);
  void set_coordinate (int coordinate);

private:
  
  ChipsGuiLinePropWidget*   _lineprop;
};

#endif
