// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSGUIMENU_HH
#define CHIPSGUIMENU_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <string>

using namespace std;

class ChipsGuiFileMenu;
class ChipsGuiEditMenu;
class ChipsGuiViewMenu;
class ChipsGuiPlugInMenu;
class ChipsGuiHelpMenu;
class ChipsGuiAnnotateMenu;


class ChipsGuiMenu
{
  public:
    ChipsGuiMenu(string filename="");
    ~ChipsGuiMenu();

    int load_plugin_menu(string fname); 
    int show(); 
    GtkWidget*  base_widget()  { return base_w; }

    ChipsGuiHelpMenu* get_help_menu() { return menuHelp; }
    ChipsGuiEditMenu* get_edit_menu() { return menuEdit; }
    ChipsGuiViewMenu* get_view_menu() { return menuView; }
    ChipsGuiAnnotateMenu *get_annotate_menu () { return menuAnnotate; }

  protected:
    GtkWidget* base_w;
    ChipsGuiFileMenu  *menuFile;
    ChipsGuiEditMenu  *menuEdit;
    ChipsGuiViewMenu  *menuView;
    ChipsGuiPlugInMenu *menuPlug;
    ChipsGuiHelpMenu  *menuHelp;
    ChipsGuiAnnotateMenu *menuAnnotate;
};

#endif 
