// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSGUIPLUGINMENU_HH
#define CHIPSGUIPLUGINMENU_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <string>
#include <map>

using namespace std;

typedef struct plugin_elem_t
{
   GtkWidget* widget;
   string     title; 
   string     filename;
   string     funcname; 
   string     cmd; 
   unsigned long sigid; 
} PLUGIN_ELEM_T, *PLUGIN_ELEM_P_T;

typedef map <string, PLUGIN_ELEM_P_T>plugin_map;

class ChipsGuiPlugInMenu
{
  public:
    ChipsGuiPlugInMenu();
    virtual ~ChipsGuiPlugInMenu();

    virtual int show();

    int menu_size()  { return items.size(); } 
    int load_file(string fname);
    int add_entry(string title, string file, string funcname); 
    int remove_entry(string funcname); 
    void set_sensitive(int val = -1); 

    static void run_custom_callback(GtkWidget *widget, gpointer data); 

    GtkWidget*  base_widget()   { return base_w; }

  protected:
    GtkWidget *base_w; 
    GtkWidget *menu;
    //WLMmap <string, PLUGIN_ELEM_P_T> items;
    plugin_map items;

};

#endif 
