// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//

#ifndef CHIPSGUIPOINTFRAME_HH
#define CHIPSGUIPOINTFRAME_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>

#include "ChipsGuiPropFrame.hh"
#include "ChipsGuiTooltipObject.hh"

using namespace std;

class ChipsGuiPointPropWidget;

//---------------------------------------------------------------------------

class ChipsGuiPointFrame: public ChipsGuiPropFrame, public ChipsGuiTooltipObject
{
public:

  ChipsGuiPointFrame();
  virtual ~ChipsGuiPointFrame();

  static void color_callback(ChipsGuiPointPropWidget *widget, void *data);
  static void style_callback(ChipsGuiPointPropWidget *widget, gpointer data);
  static void size_callback(ChipsGuiPointPropWidget *widget, gpointer data);
  static void depth_callback(ChipsGuiPointPropWidget *widget, gpointer data);
  static void fill_callback(ChipsGuiPointPropWidget *widget, gpointer data);
  static void vis_callback(ChipsGuiPointPropWidget *widget, gpointer data);
  static void position_callback(ChipsGuiPointPropWidget *widget, void *data);
  static void coordinate_callback(ChipsGuiPointPropWidget *widget, void *data);
  static void angle_callback(ChipsGuiPointPropWidget *widget, void *data);


  virtual void initialize(ChipsId* id);
  virtual void build_form(); 

  virtual void display_subobject (V_SUBOBJECT_TYPE subtype) {};

  void set_angle(float val); 
  void set_style(int val); 
  void set_depth(int val); 
  void set_color(string color); 
  void set_size(int val);
  void set_fill(bool fill); 
  void set_visibility(bool val);
  void set_position (double xpos, double ypos);
  void set_coordinate (int coordinate);

private:
  
  ChipsGuiPointPropWidget*   _pointprop;

};

#endif
