// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//

#ifndef CHIPSGUIPOINTPREFFRAME_HH
#define CHIPSGUIPOINTPREFFRAME_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>

#include "ChipsGuiPrefFrame.hh"
#include "ChipsGuiTooltipObject.hh"

using namespace std;

class ChipsGuiPointPropWidget;

//---------------------------------------------------------------------------

class ChipsGuiPointPrefFrame: public ChipsGuiPrefFrame, public ChipsGuiTooltipObject
{
public:

  ChipsGuiPointPrefFrame();
  virtual ~ChipsGuiPointPrefFrame();

  static void color_callback(ChipsGuiPointPropWidget *widget, void *data);
  static void style_callback(ChipsGuiPointPropWidget *widget, gpointer data);
  static void size_callback(ChipsGuiPointPropWidget *widget, gpointer data);
  static void depth_callback(ChipsGuiPointPropWidget *widget, gpointer data);
  static void fill_callback(ChipsGuiPointPropWidget *widget, gpointer data);
/*  static void coordinate_callback(ChipsGuiPointPropWidget *widget, void *data);
*/
  static void angle_callback(ChipsGuiPointPropWidget *widget, void *data);


  virtual void initialize();
  virtual void build_form(); 

  void set_angle(float val); 
  void set_style(int val); 
  void set_depth(int val); 
  void set_color(string color); 
  void set_size(int val);
  void set_fill(bool fill); 
/*  void set_coordinate (int coordinate);
*/

private:
  
  ChipsGuiPointPropWidget*   _pointprop;

};

#endif
