// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSGUIPOPUP_HH
#define CHIPSGUIPOPUP_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <string>

#include "ChipsDefines.hh"
#include "ChipsEventObserver.hh"
#include "ChipsGuiTooltipObject.hh"

class ChipsObject; 

using namespace std;

class ChipsGuiPopUp : public ChipsEventObserver, public ChipsGuiTooltipObject
{
  public:
    ChipsGuiPopUp();
    virtual ~ChipsGuiPopUp();

    static int  add_cb(GtkMenuItem *object, gpointer user_data);
    static int  delete_cb(GtkMenuItem *object, gpointer user_data);
    static int  shuffle_cb(GtkMenuItem *object, gpointer user_data);
    static int  props_cb(GtkMenuItem *object, gpointer user_data);
    static int  pan_cb(GtkMenuItem *object, gpointer user_data);
    static int  range_cb(GtkMenuItem *object, gpointer user_data);
    static int  select_cb(GtkMenuItem *object, gpointer user_data);
    static int  undo_cb(GtkMenuItem *object, gpointer user_data);
    static int  redo_cb(GtkMenuItem *object, gpointer user_data);
    static int  print_cb(GtkMenuItem *object, gpointer user_data);
    static int  showgui_cb(GtkMenuItem *object, gpointer user_data);
    

    virtual int show();
    void        popup(ChipsObject* object); 
    int         shuffle_object(int dir); 
    int         delete_object(); 
    int         add_object (int substate);

    void        enable_annotate_menu (bool enable);

    virtual void execute_event (int event, void *data);

  protected:
    ChipsObject *obj; 
    V_OBJECT_TYPE   typ; 
    GtkWidget *menu;
    GtkWidget *submenu;
    GtkWidget *add_submenu;
    GtkWidget *menuItemShuf; 
    GtkWidget *menuItemShufF; 
    GtkWidget *menuItemShufB; 
    GtkWidget *menuItemShufU; 
    GtkWidget *menuItemShufD; 
    GtkWidget *menuItemProps; 
    GtkWidget *sep;                 // separator
    GtkWidget *menuItemUndo;
    GtkWidget *menuItemRedo;
    GtkWidget *sep2;                 // separator
    GtkWidget *menuItemAdd;
    GtkWidget *menuItemAddLabel;
    GtkWidget *menuItemAddPoint;
    GtkWidget *menuItemAddLine;
    GtkWidget *menuItemAddHLine;
    GtkWidget *menuItemAddVLine;
    GtkWidget *menuItemAddPolygon;
    GtkWidget *menuItemAddEllipse;
    GtkWidget *menuItemAddBox;
    GtkWidget *menuItemAddColorBar;
    GtkWidget *menuItemDel;
    GtkWidget *sep3;                 // separator
    GtkWidget *menuItemPan; 
    GtkWidget *menuItemRange; 
    GtkWidget *menuItemSel; 
    GtkWidget *sep4;                 // separator
    GtkWidget *menuItemPrint;          
    GtkWidget *menuItemShowGui; 
    GtkWidget *sep5;

  // signals for callbacks
  unsigned long menuItemPan_id;
  unsigned long menuItemRange_id;
  unsigned long menuItemSel_id;
  unsigned long menuItemAdd_id;


};

#endif 
