// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//

#ifndef CHIPSGUIPREFFRAME_HH
#define CHIPSGUIPREFFRAME_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <vector>

#include "ChipsId.hh"

using namespace std;

class ChipsEngine; 

//---------------------------------------------------------------------------

class ChipsGuiPrefFrameCallback
{
   public:
      virtual void execute (ChipsEngine *eng, void *data) = 0;
};


class ChipsGuiPrefFrame
{
public:


  ChipsGuiPrefFrame();
  virtual ~ChipsGuiPrefFrame();

  GtkWidget* base_widget() { return _frame; } 

  void show();
  void hide();

  virtual void update ();

  virtual void initialize() = 0;
  virtual void build_form() = 0; 

  friend class ChipsGuiPrefFrameCallback;

  inline int get_masks () { return _object_states; };

protected:
  void update_property (ChipsGuiPrefFrameCallback *callback, void *data, bool ignore=true);
  void set_preference_override (const string &preference, int object_type, bool ignore=true);
  
  GtkWidget*   _frame; 
  ChipsEngine  *_eng; 

  int          _object_states;

};

#endif
