// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSGUIPROPDIALOG_HH
#define CHIPSGUIPROPDIALOG_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <string>
#include <map>

using namespace std;

typedef map <int, GtkTextBuffer*>pages_map;

class ChipsGuiPropDialog
{
  public:
    ChipsGuiPropDialog();
    ~ChipsGuiPropDialog();
    int show();

    int doit(); 
    void remove_dialog(); 
    void add_widget(GtkWidget* wid, GtkWidget* oldparent);
    GtkWidget* get_container()  { return _contain; }

    static void close_button_cb(GtkWidget *wid, GdkEventButton *event, gpointer data);
    static bool cleanup_cb(GtkWidget *wid, GdkEvent *event, gpointer data);

  protected:
    void generate_form(); 

    GtkWidget* base_w; 
    GtkWidget* _contain; 
    GtkWidget* _oldparent; 
    GtkWidget* _borrowed;
};

#endif 
