// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#include "ChipsGuiPropFrame.hh"
#include "ChipsGuiMain.hh"
#include "ChipsEngine.hh"
#include "ChipsId.hh"
#include "ChipsCmdManager.hh"

extern ChipsCmdManager *cmd_manager;

using namespace std;

extern ChipsGuiMain* chipsGui;

class ChipsSetEnginePropCallback : public ChipsGuiPropFrameCallback
{
   public:
      ChipsSetEnginePropCallback (int property) { this->property = property; };
      virtual void execute (ChipsEngine *eng, ChipsId &cid, void *data)
      {
         if ((data != NULL) && eng)
            eng->set_property(&cid, data, this->property);
      }

   protected:
      int property;
};


// --------------------------------------------------------
// Constructor
// --------------------------------------------------------
ChipsGuiPropFrame::ChipsGuiPropFrame()
{
   _eng = NULL; 
   _cid.clear(); 
   _object_states = STATE_CHNG_CLEAR;

}

// --------------------------------------------------------
// Destructor
// --------------------------------------------------------
ChipsGuiPropFrame::~ChipsGuiPropFrame()
{
//  gtk_widget_destroy(_frame);
}

void ChipsGuiPropFrame::build_form()
{
}

void ChipsGuiPropFrame::show()
{
   gtk_widget_show_all(GTK_WIDGET(_frame));
}

void ChipsGuiPropFrame::hide()
{
   gtk_widget_hide(GTK_WIDGET(_frame));
}

void ChipsGuiPropFrame::update_property (ChipsGuiPropFrameCallback *callback, void *data, bool ignore)
{
   if (!callback)
      return;

   bool bb = cmd_manager->get_ignore_state();
   cmd_manager->set_ignore_state(ignore);
   callback->execute (_eng, _cid, data);
   cmd_manager->set_ignore_state(bb);
}

void ChipsGuiPropFrame::set_engine_property (void *val, int property, bool ignore)
{
   ChipsSetEnginePropCallback callback (property);
   this->update_property (&callback, val, ignore);
}

void ChipsGuiPropFrame::update  ()
{
   if (cmd_manager->check_mask (_object_states))
   {
      cmd_manager->set_ignore_state (true);
      this->initialize (&_cid);
      cmd_manager->set_ignore_state (false);
      cmd_manager->reset_mask (_object_states);
   }
}
