// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//

#ifndef CHIPSGUIPROPFRAME_HH
#define CHIPSGUIPROPFRAME_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>

#include "ChipsId.hh"

using namespace std;

class ChipsEngine; 

//---------------------------------------------------------------------------

class ChipsGuiPropFrameCallback
{
   public:
      virtual void execute (ChipsEngine *eng, ChipsId &cid, void *data) = 0;
};


class ChipsGuiPropFrame
{
public:


  ChipsGuiPropFrame();
  virtual ~ChipsGuiPropFrame();

  GtkWidget* base_widget() { return _frame; } 

  void show();
  void hide();

  virtual void update (); 

  virtual void initialize(ChipsId* id) = 0;
  virtual void build_form() = 0; 
  
  virtual void display_subobject (V_SUBOBJECT_TYPE subtype) = 0;

  friend class ChipsGuiPropFrameCallback;

  inline int get_masks () { return _object_states; };

protected:
  void update_property (ChipsGuiPropFrameCallback *callback, void *data, bool ignore=true);
  void set_engine_property (void *val, int property, bool ignore=true);
  
  GtkWidget*   _frame; 
  GtkWidget*   _table;
  GtkWidget*   _nbook; 
  ChipsId      _cid; 
  ChipsEngine  *_eng; 

  int          _object_states;

};

#endif
