// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//

#ifndef CHIPSGUIPROPPANE_HH
#define CHIPSGUIPROPPANE_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <map>

#include "ChipsEventObserver.hh"
#include "ChipsGuiFontInfo.hh"

class ChipsGuiPropFrame; 
class ChipsGuiPropDialog; 
class ChipsGuiPrefFrame;

typedef map <int, ChipsGuiPropFrame*>frame_map;
typedef map <int, ChipsGuiPrefFrame*>pref_frame_map;

using namespace std;


//---------------------------------------------------------------------------

class ChipsGuiPropPane: public ChipsEventObserver
{
public:

  ChipsGuiPropPane();
  ~ChipsGuiPropPane();

//  GtkWidget* base_widget() { return _frame; } 
  GtkWidget* base_widget() { return _table; } 

  void show();
  void hide();
  void set_pane(int type, bool show_pref); 
  int  get_height(); 
  void reparent_frame(); 
  void display_dialog(); 
  void set_property_frame(ChipsEventObjectInfo* sel); 

  void update ();

  virtual void execute_event(int, void*);

  static ChipsGuiFontInfo font_info;

private:

  
  GtkWidget*   _framew; 
  GtkWidget*   _table;
  int          _type;   // object type 

  ChipsGuiPropDialog* _dialog; 

  frame_map    _frames;
  pref_frame_map _pref_frames;

  bool         _display_prefs;


private:

};

#endif
