// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSGUIREFMAN_HH
#define CHIPSGUIREFMAN_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <string>
#include <map>

using namespace std;

typedef map <int, GtkTextBuffer*>pages_map;

class ChipsGuiRefMan
{
  public:
    ChipsGuiRefMan();
    ~ChipsGuiRefMan();
    int show();

    int doit(); 
    void remove_dialog(); 

    void follow_if_link(GtkWidget *text_view, GtkTextIter *iter); 
    static bool key_press_event(GtkWidget *text_view, GdkEventKey *event,
                                gpointer data);
    static bool event_after(GtkWidget *text_view, GdkEventKey *event,
                            gpointer data);
    static void motion_notify_event(GtkWidget *text_view, 
                                    GdkEventMotion *event, gpointer data);
    static void vis_notify_event(GtkWidget *text_view,
                                 GdkEventVisibility *event, gpointer data);
    static void close_button_cb(GtkWidget *wid, GdkEventButton *event, gpointer data);
    static bool cleanup_cb(GtkWidget *wid, GdkEvent *event, gpointer data);

    void set_cursor(GtkTextView *text_view, int x, int y);

  protected:
    void generate_form(); 
    void parse_document(); 
    void display_page(GtkTextView* view, int page);
    GtkTextBuffer* add_page(); 
    void insert_link (GtkTextBuffer *buffer, GtkTextIter *iter, 
                      const char *text, const char *fmt, int page);
    void add_controls(GtkTextBuffer *buffer, GtkTextIter* iter, int page,
                      int loc=1, bool next=true);


    GtkWidget* base_w; 
    GtkWidget* sw; 
    GtkWidget *view;
    pages_map pages; 
    bool hovering;
    GdkCursor *hand_cursor;
    GdkCursor *regular_cursor;
    string     config_dir; 
};

#endif 
