// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//

#ifndef CHIPSGUIREGIONFRAME_HH
#define CHIPSGUIREGIONFRAME_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>

#include "ChipsGuiPropFrame.hh"
#include "ChipsGuiTooltipObject.hh"

using namespace std;

class ChipsGuiRegionPropWidget;

//---------------------------------------------------------------------------

class ChipsGuiRegionFrame: public ChipsGuiPropFrame, public ChipsGuiTooltipObject
{
public:

   ChipsGuiRegionFrame();
   virtual ~ChipsGuiRegionFrame();

   static void linecolor_callback(ChipsGuiRegionPropWidget *widget, void *data);
   static void linestyle_callback(ChipsGuiRegionPropWidget *widget, void *data);
   static void linethick_callback(ChipsGuiRegionPropWidget*widget, void *data);
   static void angle_callback(ChipsGuiRegionPropWidget *widget, void *data);
   static void vis_callback(ChipsGuiRegionPropWidget *widget, void *data);
   static void depth_callback(ChipsGuiRegionPropWidget *widget, void *data);
   static void opacity_callback(ChipsGuiRegionPropWidget *widget, void *data);
   static void fillcolor_callback(ChipsGuiRegionPropWidget *widget, void *data);
   static void fillstyle_callback(ChipsGuiRegionPropWidget *widget, void *data);
   static void position_callback(ChipsGuiRegionPropWidget *widget, void *data);
   static void coordinate_callback(ChipsGuiRegionPropWidget *widget, void *data);

   virtual void initialize(ChipsId* id);
   virtual void build_form(); 

   virtual void display_subobject (V_SUBOBJECT_TYPE subtype) {};

   void set_linecolor(const string &color); 
   void set_linestyle(int val); 
   void set_linethick(float val);
   void set_angle(float val);
   void set_depth(int val); 
   void set_visibility(bool val); 
   void set_fillcolor(const string &color); 
   void set_fillstyle(int val);
   void set_opacity(float val); 
   void set_position (double xpos, double ypos);
   void set_coordinate (int coordinate);

private:
  
   ChipsGuiRegionPropWidget*   _regionprop;

};

#endif
