// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSGUISETTINGSDIALOG_HH
#define CHIPSGUISETTINGSDIALOG_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <string>

#include "ChipsGuiTooltipObject.hh"


class ChipsGuiColorWidget; 

using namespace std;

class ChipsGuiSettingsDialog: public ChipsGuiTooltipObject
{
  public:
   ChipsGuiSettingsDialog();
   ~ChipsGuiSettingsDialog();
   int show();

   int doit();

  protected:
   void generate_form(); 
   void load_preferences();
   void set_preferences();

   GtkWidget *base_w;   
   GtkWidget* _scrolled; 
   GtkWidget* _notebook; 
   GtkWidget* _tab_panes;
   GtkWidget* _pane_tog[5]; 
   GtkWidget* _tab_tbar;
   GtkWidget* _tab_wids[13]; 
   GtkWidget* _tab_gen;
   GtkWidget* _gen_wids[2]; 
   GtkWidget* _label;

   ChipsGuiColorWidget* _selcolor;
   ChipsGuiColorWidget* _rangecolor;

   string     _title;             // title of dialog  

};

#endif 
