// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//

#ifndef CHIPSGUISHELLPANE_HH
#define CHIPSGUISHELLPANE_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>

using namespace std;

class ChipsGuiErrLog; 

//---------------------------------------------------------------------------

class ChipsGuiShellPane
{
public:

  ChipsGuiShellPane(string serverid);
  ~ChipsGuiShellPane();

  GtkWidget* base_widget() { return _frame; } 

  void show();
  void hide();
  int  get_height(); 

  void connect(string serv="");
  void disconnect(); 

  void log_error(string err); 
  void reset_error_label();

  static gboolean event_callback(GtkWidget* widget, GdkEvent *event,
                                 gpointer data);
  static void switchpage_callback(GtkNotebook *notebook, GtkWidget* widget, 
                                  guint page_num, gpointer data);

protected:
  void setup_chips_shell(); 
private:
  
  GtkWidget*   _frame; 
  GtkWidget*   _table;
  GtkWidget*   _nbook;
  GtkWidget*   _errbox; 
  GtkWidget*   _errlbl; 
  GtkWidget*   _shell; // vte terminal shell running chips
  ChipsGuiErrLog* _errlog; 

  string       _initfile; 
  string       _serverid;

};

#endif
