// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#include "ChipsGuiTooltipObject.hh"

bool ChipsGuiTooltipObject::tooltip_handler(GtkWidget *widget, gint x, gint y,
   gboolean keyboard_tip, GtkTooltip *tooltip, gpointer data)

{
   gchar* txt = (gchar*)data;
   if (txt)  gtk_tooltip_set_text(tooltip, txt);
   return _enabled;
}

bool ChipsGuiTooltipObject::_enabled = true; 


void ChipsGuiTooltipObject::show_tooltips(bool show)
{
   ChipsGuiTooltipObject obj;
   if (show)  obj.enable_tooltips();
      else    obj.disable_tooltips();
}


ChipsGuiTooltipObject::ChipsGuiTooltipObject()
{
}

ChipsGuiTooltipObject::~ChipsGuiTooltipObject()
{

}

void ChipsGuiTooltipObject::setup_tooltip(GtkWidget* widget, const char* txt)
{
   if (!(widget && txt))  return; 

   gtk_widget_set_has_tooltip(GTK_WIDGET(widget), TRUE);
   g_signal_connect(G_OBJECT(widget) , "query-tooltip" ,
      G_CALLBACK(ChipsGuiTooltipObject::tooltip_handler), (gpointer)txt);
}


