// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef CHIPSGUITOOLTIPOBJECT_HH
#define CHIPSGUITOOLTIPOBJECT_HH

#include <gtk/gtk.h>

using namespace std;

class ChipsGuiTooltipObject
{
  public:

   ChipsGuiTooltipObject();

   void setup_tooltip(GtkWidget* widget, const char* txt);
   void enable_tooltips()  { _enabled = true; }
   void disable_tooltips()  { _enabled = false; }

   static void show_tooltips(bool show); 
  protected:

   virtual ~ChipsGuiTooltipObject();

   static bool tooltip_handler(GtkWidget *widget, gint x, gint y,
              gboolean keyboard_tip, GtkTooltip *tooltip, gpointer data);

   static bool _enabled;  // display tooltips?
};


#endif 
