// 
//  Copyright (C) 2011,2013  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//



#ifndef CHIPSGUIVIEWMENU_HH
#define CHIPSGUIVIEWMENU_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <string>

using namespace std;

#include "ChipsGuiTooltipObject.hh"


class ChipsGuiViewMenu: public ChipsGuiTooltipObject
{
  public:
    ChipsGuiViewMenu();
    virtual ~ChipsGuiViewMenu();

    static int  toggled_cb(GObject *object, gpointer user_nav);
    static int  alternate_cb(GObject *object, gpointer data);
    static int  gridprops_cb(GObject *object, gpointer data);
    static int  gridvis_cb(GObject *object, gpointer data);

    virtual int show();

    bool display_tbar(); 
    bool display_info(); 
    bool display_nav(); 
    bool display_property(); 
    bool display_shell(); 
    bool display_grid(); 

    void initialize();
    void update_gui_prefs(); 

    GtkWidget*  base_widget()   { return base_w; }

  protected:
    GtkWidget *base_w; 
    GtkWidget *menu;
    GtkWidget *menuItemTbar;
    GtkWidget *menuItemInfo;
    GtkWidget *menuItemNav;
    GtkWidget *menuItemProperty;
    GtkWidget *menuItemShell;
    GtkWidget *menuItemAlt; 
    GtkWidget *sep;
    GtkWidget *gridLayout;
    GtkWidget *gridProps;

};

#endif 
