// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#include "ChipsGuiWidget.hh"
#include <algorithm>
#include <iostream>

ChipsGuiWidget::ChipsGuiWidget ()
{
   _base_widget = NULL;
}

ChipsGuiWidget::~ChipsGuiWidget()
{
   map<string, ChipsGuiWidgetCallback *>::iterator ii;
   for (ii=_callbacks.begin (); ii!=_callbacks.end (); ii++)
      delete ii->second;
   _callbacks.clear ();
}

void ChipsGuiWidget::add_callback (const string &callback_id, ChipsGuiWidgetCallback *callback)
{
   list<string>::iterator ii = find (_valid_callback_ids.begin (),  _valid_callback_ids.end (), callback_id);

   if (ii == _valid_callback_ids.end ())
      cerr << "ERROR: Invalid ChipsGuiWidget callback id: " << callback_id << endl;
   else
      _callbacks[callback_id] = callback;
}

void ChipsGuiWidget::remove_callback (const string &callback_id)
{
   _callbacks.erase (callback_id);
}
   
