// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//

#ifndef CHIPSGUIWIDGET_HH
#define CHIPSGUIWIDGET_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>
#include <list>
#include <map>

using namespace std;

class ChipsGuiWidget;

class ChipsGuiWidgetCallback
{
   public:
      virtual void execute (ChipsGuiWidget *caller, void *data) = 0;

};


//---------------------------------------------------------------------------

class ChipsGuiWidget
{
public:

  ChipsGuiWidget();
  ~ChipsGuiWidget();
  virtual void build_form() = 0;

  void add_callback (const string &callback_id, ChipsGuiWidgetCallback *callback);
  void remove_callback (const string &callback_id);

  virtual void show () = 0;
  virtual void hide () = 0;

  virtual GtkWidget * base_widget() { return _base_widget; };

protected:

  GtkWidget*   _base_widget;
  map<string, ChipsGuiWidgetCallback *> _callbacks;
  list<string> _valid_callback_ids;
};



#endif
