// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//

#ifndef CHIPSGUIWINDOWFRAME_HH
#define CHIPSGUIWINDOWFRAME_HH

#include <stdio.h>
#include <gtk/gtk.h>
#include <iostream>

#include "ChipsGuiPropFrame.hh"
#include "ChipsGuiTooltipObject.hh"

using namespace std;

class ChipsGuiColorWidget;

//---------------------------------------------------------------------------

class ChipsGuiWindowFrame: public ChipsGuiPropFrame, ChipsGuiTooltipObject
{
public:

  ChipsGuiWindowFrame();
  virtual ~ChipsGuiWindowFrame();

  static void color_callback(ChipsGuiColorWidget *widget, void *data);
  static void redraw_callback(GtkWidget *widget, gpointer data);

  virtual void initialize(ChipsId* id);
  virtual void build_form(); 

  virtual void display_subobject (V_SUBOBJECT_TYPE subtype) {};

  void set_redraw(bool val); 
  void set_color(string color); 

private:
  
  ChipsGuiColorWidget*   _color;
  GtkWidget*   _redraw;

  // signals for callbacks 
  unsigned long _redraw_id; 

  bool         _redrawval;

};

#endif
