# 
#  Copyright (C) 2007,2009  Smithsonian Astrophysical Observatory
#
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License along
#  with this program; if not, write to the Free Software Foundation, Inc.,
#  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#


import numpy  # leave this import for backwards compatibility1
import numpy as np

from pychips_base import *
from extensions import *
from attribute_objects import *
from deprecated import *

import advanced.names as __advanced_names__

try:
   from offscreen import *
   __offscreen_list = []
except:
   __offscreen_list = ["set_offscreen_mode"]

__pysl_loaded = globals().has_key ('pysl');

__versionstr__ = CHIPS_VERSION_STR
__version__ = CHIPS_VERSION

# The following is the list of methods which should be excluded from
# the public API. Put it in a dictionary for quicker searches
__exclude_list = [ 'string_to_hoffset', 'string_to_pagesize', 
   'string_to_pickmask', 'string_to_v_axisstyle', 
   'string_to_v_baddatamode', 'string_to_v_line_extension', 
   'string_to_v_line', 'string_to_v_symbol', 'string_to_v_contour', 
   'v_object_to_string', 'string_to_v_coord_sys', 
   'string_to_v_cornerstyle', 'string_to_v_errstyle', 'string_to_v_font',
   'string_to_v_fontstyle', 'string_to_v_object', 
   'string_to_v_printfile', 'string_to_v_tickmode', 
   'string_to_v_tickstyle', 'string_to_v_units', 'string_to_voffset', 
   'v_axisstyle_to_string', 'v_baddatamode_to_string', 'v_colormap_to_string', 
   'v_contour_to_string', 'v_coord_sys_to_enum_string', 
   'v_coord_sys_to_string', 'v_cornerstyle_to_string', 
   'v_errstyle_to_string', 'v_fill_to_string', 'v_font_to_string', 
   'v_fontstyle_to_string', 'v_interpolation_to_string', 
   'v_line_extension_to_string', 'v_line_to_string', 'v_pagesize_to_string', 
   'v_printfile_to_string', 'v_rgba_to_string', 'v_symbol_to_string', 
   'v_tickmode_to_string', 'v_tickstyle_to_string', 'v_units_to_string', 
   'new_instancemethod', 'string_to_v_fill', 'CHIPS_VERSION_STR', 
   'CHIPS_VERSION' ]

__exclude_list = __exclude_list + __advanced_names__.advanced_list + __offscreen_list
for __elem__ in __exclude_list:
   try:
      del globals()[__elem__]
   except:
      pass

#for __elem__ in __advanced_names__.advanced_list:
#   __exclude_dict[__elem__] = 1
 
  
#
#for __elem__ in dir (__pychips_base__):
#   if not __elem__.startswith ('__') and not globals().has_key (__elem__) and not __exclude_dict.has_key(__elem__):
#      globals()[__elem__] = getattr(__pychips_base__,__elem__)


