# 
#  Copyright (C) 2007  Smithsonian Astrophysical Observatory
#
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License along
#  with this program; if not, write to the Free Software Foundation, Inc.,
#  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#



# a list of function names for the advanced user
advanced_list = ['blink_frames', 'clear_errors', 'close_undo_block', 
         'close_undo_buffer', 'discard_undo_buffer', 'get_axis_automax', 
         'get_axis_automin', 'get_axis_color', 'get_axis_depth',
         'get_axis_label_angle', 'get_axis_label_color', 'get_axis_label_font',
         'get_axis_label_fontstyle', 'get_axis_label_halign',
         'get_axis_label_size', 'get_axis_label_valign', 
         'get_axis_label_visible', 'get_axis_major_color', 
         'get_axis_major_interval', 'get_axis_major_length',
         'get_axis_major_mode', 'get_axis_major_num',
         'get_axis_major_style', 'get_axis_major_thickness',
         'get_axis_majorgrid_color', 'get_axis_majorgrid_style',
         'get_axis_majorgrid_thickness', 'get_axis_majorgrid_visible',
         'get_axis_minor_color', 'get_axis_minor_interval',
         'get_axis_minor_length', 'get_axis_minor_mode',
         'get_axis_minor_num', 'get_axis_minor_style',
         'get_axis_minor_thickness', 'get_axis_minorgrid_color',
         'get_axis_minorgrid_style', 'get_axis_minorgrid_thickness',
         'get_axis_minorgrid_visible', 'get_axis_pad',
         'get_axis_parallel_offset', 'get_axis_perpendicular_offset',
         'get_axis_thickness', 'get_axis_tickformat',
         'get_axis_ticklabel_angle', 'get_axis_ticklabel_color',
         'get_axis_ticklabel_font', 'get_axis_ticklabel_fontstyle',
         'get_axis_ticklabel_halign', 'get_axis_ticklabel_offset',
         'get_axis_ticklabel_size', 'get_axis_ticklabel_style',
         'get_axis_ticklabel_valign', 'get_axis_ticklabel_visible',
         'get_axis_tickstyle', 'get_contour_algorithm',
         'get_contour_color', 'get_contour_depth', 'get_contour_interval',
         'get_contour_mode', 'get_contour_numlevels', 'get_contour_style',
         'get_contour_thickness', 'get_curve_baddatamode', 
         'get_curve_depth', 'get_curve_errcolor', 'get_curve_errdown',
         'get_curve_errleft', 'get_curve_errright', 'get_curve_errstyle',
         'get_curve_errthickness', 'get_curve_errup', 'get_curve_limitlength',
         'get_curve_limitoverride', 'get_curve_linecolor',
         'get_curve_linestyle', 'get_curve_linethickness',
         'get_curve_symbolangle', 'get_curve_symbolcolor',
         'get_curve_symbolfill', 'get_curve_symbolsize',
         'get_curve_symbolstyle', 'get_error_count', 'get_error_types',
         'get_error_verbosity', 'get_errors', 'get_frame_bgcolor',
         'get_frame_border_color', 'get_frame_transparency',
         'get_histogram_depth', 'get_histogram_dropline',
         'get_histogram_errcolor', 'get_histogram_errdown',
         'get_histogram_errstyle', 'get_histogram_errthickness',
         'get_histogram_errup', 'get_histogram_fillstyle',
         'get_histogram_fillcolor', 'get_histogram_fillopacity',
         'get_histogram_linecolor', 'get_histogram_linestyle',
         'get_histogram_linethickness', 'get_histogram_symbolangle',
         'get_histogram_symbolcolor', 'get_histogram_symbolfill',
         'get_histogram_symbolsize', 'get_histogram_symbolstyle',
         'get_histogram_visible', 'get_label_angle',
         'get_label_color', 'get_label_depth', 'get_label_font',
         'get_label_fontstyle', 'get_label_halign', 'get_label_size',
         'get_label_valign', 'get_label_visible', 'get_line_color',
         'get_line_depth', 'get_line_extend', 'get_line_stipple',
         'get_line_style', 'get_line_thickness', 'get_line_visible',
         'get_major_ticks_visible', 'get_minor_ticks_visible',
         'get_plot_axisstyle', 'get_plot_bottommargin',
         'get_plot_cornerstyle', 'get_plot_leftmargin',
         'get_plot_rightmargin', 'get_plot_title_angle',
         'get_plot_title_color', 'get_plot_title_depth',
         'get_plot_title_font', 'get_plot_title_fontstyle',
         'get_plot_title_halign', 'get_plot_title_size',
         'get_plot_title_valign', 'get_plot_title_xpos',
         'get_plot_title_ypos', 'get_plot_topmargin', 'get_point_angle',
         'get_point_color', 'get_point_depth', 'get_point_fill',
         'get_point_size', 'get_point_style', 'get_region_angle',
         'get_region_depth', 'get_region_edgecolor',
         'get_region_edgestyle', 'get_region_edgethickness',
         'get_region_fillstyle', 'get_region_fillcolor',
         'get_region_opacity', 'get_window_bgcolor',
         'get_window_redraw', 'highlight_object', 'load_font', 'load_fill',
         'open_undo_block', 'open_undo_buffer', 'pickmask_to_string',
         'set_axis_automax',
         'set_axis_automin', 'set_axis_color', 'set_axis_depth',
         'set_axis_label_angle', 'set_axis_label_color',
         'set_axis_label_font', 'set_axis_label_fontstyle',
         'set_axis_label_halign', 'set_axis_label_size',
         'set_axis_label_valign', 'set_axis_label_visible',
         'set_axis_major_color', 'set_axis_major_interval',
         'set_axis_major_length', 'set_axis_major_mode',
         'set_axis_major_num', 'set_axis_major_style',
         'set_axis_major_thickness', 'set_axis_majorgrid_color',
         'set_axis_majorgrid_style', 'set_axis_majorgrid_thickness',
         'set_axis_majorgrid_visible', 'set_axis_minor_color',
         'set_axis_minor_interval', 'set_axis_minor_length',
         'set_axis_minor_mode', 'set_axis_minor_num',
         'set_axis_minor_style', 'set_axis_minor_thickness',
         'set_axis_minorgrid_color', 'set_axis_minorgrid_style',
         'set_axis_minorgrid_thickness', 'set_axis_minorgrid_visible',
         'set_axis_pad', 'set_axis_parallel_offset',
         'set_axis_perpendicular_offset', 'set_axis_thickness',
         'set_axis_tickformat', 'set_axis_ticklabel_angle',
         'set_axis_ticklabel_color', 'set_axis_ticklabel_font',
         'set_axis_ticklabel_fontstyle', 'set_axis_ticklabel_halign',
         'set_axis_ticklabel_offset', 'set_axis_ticklabel_size',
         'set_axis_ticklabel_style', 'set_axis_ticklabel_valign',
         'set_axis_ticklabel_visible', 'set_axis_tickstyle',
         'set_contour_algorithm', 'set_contour_color',
         'set_contour_depth', 'set_contour_interval',
         'set_contour_levels', 'set_contour_mode',
         'set_contour_numlevels', 'set_contour_style',
         'set_contour_thickness', 'set_contour_transform',
         'set_curve_baddatamode', 'set_curve_depth',
         'set_curve_errcolor', 'set_curve_errdown',
         'set_curve_errleft', 'set_curve_errright',
         'set_curve_errstyle', 'set_curve_errthickness',
         'set_curve_errup', 'set_curve_limitlength',
         'set_curve_limitoverride', 'set_curve_linecolor',
         'set_curve_linestyle', 'set_curve_linethickness',
         'set_curve_symbolangle', 'set_curve_symbolcolor',
         'set_curve_symbolfill', 'set_curve_symbolsize',
         'set_curve_symbolstyle', 'set_error_verbosity',
         'set_frame_bgcolor', 'set_frame_border_color',
         'set_frame_scale', 'set_frame_transparency',
         'set_histogram_depth', 'set_histogram_dropline',
         'set_histogram_errcolor', 'set_histogram_errdown',
         'set_histogram_errstyle', 'set_histogram_errthickness',
         'set_histogram_errup', 'set_histogram_fillstyle',
         'set_histogram_fillcolor', 'set_histogram_fillopacity',
         'set_histogram_linecolor', 'set_histogram_linestyle',
         'set_histogram_linethickness', 'set_histogram_symbolangle',
         'set_histogram_symbolcolor', 'set_histogram_symbolfill',
         'set_histogram_symbolsize', 'set_histogram_symbolstyle',
         'set_label_angle', 'set_label_color', 'set_label_depth',
         'set_label_font', 'set_label_fontstyle', 'set_label_halign',
         'set_label_size', 'set_label_valign', 'set_line_color',
         'set_line_depth', 'set_line_extend', 'set_line_stipple',
         'set_line_style', 'set_line_thickness', 'set_plot_axisstyle',
         'set_plot_bottommargin', 'set_plot_cornerstyle',
         'set_plot_leftmargin', 'set_plot_rightmargin',
         'set_plot_title_angle', 'set_plot_title_color',
         'set_plot_title_depth', 'set_plot_title_font',
         'set_plot_title_fontstyle', 'set_plot_title_halign',
         'set_plot_title_size', 'set_plot_title_valign',
         'set_plot_title_xpos', 'set_plot_title_ypos',
         'set_plot_topmargin', 'set_point_angle', 'set_point_color',
         'set_point_depth', 'set_point_fill', 'set_point_size',
         'set_point_style', 'set_region_depth', 'set_region_edgecolor',
         'set_region_edgestyle', 'set_region_edgethickness',
         'set_region_fillstyle', 'set_region_fillcolor',
         'set_region_opacity', 'set_window_bgcolor',
         'set_window_redraw', 'stop_blink', 'apply_contour_transform',
         'apply_contour_transform_inverse', 'get_contour_transform',
         'valid_axisstyle_type', 'valid_baddatamode_type', 'valid_color',
         'valid_colormap_type', 'valid_contour_type', 'valid_coord_sys_type',
         'valid_cornerstyle_type', 'valid_errstyle_type', 'valid_fill_type',
         'valid_font_type', 'valid_fontstyle_type', 'valid_interpolation_type',
         'valid_line_extension_type', 'valid_line_type', 'valid_object_type', 
         'valid_printfile_type', 'valid_rgba_type',
         'valid_shuffle_type', 'valid_symbol_type', 'valid_tickmode_type',
         'valid_tickstyle_type', 'valid_units_type',
         'set_image_depth', 'set_image_alpha', 'set_image_interpolation',
         'set_image_invert_colormap',
         'set_image_colormap', 'set_image_scale_channels',
         'set_image_colormap_interpolate', 'set_image_threshold',
         'set_image_colormap_size', 
         'get_image_depth', 'get_image_alpha', 'get_image_interpolation',
         'get_image_invert_colormap',
         'get_image_colormap', 'get_image_scale_channels',
         'get_image_colormap_interpolate', 'get_image_threshold',
         'get_image_colormap_size', 
         'set_colorbar_tick_length', 'set_colorbar_depth',
         'set_colorbar_tick_location', 'set_colorbar_halign',
         'set_colorbar_tick_mode', 'set_colorbar_label_angle', 
         'set_colorbar_tick_style', 'set_colorbar_label_color',
         'set_colorbar_tick_thickness', 'set_colorbar_label_font',
         'set_colorbar_tick_visible', 'set_colorbar_label_fontstyle',
         'set_colorbar_ticklabel_angle', 'set_colorbar_label_halign',
         'set_colorbar_ticklabel_color', 'set_colorbar_label_location',
         'set_colorbar_ticklabel_font', 'set_colorbar_label_size',
         'set_colorbar_ticklabel_fontstyle', 'set_colorbar_label_text',
         'set_colorbar_ticklabel_halign', 'set_colorbar_label_valign',
         'set_colorbar_ticklabel_offset', 'set_colorbar_label_visible',
         'set_colorbar_ticklabel_size', 'set_colorbar_length',
         'set_colorbar_ticklabel_valign', 'set_colorbar_orientation',
         'set_colorbar_ticklabel_visible', 'set_colorbar_parallel_offset',
         'set_colorbar_valign', 'set_colorbar_perpendicular_offset',
         'set_colorbar_width', 'set_colorbar_tick_color',
         'get_colorbar_tick_length', 'get_colorbar_depth',
         'get_colorbar_tick_location', 'get_colorbar_halign',
         'get_colorbar_tick_mode', 'get_colorbar_label_angle',
         'get_colorbar_tick_style', 'get_colorbar_label_color',
         'get_colorbar_tick_thickness', 'get_colorbar_label_font',
         'get_colorbar_tick_visible', 'get_colorbar_label_fontstyle',
         'get_colorbar_ticklabel_angle', 'get_colorbar_label_halign',
         'get_colorbar_ticklabel_color', 'get_colorbar_label_location',
         'get_colorbar_ticklabel_font', 'get_colorbar_label_size',
         'get_colorbar_ticklabel_fontstyle', 'get_colorbar_label_text',
         'get_colorbar_ticklabel_halign', 'get_colorbar_label_valign',
         'get_colorbar_ticklabel_offset', 'get_colorbar_label_visible',
         'get_colorbar_ticklabel_size', 'get_colorbar_length',
         'get_colorbar_ticklabel_valign', 'get_colorbar_orientation',
         'get_colorbar_ticklabel_visible', 'get_colorbar_parallel_offset',
         'get_colorbar_valign', 'get_colorbar_perpendicular_offset',
         'get_colorbar_width', 'get_colorbar_tick_color',
         'set_curve_errcaplength', 'set_histogram_errcaplength',
         'get_curve_errcaplength', 'get_histogram_errcaplength',
         'string_to_ratio_values', 'string_to_v_interpolation',
         'string_to_v_colormap', 'string_to_v_rgba']



