import os
import pychips_base as __pychips_base__

__all__ = ["set_offscreen_mode"]

if not 'set_offscreen_mode' in dir (__pychips_base__):
   raise ImportError ('Chips ERROR: Offscreen is not supported in current user configuration. CHIPS_OS_LIBS environment variable needs to be set, before running in offscreen mode')

if os.environ.has_key ('LD_LIBRARY_PATH'):
   __ld_library_path__ = os.environ['LD_LIBRARY_PATH']
else:
   __ld_library_path__ = ''

def set_offscreen_mode (flag):
   """
   Toggles on and off offscreen mode. This command is only valid
   before the server has started.
   """

   server_id = __pychips_base__.get_server_id ()

   if len(server_id) != 0:
      raise RuntimeError("Chips ERROR: This function has no effect when attached to server. The offscreen mode will NOT be changed. Please disconnect and run the function again.")

   if os.environ.has_key ('CHIPS_OS_LIBS'):
      chips_os_libs = os.environ['CHIPS_OS_LIBS']
   else:
      chips_os_libs = ''

   if flag:
      if len (__ld_library_path__) > 0:
         os.environ['LD_LIBRARY_PATH'] = chips_os_libs+':'+__ld_library_path__
      else:
         os.environ['LD_LIBRARY_PATH'] = chips_os_libs
   else:
      os.environ['LD_LIBRARY_PATH'] = __ld_library_path__

   __pychips_base__.set_offscreen_mode (flag)

