from numpy.distutils.core import setup, Extension

import platform
import os

cpp_libs = ['chips']
if platform.system() == 'SunOS':
    cpp_libs.append('Cstd')

chips_includes = os.getenv ('CHIPS_INC')
chips_includes = chips_includes.split (':')

chips_files = ['utils.py', 'extensions.py', 'attribute_objects.py', 'deprecated.py', 'all.py']

if 'offscreen.py' in os.listdir('./'):
   chips_files.append ('offscreen.py')

setup(name='',
      version='0.1.0',
      author='Smithsonian Astrophysical Observatory / Chandra X-Ray Center',
      author_email='cxchelp@head.cfa.harvard.edu',
      py_modules=['__init__', 'pychips_base'],
      packages=['hlui', 'advanced'],
      ext_modules=[Extension('_pychips',
                             ['pychips_wrap.cc', '../ChipsRemoteMod.cc'],
                             chips_includes,
                             library_dirs=['../'],
                             libraries=cpp_libs)],
      data_files=[('.', chips_files)]
     )
