// 
//  Copyright (C) 2004-2007  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef VTKAXISLABEL_HH
#define VTKAXISLABEL_HH

#include <string>

#include "vtkVectorText.h"
#include "vtkActor.h"
#include "vtkProperty.h"

#include "vtkPolyDataMapper.h"
#include "vtkTextProperty.h"


#include "ChipsLabel.hh"
#include "ChipsAxis.hh"
#include "VtkLabelInterface.hh"

using namespace std;


class vtkAxisActor2DExtra;
class vtkTextActorExtra;
#ifndef HEADLESS
class vtkChipsTextWidget;
#endif
class vtkRenderer;


class VtkAxisLabel: public ChipsLabel, public VtkLabelInterface
{
public:

  VtkAxisLabel(vtkAxisActor2DExtra* inAxis, vtkRenderer *renderer, ChipsObject* par, double inParallelOffset, double inPerpendicularOffset,const string& val);

  VtkAxisLabel(vtkAxisActor2DExtra* inAxis, vtkRenderer *renderer, ChipsObject* par, ChipsStateStream& in);

  virtual ~VtkAxisLabel();

  virtual int redraw();
  virtual int change_text();
  virtual int change_font();
  virtual int change_size();
  virtual int change_color();
  virtual int change_rotation();
  virtual int change_scale_factor();
  virtual int change_alignment();
  virtual int change_visible();

  virtual int compute_resize( double bounds[]);

  virtual void select ();
  virtual void unselect ();

  virtual void disable_interaction ();
  virtual void enable_interaction ();

  virtual void modify ();


protected:

private:
  VtkAxisLabel(const VtkAxisLabel& inLabel);

  vtkTextActorExtra* vtkText;
  
  vtkAxisActor2DExtra* axis;
  vtkRenderer* renderer;

#ifndef HEADLESS
  vtkChipsTextWidget *label_widget;
#endif



};





#endif
