// 
//  Copyright (C) 2007  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef VTKDEPTHCONTROL_HH
#define VTKDEPTHCONTROL_HH

#include "vtkRenderer.h"
#include "vtkActor2D.h"
#include "vtkActor2DCollection.h"

#include "ChipsDepthControl.hh"
#include "ChipsErrs.hh"

#include <list>

using namespace std;

class VtkDepthControl : public ChipsDepthControl
{
  public:
   VtkDepthControl(vtkRenderer *inRenderer, int val=V_DEFAULT_DEPTH);
   VtkDepthControl(vtkRenderer *inRenderer, ChipsFrame* frm, 
                   ChipsStateStream& in);
   virtual ~VtkDepthControl();

   virtual int sort_depth (int start_layer=0);
   virtual int sort_single_item ();
   virtual int sort_last_item ();


  protected:
   vtkRenderer *renderer;

  private:

   static bool list_comp (list<vtkActor2D *>::const_reference str1,
                          list<vtkActor2D *>::const_reference str2)
      { return (str1->GetLayerNumber () < str2->GetLayerNumber ()); };


};

#endif

