// 
//  Copyright (C) 2004-2007  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef VTKENGINE_HH
#define VTKENGINE_HH

#include "ChipsEngine.hh" 
#include "VtkWindow.hh"

class VtkEngine: public ChipsEngine
{
  public:

   VtkEngine(bool load_prefs=true);
   virtual ~VtkEngine();

   virtual bool verify_fontfile_exists(string fontpath); 

   virtual ChipsWindow* new_window(string id="");
   virtual ChipsWindow* new_window(ChipsStateStream& in);
   virtual ChipsWindow* new_window(float width, float height,
                                 string format="inch",
                                 string id="");
};

#endif

