// 
//  Copyright (C) 2004-2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef VTKLABEL_HH
#define VTKLABEL_HH

#include <string>

#include "vtkRenderer.h"
#include "vtkVectorText.h"
#include "vtkActor.h"
#include "vtkProperty.h"

#include "vtkPolyDataMapper.h"
#include "vtkTextProperty.h"


#include "ChipsLabel.hh"
#include "VtkLabelInterface.hh"

using namespace std;


class vtkTextActorExtra;

#ifndef HEADLESS
class vtkChipsTextWidget;
#endif


class VtkLabel: public ChipsLabel, public VtkLabelInterface
{
public:

  VtkLabel(vtkRenderer* inRenderer,ChipsObject* par, const string& lbid, ChipsCoordinate *inCoord, COORD_SYS coord_sys, double inXPos, double inYPos,const string& val);

  VtkLabel(vtkRenderer* inRenderer,ChipsObject* par, ChipsCoordinate *inCoord, 
           COORD_SYS coord_sys, ChipsStateStream& in);

  virtual ~VtkLabel();


  virtual int  compute_resize ( double bounds[] );


  virtual int redraw();
  virtual int change_text();
  virtual int change_font();
  virtual int change_size();
  virtual int change_position();
  virtual int change_color();
  virtual int change_rotation();
  virtual int change_scale_factor();
  virtual int change_alignment();
  virtual int change_visible();
  virtual int change_depth();
  virtual int change_bbox();

  virtual void select ();
  virtual void unselect ();

  virtual void disable_interaction ();
  virtual void enable_interaction ();


protected:

private:
  VtkLabel(const VtkLabel& inLabel);

  vtkTextActorExtra* vtkText;
  
  vtkRenderer* renderer;

#ifndef HEADLESS
  vtkChipsTextWidget *label_widget;
#endif




};





#endif
