// 
//  Copyright (C) 2006,2007  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef VTKPOLYGON_HH
#define VTKPOLYGON_HH

#include <string>
#include <list>

#include "vtkRenderer.h"
#include "ChipsPolygon.hh"

#include "vtkPolygonDataActor2DExtra.hh"

#ifndef HEADLESS
class vtkChipsPointWidget;
#endif
class vtkDataArray;

using namespace std;

class VtkPolygon: public ChipsPolygon
{
public:

  VtkPolygon(vtkRenderer* inRenderer,ChipsObject* par, 
	     ChipsCoordinate *inCoord, COORD_SYS coord_sys,
	     double* xcoords, double* ycoords, unsigned int cnt, string val);

  VtkPolygon(vtkRenderer* inRenderer,ChipsObject* par, 
	       ChipsCoordinate *inCoord, COORD_SYS coord_sys,
             int sides, double xcoord, double ycoord, double radius, 
	     string val);
  
  VtkPolygon(vtkRenderer* inRenderer, ChipsObject* par, 
             ChipsCoordinate *inCoord, COORD_SYS coord_sys,
             ChipsStateStream& in);


  virtual ~VtkPolygon();

  virtual int change_depth ();
  virtual int change_thickness(); 
  virtual int change_linestyle(); 
  virtual int change_fillstyle();
  virtual int change_color();
  virtual int change_opacity();
  virtual int change_fillcolor();

  virtual int change_position();

  virtual int change_rotation(); 


  virtual int change_visible(); 

  virtual int update_data();

  virtual void select ();
  virtual void unselect ();

  virtual void disable_interaction ();
  virtual void enable_interaction ();

  virtual int update_clipping ();

protected:


private:
  VtkPolygon(const VtkPolygon& inCurve);
  void adjust_plotlimits(const string& inXAxisId,
			 const string& inYAxisId);


  void setup_polygondata();
  int calculate_points (vtkDataArray *points) ;

  void set_clip_bounds ();

  vtkRenderer* renderer;


  vtkPolygonDataActor2DExtra* polygonActor;

#ifndef HEADLESS
  vtkChipsPointWidget *polygon_widget;
#endif


  ChipsVector lower_bounds_norm;
  ChipsVector upper_bounds_norm;

  bool scale[2];


};





#endif
