#include "VtkGtkWindow.hh"
#include "ChipsDefines.hh"

#include "vtkGtkRenderWindowInteractor.hh"
#include "vtkInteractorStyleChips.hh"

#include <vtkRenderWindow.h>
#include <vtkRenderWindowInteractor.h>
#include <vtkRenderer.h>
#include <vtkInteractorStyle.h>
#include <vtkVersion.h>
#include <vtkCommand.h>
#include <vtkRenderedAreaPicker.h>

#include <gdk/gdkkeysyms.h>


//#define DEBUG


VtkGtkWindow::VtkGtkWindow (vtkRenderWindow *render_window, ChipsWindow *parent, string geom, bool focus) :
   ChipsGtkWindow (parent, geom, focus)
{
   this->render_interactor = vtkGtkRenderWindowInteractor::New ();
   this->interactor_style = vtkInteractorStyleChips::New ();
   this->render_interactor->SetInteractorStyle (this->interactor_style);

   this->render_interactor->SetWindow (this->window);
   this->render_interactor->SetDrawingArea (this->drawing_area);
   this->render_interactor->SetRenderWindow (render_window);

   vtkRenderedAreaPicker *area_picker = vtkRenderedAreaPicker::New ();
   this->render_interactor->SetPicker (area_picker);
   area_picker->Delete ();

   this->ctrl = 0;
   this->shift = 0;
}

VtkGtkWindow::~VtkGtkWindow ()
{
   this->render_interactor->Delete ();
}

void VtkGtkWindow::set_render_window (vtkRenderWindow *render_window)
{
  this->render_interactor->SetRenderWindow (render_window);
/*  if (render_window != NULL)
    this->render_interactor->ReInitialize ();
*/
}

