// 
//  Copyright (C) 2004-2007  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef VTKGTKWINDOW_HH
#define VTKGTKWINDOW_HH

#include "ChipsGtkWindow.hh"


class vtkGtkRenderWindowInteractor;
class vtkInteractorStyleChips;
class vtkRenderWindow;
class ChipsWindow;

class VtkGtkWindow :  public ChipsGtkWindow
{
   public:
      VtkGtkWindow (vtkRenderWindow *render_window, ChipsWindow *parent, string geom="", bool focus=FALSE);
      virtual ~VtkGtkWindow ();

      void set_render_window (vtkRenderWindow *render_window);

      inline void set_shift (int value) { this->shift = value; }; 
      inline int get_shift () { return this->shift; };
      inline void set_ctrl (int value) { this->ctrl = value; };
      inline int get_ctrl () { return this->ctrl; };
      
      inline vtkGtkRenderWindowInteractor *get_render_interactor () { return this->render_interactor; };

   protected:
      vtkGtkRenderWindowInteractor *render_interactor;
      vtkInteractorStyleChips *interactor_style;

      int shift;
      int ctrl;

};

#endif
