#include "vtkAxisRepresentation.hh"
#include "vtkAxisActor2DExtra.hh"

#include "vtkRenderedAreaPicker.h"
#include "vtkObjectFactory.h"
#include "vtkRenderer.h"
#include "vtkTransform.h"
#include "vtkAssemblyPath.h"
#include "vtkProp3DCollection.h"

#include <float.h>


vtkStandardNewMacro(vtkAxisRepresentation);

//-------------------------------------------------------------------------
vtkAxisRepresentation::vtkAxisRepresentation()
{
}

//-------------------------------------------------------------------------
vtkAxisRepresentation::~vtkAxisRepresentation()
{
}


//-------------------------------------------------------------------------
void vtkAxisRepresentation::NegotiateLayout()
{
  vtkAxisActor2DExtra* AxisActor = reinterpret_cast<vtkAxisActor2DExtra*>(this->PickProp);
  if (!AxisActor)
    return;

//  AxisActor->BuildData (this->Renderer);

  double *pos1 = AxisActor->GetPositionCoordinate ()->GetComputedDoubleViewportValue(this->Renderer);
  double *pos2 = AxisActor->GetPosition2Coordinate ()->GetComputedDoubleViewportValue(this->Renderer);

/*
  double clipBounds[4];

  if (AxisActor->GetClipData ())
    {
    AxisActor->GetClipBounds (clipBounds);
    vtkCoordinate *clipCoordinate1 = vtkCoordinate::New ();
    vtkCoordinate *clipCoordinate2 = vtkCoordinate::New ();
    double *clipPos1;
    double *clipPos2;

    clipCoordinate1->SetCoordinateSystem (AxisActor->GetPositionCoordinate ()->GetCoordinateSystem ());
    clipCoordinate2->SetCoordinateSystem (AxisActor->GetPositionCoordinate ()->GetCoordinateSystem ());
    clipCoordinate1->SetValue (clipBounds[0], clipBounds[1]);
    clipCoordinate2->SetValue (clipBounds[2], clipBounds[3]);

    clipPos1 = clipCoordinate1->GetComputedDoubleViewportValue(this->Renderer);
    clipPos2 = clipCoordinate2->GetComputedDoubleViewportValue(this->Renderer);

    if (clipPos1[0] > pos1[0])
      pos1[0] = clipPos1[0];
    if (clipPos1[1] > pos1[1])
      pos1[1] = clipPos1[1];

    if (clipPos1[0] > pos2[0])
      pos2[0] = clipPos1[0];
    if (clipPos1[1] > pos2[1])
      pos2[1] = clipPos1[1];

    if (clipPos2[0] < pos2[0])
      pos2[0] = clipPos2[0];
    if (clipPos2[1] < pos2[1])
      pos2[1] = clipPos2[1];

    if (clipPos2[0] < pos1[0])
      pos1[0] = clipPos2[0];
    if (clipPos2[1] < pos1[1])
      pos1[1] = clipPos2[1];
    }
*/

  this->PositionCoordinate->SetCoordinateSystemToViewport ();
  this->PositionCoordinate->SetValue(pos1[0], pos1[1]);
  this->Position2Coordinate->SetCoordinateSystemToViewport ();
  this->Position2Coordinate->SetValue(pos2[0]-pos1[0], pos2[1]-pos1[1]);

}

void vtkAxisRepresentation::SetAxisActor (vtkAxisActor2DExtra *actor)
{
  this->SetPickProp (actor);
}

vtkAxisActor2DExtra * vtkAxisRepresentation::GetAxisActor ()
{
  return reinterpret_cast<vtkAxisActor2DExtra*>(this->GetPickProp ());
}
  
void vtkAxisRepresentation::PrintSelf(ostream& os, vtkIndent indent)
{
  this->Superclass::PrintSelf(os,indent);
}


