

#ifndef __vtkChipsPickableRepresentation_h
#define __vtkChipsPickableRepresentation_h

#include "vtkChipsRepresentation.hh"
#include "vtkCoordinate.h" //Because of the viewport coordinate macro
#include "vtkProp.h"


class VTK_WIDGETS_EXPORT vtkChipsPickableRepresentation : public vtkChipsRepresentation
{
public:
  // Description:
  // Instantiate this class.
  static vtkChipsPickableRepresentation *New();

  // Description:
  // Define standard methods.
  vtkTypeMacro(vtkChipsPickableRepresentation,vtkChipsRepresentation);
  void PrintSelf(ostream& os, vtkIndent indent);

  // Description:
  // Set/Get Representation prop
  vtkSetObjectMacro (PickProp, vtkProp);
  vtkGetObjectMacro (PickProp, vtkProp);


  // Description:
  // Specify the pick path
  void SetPickPath (vtkAssemblyPath* path);

  // Description:
  // Subclasses should implement these methods. See the superclasses'
  // documentation for more information.
  virtual int ComputeInteractionState(int X, int Y, int modify=0);

protected:
  vtkChipsPickableRepresentation();
  ~vtkChipsPickableRepresentation();

  vtkProp                    *PickProp;
  vtkAssemblyPath            *PickPath;
  bool PropPicked;
  
private:
  vtkChipsPickableRepresentation(const vtkChipsPickableRepresentation&);  //Not implemented
  void operator=(const vtkChipsPickableRepresentation&);  //Not implemented
};

#endif
