// 
//  Copyright (C) 2004-2009  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#include "vtkChipsPickableWidget.hh"
#include "vtkChipsWidgetEvent.hh"
#include "vtkCommand.h"
#include "vtkWidgetEventTranslator.h"
#include "vtkObjectFactory.h"
#include "vtkAbstractPropPicker.h"
#include "vtkRenderWindowInteractor.h"

#include "vtkChipsPickableRepresentation.hh"


vtkStandardNewMacro(vtkChipsPickableWidget);


//-------------------------------------------------------------------------
vtkChipsPickableWidget::vtkChipsPickableWidget()
{
  vtkWidgetEventTranslator *translator = this->GetEventTranslator ();
  translator->SetTranslation (vtkCommand::EndPickEvent, vtkChipsWidgetEvent::Move);
  translator->RemoveTranslation (vtkCommand::MouseMoveEvent);
}

//-------------------------------------------------------------------------
vtkChipsPickableWidget::~vtkChipsPickableWidget()
{
}

//-------------------------------------------------------------------------
int vtkChipsPickableWidget::SubclassMoveAction()
{
  vtkChipsPickableRepresentation *chipsRep = reinterpret_cast<vtkChipsPickableRepresentation*>(this->WidgetRep);

  if ( this->WidgetState != vtkChipsWidget::Modify)
    {

    vtkAbstractPropPicker *picker =
           vtkAbstractPropPicker::SafeDownCast(this->Interactor->GetPicker());

    if (picker)
      {
      vtkAssemblyPath *path = picker->GetPath();
      chipsRep->SetPickPath (path);
      }
    }

  return 0;
}


    

//-------------------------------------------------------------------------
void vtkChipsPickableWidget::PrintSelf(ostream& os, vtkIndent indent)
{
  this->Superclass::PrintSelf(os,indent);
}

