// 
//  Copyright (C) 2004-2009  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef __vtkChipsPlotWidget_h
#define __vtkChipsPlotWidget_h

#include "vtkChipsWidget.hh"

class VTK_WIDGETS_EXPORT vtkChipsPlotWidget : public vtkChipsWidget
{
public:
  // Description:
  // Method to instantiate class.
  static vtkChipsPlotWidget *New();

  // Description;
  // Standard methods for class.
  vtkTypeMacro(vtkChipsPlotWidget,vtkChipsWidget);
  void PrintSelf(ostream& os, vtkIndent indent);

protected:
  vtkChipsPlotWidget();
  ~vtkChipsPlotWidget();

  virtual int SubclassSelectAction ();
  virtual int SubclassMoveAction();
  virtual int SubclassEndSelectAction();

  // helper methods for cursoe management
  virtual void SetCursor(int State);

  // helper to finalize selection
  virtual void FinalizeSelect ();

private:
  vtkChipsPlotWidget(const vtkChipsPlotWidget&);  //Not implemented
  void operator=(const vtkChipsPlotWidget&);  //Not implemented

  bool edgeSelect;
};

#endif
