// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef __vtkChipsPointRepresentation_h
#define __vtkChipsPointRepresentation_h

#include "vtkChipsPickableRepresentation.hh"
#include "vtkGlyphSource2D.h"


class VTK_WIDGETS_EXPORT vtkChipsPointRepresentation : public vtkChipsPickableRepresentation 
{
public:

  // Description:
  // Instantiate this class.
  static vtkChipsPointRepresentation *New();

  // Description:
  // Define standard methods.
  vtkTypeMacro(vtkChipsPointRepresentation,vtkChipsPickableRepresentation);
  void PrintSelf(ostream& os, vtkIndent indent);

  // Description:
  // Set/Get Text Actor 
  vtkSetObjectMacro (GlyphSource, vtkGlyphSource2D);
  vtkGetObjectMacro (GlyphSource, vtkGlyphSource2D);

  // Description:
  // Set/Get Text Actor
  vtkSetMacro (AngleOffset, float);
  vtkGetMacro (AngleOffset, float);


  virtual void WidgetInteraction(double eventPos[2]);

  virtual void NegotiateLayout();

  virtual void SetRotating (bool rotate);





protected:

  vtkChipsPointRepresentation();
  ~vtkChipsPointRepresentation();


private:
  vtkChipsPointRepresentation(const vtkChipsPointRepresentation&);  //Not implemented
  void operator=(const vtkChipsPointRepresentation&);  //Not implemented

  vtkGlyphSource2D        *GlyphSource;
  float                   AngleOffset;

};

#endif



