// 
//  Copyright (C) 2004-2009  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef __vtkChipsScalarBarWidget_h
#define __vtkChipsScalarBarWidget_h

#include "vtkChipsPickableWidget.hh"

class VTK_WIDGETS_EXPORT vtkChipsScalarBarWidget : public vtkChipsPickableWidget
{
public:
  // Description:
  // Method to instantiate class.
  static vtkChipsScalarBarWidget *New();

  // Description;
  // Standard methods for class.
  vtkTypeMacro(vtkChipsScalarBarWidget,vtkChipsPickableWidget);
  void PrintSelf(ostream& os, vtkIndent indent);

protected:
  vtkChipsScalarBarWidget();
  ~vtkChipsScalarBarWidget();

  virtual int SubclassEndSelectAction();
  virtual int SubclassMoveAction();


private:
  vtkChipsScalarBarWidget(const vtkChipsScalarBarWidget&);  //Not implemented
  void operator=(const vtkChipsScalarBarWidget&);  //Not implemented
};

#endif
