
#ifndef __vtkChipsWidgetEvent_h
#define __vtkChipsWidgetEvent_h

#include "vtkWidgetEvent.h"

// The superclass that all commands should be subclasses of
class VTK_COMMON_EXPORT vtkChipsWidgetEvent : public vtkWidgetEvent
{
public:

  // Description:
  // The object factory constructor.
  static vtkChipsWidgetEvent *New() ;

  // Description:
  // Standard macros.
  vtkTypeMacro(vtkChipsWidgetEvent,vtkWidgetEvent);
  void PrintSelf(ostream& os, vtkIndent indent);


//BTX
  // Description:
  // All the currently defined events are listed here.  Developers can
  // use -- vtkChipsWidgetEvent::UserEvent + int to specify their own event
  // ids. If this list is adjusted, be sure to adjust
  // vtkChipsWidgetEventEventStrings in vtkChipsWidgetEvent.cxx to match.
  enum ChipsWidgetEventIds {
    NoEvent = 0,
    Select,
    EndSelect,
    DoubleClickSelect,
    RightSelect,
    EndRightSelect,
    Resize,
    EndResize,
    Move,
    KeyPressed,
    KeyReleased,
    Pick,
    Add,
    EndAdd
  };
//ETX

protected:
  vtkChipsWidgetEvent() {}
  virtual ~vtkChipsWidgetEvent() {}

private:
//BTX
  vtkChipsWidgetEvent(const vtkChipsWidgetEvent& );
  void operator=(const vtkChipsWidgetEvent&);
//ETX
};

#endif /* __vtkChipsWidgetEvent_h */
 
