#include "vtkHistogramDataRepresentation.hh"
#include "vtkHistogramDataListActor2DExtra.hh"

#include "vtkRenderedAreaPicker.h"
#include "vtkObjectFactory.h"
#include "vtkRenderer.h"
#include "vtkTransform.h"
#include "vtkAssemblyPath.h"
#include "vtkProp3DCollection.h"

#include <float.h>


vtkStandardNewMacro(vtkHistogramDataRepresentation);

//-------------------------------------------------------------------------
vtkHistogramDataRepresentation::vtkHistogramDataRepresentation()
{
}

//-------------------------------------------------------------------------
vtkHistogramDataRepresentation::~vtkHistogramDataRepresentation()
{
}


//-------------------------------------------------------------------------
void vtkHistogramDataRepresentation::NegotiateLayout()
{
  vtkHistogramDataListActor2DExtra* HistogramDataActor = reinterpret_cast<vtkHistogramDataListActor2DExtra*>(this->PickProp);
  if (!HistogramDataActor)
    return;

  double bounds[4];
  int clipBounds[4];

  HistogramDataActor->GetBounds (this->Renderer, bounds);
  HistogramDataActor->GetClipPlanes (clipBounds[0], clipBounds[1],clipBounds[2],clipBounds[3]);

  if (clipBounds[0] > bounds[0])
    bounds[0] = clipBounds[0];
  if (clipBounds[0] > bounds[1])
    bounds[2] = clipBounds[0];

  if (clipBounds[1] < bounds[0])
    bounds[0] = clipBounds[1];
  if (clipBounds[1] < bounds[1])
    bounds[1] = clipBounds[1];

  if (clipBounds[2] > bounds[2])
    bounds[2] = clipBounds[2];
  if (clipBounds[2] > bounds[3])
    bounds[3] = clipBounds[2];

  if (clipBounds[3] < bounds[2])
    bounds[2] = clipBounds[3];
  if (clipBounds[3] < bounds[3])
    bounds[3] = clipBounds[3];

  
  this->PositionCoordinate->SetCoordinateSystemToViewport ();
  this->PositionCoordinate->SetValue(bounds[0], bounds[2]);
  this->Position2Coordinate->SetCoordinateSystemToViewport ();
  this->Position2Coordinate->SetValue(bounds[1]-bounds[0], bounds[3]-bounds[2]);

}

void vtkHistogramDataRepresentation::SetHistogramDataActor (vtkHistogramDataListActor2DExtra *actor)
{
  this->SetPickProp (actor);
}

vtkHistogramDataListActor2DExtra * vtkHistogramDataRepresentation::GetHistogramDataActor ()
{
  return reinterpret_cast<vtkHistogramDataListActor2DExtra*>(this->GetPickProp ());
}
  
void vtkHistogramDataRepresentation::PrintSelf(ostream& os, vtkIndent indent)
{
  this->Superclass::PrintSelf(os,indent);
}


