// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef __vtkHistogramDataRepresentation_h
#define __vtkHistogramDataRepresentation_h

#include "vtkChipsPickableRepresentation.hh"

class vtkHistogramDataListActor2DExtra;

class VTK_WIDGETS_EXPORT vtkHistogramDataRepresentation : public vtkChipsPickableRepresentation 
{
public:

  // Description:
  // Instantiate this class.
  static vtkHistogramDataRepresentation *New();

  // Description:
  // Define standard methods.
  vtkTypeMacro(vtkHistogramDataRepresentation,vtkChipsPickableRepresentation);
  void PrintSelf(ostream& os, vtkIndent indent);

  // Description:
  // Set/Get the associated vtkHistogramDataActor
  void SetHistogramDataActor (vtkHistogramDataListActor2DExtra *actor);
  vtkHistogramDataListActor2DExtra * GetHistogramDataActor ();

  virtual void NegotiateLayout();


protected:

  vtkHistogramDataRepresentation();
  ~vtkHistogramDataRepresentation();


private:
  vtkHistogramDataRepresentation(const vtkHistogramDataRepresentation&);  //Not implemented
  void operator=(const vtkHistogramDataRepresentation&);  //Not implemented

};

#endif



