#include "vtkPlotContourRepresentation.hh"
#include "vtkPlotContourActor2DExtra.hh"

#include "vtkRenderedAreaPicker.h"
#include "vtkObjectFactory.h"
#include "vtkRenderer.h"
#include "vtkTransform.h"
#include "vtkAssemblyPath.h"
#include "vtkProp3DCollection.h"

#include <float.h>


vtkStandardNewMacro(vtkPlotContourRepresentation);

//-------------------------------------------------------------------------
vtkPlotContourRepresentation::vtkPlotContourRepresentation()
{
}

//-------------------------------------------------------------------------
vtkPlotContourRepresentation::~vtkPlotContourRepresentation()
{
}


//-------------------------------------------------------------------------
void vtkPlotContourRepresentation::NegotiateLayout()
{
  vtkPlotContourActor2DExtra* PlotContourActor = reinterpret_cast<vtkPlotContourActor2DExtra*>(this->PickProp);
  if (!PlotContourActor)
    return;

  double bounds[4];
  int clipBounds[4];

  PlotContourActor->GetBounds (this->Renderer, bounds);
  PlotContourActor->GetClipPlanes (clipBounds[0], clipBounds[1],clipBounds[2],clipBounds[3]);

  if (clipBounds[0] > bounds[0])
    bounds[0] = clipBounds[0];
  if (clipBounds[0] > bounds[1])
    bounds[2] = clipBounds[0];

  if (clipBounds[1] < bounds[0])
    bounds[0] = clipBounds[1];
  if (clipBounds[1] < bounds[1])
    bounds[1] = clipBounds[1];

  if (clipBounds[2] > bounds[2])
    bounds[2] = clipBounds[2];
  if (clipBounds[2] > bounds[3])
    bounds[3] = clipBounds[2];

  if (clipBounds[3] < bounds[2])
    bounds[2] = clipBounds[3];
  if (clipBounds[3] < bounds[3])
    bounds[3] = clipBounds[3];
  
  this->PositionCoordinate->SetCoordinateSystemToViewport ();
  this->PositionCoordinate->SetValue(bounds[0], bounds[2]);
  this->Position2Coordinate->SetCoordinateSystemToViewport ();
  this->Position2Coordinate->SetValue(bounds[1]-bounds[0], bounds[3]-bounds[2]);

}

void vtkPlotContourRepresentation::SetPlotContourActor (vtkPlotContourActor2DExtra *actor)
{
  this->SetPickProp (actor);
}

vtkPlotContourActor2DExtra * vtkPlotContourRepresentation::GetPlotContourActor ()
{
  return reinterpret_cast<vtkPlotContourActor2DExtra*>(this->GetPickProp ());
}
  
void vtkPlotContourRepresentation::PrintSelf(ostream& os, vtkIndent indent)
{
  this->Superclass::PrintSelf(os,indent);
}


