// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef __vtkPlotContourRepresentation_h
#define __vtkPlotContourRepresentation_h

#include "vtkChipsPickableRepresentation.hh"

class vtkPlotContourActor2DExtra;

class VTK_WIDGETS_EXPORT vtkPlotContourRepresentation : public vtkChipsPickableRepresentation 
{
public:

  // Description:
  // Instantiate this class.
  static vtkPlotContourRepresentation *New();

  // Description:
  // Define standard methods.
  vtkTypeMacro(vtkPlotContourRepresentation,vtkChipsPickableRepresentation);
  void PrintSelf(ostream& os, vtkIndent indent);

  // Description:
  // Set/Get the associated vtkPlotContourActor
  void SetPlotContourActor (vtkPlotContourActor2DExtra *actor);
  vtkPlotContourActor2DExtra * GetPlotContourActor ();

  virtual void NegotiateLayout();


protected:

  vtkPlotContourRepresentation();
  ~vtkPlotContourRepresentation();


private:
  vtkPlotContourRepresentation(const vtkPlotContourRepresentation&);  //Not implemented
  void operator=(const vtkPlotContourRepresentation&);  //Not implemented

};

#endif



