#include "vtkPlotDataRepresentation.hh"
#include "vtkPlotDataListActor2DExtra.hh"

#include "vtkRenderedAreaPicker.h"
#include "vtkObjectFactory.h"
#include "vtkRenderer.h"
#include "vtkTransform.h"
#include "vtkAssemblyPath.h"
#include "vtkProp3DCollection.h"

#include <float.h>


vtkStandardNewMacro(vtkPlotDataRepresentation);

//-------------------------------------------------------------------------
vtkPlotDataRepresentation::vtkPlotDataRepresentation()
{
}

//-------------------------------------------------------------------------
vtkPlotDataRepresentation::~vtkPlotDataRepresentation()
{
}


//-------------------------------------------------------------------------
void vtkPlotDataRepresentation::NegotiateLayout()
{
  vtkPlotDataListActor2DExtra* PlotDataActor = reinterpret_cast<vtkPlotDataListActor2DExtra*>(this->PickProp);
  if (!PlotDataActor)
    return;

  double bounds[4];
  int clipBounds[4];

  PlotDataActor->GetBounds (this->Renderer, bounds);
  PlotDataActor->GetClipPlanes (clipBounds[0], clipBounds[1],clipBounds[2],clipBounds[3]);

  if (clipBounds[0] > bounds[0])
    bounds[0] = clipBounds[0];
  if (clipBounds[0] > bounds[1])
    bounds[2] = clipBounds[0];

  if (clipBounds[1] < bounds[0])
    bounds[0] = clipBounds[1];
  if (clipBounds[1] < bounds[1])
    bounds[1] = clipBounds[1];

  if (clipBounds[2] > bounds[2])
    bounds[2] = clipBounds[2];
  if (clipBounds[2] > bounds[3])
    bounds[3] = clipBounds[2];

  if (clipBounds[3] < bounds[2])
    bounds[2] = clipBounds[3];
  if (clipBounds[3] < bounds[3])
    bounds[3] = clipBounds[3];

  this->PositionCoordinate->SetCoordinateSystemToViewport ();
  this->PositionCoordinate->SetValue(bounds[0], bounds[2]);
  this->Position2Coordinate->SetCoordinateSystemToViewport ();
  this->Position2Coordinate->SetValue(bounds[1]-bounds[0], bounds[3]-bounds[2]);

}

void vtkPlotDataRepresentation::SetPlotDataActor (vtkPlotDataListActor2DExtra *actor)
{
  this->SetPickProp (actor);
}

vtkPlotDataListActor2DExtra * vtkPlotDataRepresentation::GetPlotDataActor ()
{
  return reinterpret_cast<vtkPlotDataListActor2DExtra*>(this->GetPickProp ());
}
  
void vtkPlotDataRepresentation::PrintSelf(ostream& os, vtkIndent indent)
{
  this->Superclass::PrintSelf(os,indent);
}


