#include "vtkPolyLineRepresentation.hh"
#include "vtkPolyLineActor2DExtra.hh"

#include "vtkRenderedAreaPicker.h"
#include "vtkObjectFactory.h"
#include "vtkRenderer.h"
#include "vtkTransform.h"
#include "vtkAssemblyPath.h"
#include "vtkProp3DCollection.h"

#include <float.h>


vtkStandardNewMacro(vtkPolyLineRepresentation);

//-------------------------------------------------------------------------
vtkPolyLineRepresentation::vtkPolyLineRepresentation()
{
}

//-------------------------------------------------------------------------
vtkPolyLineRepresentation::~vtkPolyLineRepresentation()
{
}


//-------------------------------------------------------------------------
void vtkPolyLineRepresentation::NegotiateLayout()
{
  vtkPolyLineActor2DExtra* LineActor = reinterpret_cast<vtkPolyLineActor2DExtra*>(this->PickProp);
  if (!LineActor)
    return;

  double x[2] = {0,0};
  double y[2] = {0,0};

  LineActor->BuildData (this->Renderer);

  LineActor->GetXClippedRange (x);
  LineActor->GetYClippedRange (y);

  this->PositionCoordinate->SetCoordinateSystemToViewport();
  this->PositionCoordinate->SetValue(x[0], y[0]);
  this->Position2Coordinate->SetCoordinateSystemToViewport();
  this->Position2Coordinate->SetValue(x[1]-x[0], y[1]-y[0]);

}

void vtkPolyLineRepresentation::SetLineActor (vtkPolyLineActor2DExtra *actor)
{
  this->SetPickProp (actor);
}

vtkPolyLineActor2DExtra * vtkPolyLineRepresentation::GetLineActor ()
{
  return reinterpret_cast<vtkPolyLineActor2DExtra*>(this->GetPickProp ());
}
  
void vtkPolyLineRepresentation::PrintSelf(ostream& os, vtkIndent indent)
{
  this->Superclass::PrintSelf(os,indent);
}


