// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef __vtkPolyLineRepresentation_h
#define __vtkPolyLineRepresentation_h

#include "vtkChipsPickableRepresentation.hh"

class vtkPolyLineActor2DExtra;

class VTK_WIDGETS_EXPORT vtkPolyLineRepresentation : public vtkChipsPickableRepresentation 
{
public:

  // Description:
  // Instantiate this class.
  static vtkPolyLineRepresentation *New();

  // Description:
  // Define standard methods.
  vtkTypeMacro(vtkPolyLineRepresentation,vtkChipsPickableRepresentation);
  void PrintSelf(ostream& os, vtkIndent indent);

  // Description:
  // Set/Get the associated vtkLineActor
  void SetLineActor (vtkPolyLineActor2DExtra *actor);
  vtkPolyLineActor2DExtra * GetLineActor ();

  virtual void NegotiateLayout();


protected:

  vtkPolyLineRepresentation();
  ~vtkPolyLineRepresentation();


private:
  vtkPolyLineRepresentation(const vtkPolyLineRepresentation&);  //Not implemented
  void operator=(const vtkPolyLineRepresentation&);  //Not implemented

};

#endif



