// 
//  Copyright (C) 2011  Smithsonian Astrophysical Observatory
//
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//


#ifndef __vtkPolygonRepresentation_h
#define __vtkPolygonRepresentation_h

#include "vtkChipsPickableRepresentation.hh"

class vtkPolygonDataActor2DExtra;

class VTK_WIDGETS_EXPORT vtkPolygonRepresentation : public vtkChipsPickableRepresentation 
{
public:

  // Description:
  // Instantiate this class.
  static vtkPolygonRepresentation *New();

  // Description:
  // Define standard methods.
  vtkTypeMacro(vtkPolygonRepresentation,vtkChipsPickableRepresentation);
  void PrintSelf(ostream& os, vtkIndent indent);

  // Description:
  // Set/Get the associated vtkPolygonActor
  void SetPolygonActor (vtkPolygonDataActor2DExtra *actor);
  vtkPolygonDataActor2DExtra * GetPolygonActor ();

  virtual void WidgetInteraction(double eventPos[2]);

  virtual void NegotiateLayout();


protected:

  vtkPolygonRepresentation();
  ~vtkPolygonRepresentation();


private:
  vtkPolygonRepresentation(const vtkPolygonRepresentation&);  //Not implemented
  void operator=(const vtkPolygonRepresentation&);  //Not implemented

};

#endif



