#ifndef    __FTFontExtra__
#define    __FTFontExtra__


#include <vtk_freetype.h>
#include FT_FREETYPE_H

#include "FTGL.h"
#include "FTFace.h"


#include "FTFont.h"

#ifdef FTGL_USE_NAMESPACE
namespace ftgl
{
#endif


class FTGlyphContainer;
class FTGlyph;


class FTGL_EXPORT FTFontExtra : public FTFont
{
public:
  
  FTFontExtra();
  
  virtual ~FTFontExtra();
  
  
  virtual void renderExtra(double inAngleRad,const char* string, 
			   const FTGLRenderContext *context = 0);
  
  
  virtual void renderExtra(double inAngleRad,const wchar_t* string, 
			   const FTGLRenderContext *context = 0);
  
  float Advance(const char* string);

  float Advance(const wchar_t* string);
  
  void BBox( const char* string,
	     float& llx, float& lly, 
	     float& llz, float& urx, float& ury, float& urz);
  
  void BBox( const wchar_t* string,
	     float& llx, float& lly, 
	     float& llz, float& urx, float& ury, float& urz);

  float ItalicAngle();

protected:
  
  void doRenderExtra( const unsigned int chr, 
		      const unsigned int nextChr, 
		      const FTGLRenderContext *context = 0);
  
  double angleRad;
private:
  double tmpPen[2];
};

#ifdef FTGL_USE_NAMESPACE
} // namespace ftgl
#endif

#endif  //  __FTFontExtra__

