#include <math.h>
#include  "FTGLBitmapFontExtra.hh"
#include  "FTBitmapGlyph.h"
#ifdef FTGL_DEBUG
  #include "mmgr.h"
#endif

#ifdef FTGL_USE_NAMESPACE
namespace ftgl
{
#endif


FTGLBitmapFontExtra::FTGLBitmapFontExtra()
{}


FTGLBitmapFontExtra::~FTGLBitmapFontExtra()
{}


FTGlyph* FTGLBitmapFontExtra::MakeGlyph( unsigned int g)
{

  FT_Matrix matrix;
  matrix.xx = (FT_Fixed)( cos(angleRad) * 0x10000L);
  matrix.xy = (FT_Fixed)(-sin(angleRad) * 0x10000L);
  matrix.yx = (FT_Fixed)( sin(angleRad) * 0x10000L);
  matrix.yy = (FT_Fixed)( cos(angleRad) * 0x10000L);

  
  FT_Set_Transform(*face.Face(),&matrix,0);



  FT_Glyph* ftGlyph = face.Glyph( g, FT_LOAD_RENDER);

  if( ftGlyph)
  {
    FTBitmapGlyph* tempGlyph = new FTBitmapGlyph( *ftGlyph);
//                FT_Done_Glyph( *ftGlyph );

    return tempGlyph;
  }

  err = face.Error();
  return NULL;
}


void FTGLBitmapFontExtra::render(const char* string,
                            const FTGLRenderContext *context)

{  
#ifdef FTGL_SUPPORT_MANGLE_MESA
  if (context && context->UseMangleMesa)
    {
    this->RenderMesa(string, context);
    }
  else
#endif
    {
    this->RenderOpenGL(string, context);
    }
}


void FTGLBitmapFontExtra::render(const wchar_t* string,
                            const FTGLRenderContext *context)

{  
#ifdef FTGL_SUPPORT_MANGLE_MESA
  if (context && context->UseMangleMesa)
    {
    this->RenderMesa(string, context);
    }
  else
#endif
    {
    this->RenderOpenGL(string, context);
    }
}

#ifdef FTGL_USE_NAMESPACE
} // namespace ftgl
#endif
